#!/system/bin/sh
#
# V6 SuperCharger Update 9 RC12 by -=zeppelinrox=-
#
# When using scripting tricks, ideas, or code snippets from here, please give proper credit.
# There are many things may look simple, but actually took a lot of time, trial, and error to get perfected.
#
# This script can be used freely and can even be modified for PERSONAL USE ONLY.
# It can be freely incorporated into ROMs - provided that proper credit is given WITH a link back to the XDA SuperCharger thread.
# If you want to share it or make a thread about it, just provide a link to the main thread.
#      - This ensures that users will always be getting the latest versions.
# Prohibited: Any modification (excluding personal use), repackaging, redistribution, or mirrors of my work are NOT PERMITTED.
# Thanks, zeppelinrox.
#
# V6 SuperCharger, OOM Grouping & Priority Fixes created by zeppelinrox.
# SuperMinFree Calculator & MFK Calculator (for min_free_kbytes) created by zeppelinrox also ;^]
# Entropy-ness Enlarger (sysctl tweak for kernel.random.read_wakeup_threshold that keeps entropy_avail full) discovered by zeppelinrox.
#
# See http://goo.gl/qM6yR - SuperCharger thread at XDA
# See http://goo.gl/IvGL1 - Ultimatic Jar Patcher Tools thread at XDA for more Goodness and MultiTasking!
#                           ie. Patch services.jar for ICS and above to get 100% SuperCharged with "Jelly ISCream"
#                               Patch services.jar for ALL ROMS (Froyo and above) and get "Maximum MultiTasking Mods"
#                               Patch services.jar for Sense 4 and above ROMS (Not needed for Sense 3.6 and below) and get a "Non-Sense App Limit"
#
# See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article!
# See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why 'Free RAM' Is NOT Wasted RAM!"
# See http://goo.gl/4w0ba - MFK Calculator Info - explanation for vm.min_free_kbytes.
# See http://goo.gl/P8Bvu - How Entropy-ness Enlarger works.
# See http://goo.gl/Zc85j - Possible reasons why it may actually do something :p
#
# For Debugging: Delete the # at the beginning of the next line and watch the output on the next run!
# set -x
#
if [ ! -d "/data/local/busybox*/xbin" ]; then export PATH=$PATH:/system/xbin:/sbin:/vendor/bin:/system/sbin:/system/bin
else export PATH=$PATH:/system/xbin:/sbin:/vendor/bin:/system/sbin:/system/bin:`ls -d /data/local/busybox*/xbin 2>/dev/null`
fi 2>/dev/null
line=================================================
echo ""
echo $line
echo " NOTE: BUSYBOX v1.16.2 OR HIGHER IS RECOMMENDED!"
echo $line
sleep 2
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
mount -o remount,rw / 2>/dev/null
mount -o remount,rw rootfs 2>/dev/null
busybox mount -o remount,rw / 2>/dev/null
busybox mount -o remount,rw rootfs 2>/dev/null
if [ -d "/sqlite_stmt_journals" ]; then madesqlitefolder=0
else mkdir /sqlite_stmt_journals; madesqlitefolder=1
fi
if [ "`ls $EXTERNAL_STORAGE`" ]; then storage=${EXTERNAL_STORAGE#*mnt}
elif [ "`ls $EXTERNAL_STORAGE2`" ]; then storage=${EXTERNAL_STORAGE2#*mnt}
elif [ "`ls $USBHOST_STORAGE`" ]; then storage=${USBHOST_STORAGE#*mnt}
elif [ "`ls $SECONDARY_STORAGE`" ]; then storage=${SECONDARY_STORAGE#*mnt}
elif [ "`ls $PHONE_STORAGE`" ]; then storage=${PHONE_STORAGE#*mnt}
else storage="/sdcard"
fi 2>/dev/null
cat > $storage/!SuperCharger.html <<EOF
<br>
<br>
<i><u><b>The -=V6 SuperCharger=-</b></u> created by -=zeppelinrox=-</i><br>
<br>
<u><b>Owner's Guide</b></u><br>
<br>
Hi! I hope that the V6 SuperCharger script is working well for you!<br>
<br>
<b>Did this file just auto load?</b> If so, there are 3 reasons why this could happen:<br>
1. You're <u>not</u> 100% SuperCharged and minfrees <u>don't match</u>! If this is the case, <u><b>READ</b></u> this entire help file - <u><b>BEFORE</b></u> asking redundant questions!</u><br>
2. You set Wheel Alignment to run on boot but you don't have the zipalign binary installed. Get it by installing the <a href="http://goo.gl/1JPl8">SuperCharger Starter Kit</a>.<br>
3. You set Detailing to run on boot but you don't have the sqlite3 binary installed. Get it by installing the <a href="http://goo.gl/1JPl8">SuperCharger Starter Kit</a>.<br>
<br>
Here is some <b><u>Background Info</u></b> in case you're curious...<br>
<br>
<a href="http://goo.gl/krtf9">Linux Memory Consumption</a> - Nice article!<br>
<a href="http://goo.gl/hFdNO">Memory and SuperCharging Overview</a>, or... "Why 'Free RAM' Is NOT Wasted RAM!"<br>
<a href="http://goo.gl/4w0ba">MFK Calculator Info</a> - explanation for <b>vm.min_free_kbytes</b><br>
<a href="http://goo.gl/P8Bvu">Entropy-ness Enlarger Info</a> - explanation for <b>kernel.random.read_wakeup_threshold</b><br>
<a href="http://goo.gl/Zc85j">Entropy-ness Enlarger Musings...</a> - Possible reasons why it may actually do something :p<br>
<br>
<u><b>Patching services.jar/odex for ALL ROMS:</b></u>: It actually has 3 Mods. See the <a href="http://goo.gl/IvGL1">-=Ultimatic Jar Patcher Tools=-</a> thread.<br>
Mod 1. "Jelly ISCream" for ICS, Jelly Bean and above. This will SuperCharge Your Home Launcher and ADJ/OOM Priorities!<br>
Mod 2. "Maximum MultiTasking Mods" for Froyo and above<br>
Mod 3. "Non-Sense App Limit" for Sense 4 and above (Not needed for Sense 3.6 and below).<br>
<br>
Ok... now be sure to have <a href="http://play.google.com/store/apps/details?id=com.jrummy.busybox.installer">BusyBox</a> installed or else the scripts won't work!<br>
Most custom roms should already have a version installed and that usually works OK.<br>
So if you need to, only install <b>BusyBox v1.16.2 or higher!</b><br>
Note that some versions above v1.18.2 and below v1.19.1 sometimes give errors so <u>PAY ATTENTION</u> to the script output!<br>
Versions above v1.19.0 should be fine though.<br>
If all else fails or if you get "<b>applet not found</b>" errors, just grab BusyBox from the <a href="http://goo.gl/qM6yR">V6 SuperCharger Thread!</a><br>
Or even better, get the <b>SuperCharger Starter Kit!</b>
<br>
A nice app for running the script is <a href="http://play.google.com/store/apps/details?id=os.tools.scriptmanager">Script Manager</a><br>
It can even load scripts on boot - on ANY ROM!<br>
Plus, it even has WIDGETS!<br>
So you can actually put a V6 SuperCharger shortcut on your desktop, launch it, and have a quick peek at your current status!<br>
<br>
But first, you need to set up Script Manager properly!<br>
In the "Config" settings, enable "Browse as Root."<br>
Then browse to where you saved the V6 SuperCharger script, select it, and in the script's properties box, be sure to select "Run as Root" ie. SuperUser!<br>
<b>Do NOT run this file at boot!</b> (You don't want to run the install on every boot, do you?)<br>
Run the V6 SuperCharger script, touch the screen to access the soft keyboard, and enter your choice :)<br>
<br>
<u><b>Stock ROMs</b></u>: After running the script, have Script Manager load the newly created <b>/data/99SuperCharger.sh</b> on boot<br>
In the "Config" settings, be sure that "Browse as Root" is enabled.<br>
Press the menu key and then Browser. Navigate up to the root, then click on the "data" folder.<br>
Click on 99SuperCharger.sh and select "Script" from the "Open As" menu.<br>
In the properties dialogue box, check "Run as root" (SuperUser) and "Run at boot" and "Save".<br>
And that's it!<br>
Script Manager will load your most recent settings on boot!<br>
If you run the script later and with different settings, you don't have to reconfigure anything.<br>
Script Manager will just load the new /data/99SuperCharger.sh on boot automagically ;^]<br>
<br>
<u><b>Custom ROMs</b></u>: If you have a custom rom that loads /system/etc/init.d boot scripts,<br>
You DON'T need to use Script Manager to load a boot script. It will all be automatic!<br>
Also, if you can run boot scripts from the /system/etc/init.d folder, there are other options.<br>
For example you can use an app like Terminal Emulator to run the script.<br>
<u>PRE-ICS ROMS</u>: If your ROM has the option, <b>DISABLE "Lock Home In Memory.</b> This takes effect immediately.<br>
Alternately, <u>if you need to free up extra ram</u>, you can use "Lock Home in Memory" as a "Saftey Lock".<br>
ie. Use it to toggle your launcher from "Bulletproof" (0) or Hard To Kill (1) to "Weak" (2) in the event that you want to make the launcher an easy kill and free up extra RAM ;)<br>
<br>
<u><b>If Settings Don't Stick:</b></u> If you have Auto Memory Manager, DISABLE SuperUser permissions and if you have AutoKiller Memory Optimizer, DISABLE the apply settings at boot option!<br>
Also, if you have a <b>Custom ROM</b>, there might be something in the init.d folder that interferes with priorities and minfrees.<br>
If you can't find the problem, a quick fix is to have Script Manager run <b>/system/etc/init.d/*99SuperCharger</b> "at boot" and "as root."<br>
<br>
Another option is to make a Script Manager widget for <b>/system/etc/init.d/*99SuperCharger</b> or <b>/data/99SuperCharger.sh</b> on your homescreen and simply launch it after each reboot.<br>
<br>
For those with a <b>Milestone</b>, I made a version for <b>Androidiani Open Recovery</b> too :D<br>
Just extract the zip to the root of $storage (it contains the directory structure), load AOR, and there will be a SuperCharger Menu on the main screen! <br>
<br>
For more SuperCharging help and info,<br>
See the <a href="http://goo.gl/qM6yR">-=V6 SuperCharger Thread=-</a><br>
Feedback is Welcome!<br>
<br>
-=zeppelinrox=- @ <a href="http://goo.gl/qM6yR">XDA</a> & <a href="http://www.droidforums.net/forum/droid-hacks/148268-script-v6-supercharger-htk-bulletproof-launchers-fix-memory-all-androids.html">Droid</a> Forums<br>
<br>
EOF
if [ ! -d "/sqlite_stmt_journals" ]; then FAIL=yes
	echo $line
	echo ""
	sleep 2
	echo " Big Problem! Can't create a temporary folder!"
	echo ""
	sleep 2
	echo " Possible reasons:"
	echo ""
	sleep 2
	echo " 1. Not running as root...?"
	sleep 1
	echo " 2. Busybox isn't installed...?"
	sleep 1
	echo " 3. Busybox can't mount as r/w for some reason."
	echo ""
	sleep 2
	echo $line
fi
if [ "$madesqlitefolder" -eq 1 ]; then rm -r /sqlite_stmt_journals; fi 2>/dev/null
mount -o remount,ro / 2>/dev/null
mount -o remount,ro rootfs 2>/dev/null
busybox mount -o remount,ro / 2>/dev/null
busybox mount -o remount,ro rootfs 2>/dev/null
echo "        Test Driving Your Android Device..."
echo $line
echo ""
sleep 1
if [ ! "`busybox --list`" ]; then FAIL=yes
	echo " BusyBox NOT FOUND..."
	echo ""
	sleep 4
	echo $line
	echo "                           ...No Supe For You!!"
	echo $line
	echo ""
	sleep 4
	echo " If you continue, problems can occur..."
	echo ""
	sleep 4
	echo "                         ...and even bootloops!"
	echo ""
	sleep 4
	echo "  ...Please install BusyBox and try again..."
	echo ""
	sleep 4
	echo " Get BusyBox from the V6 SuperCharger Thread!"
	echo ""
	echo $line
	echo ""
	sleep 4
	su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
	echo ""
	echo $line
	echo ""
	sleep 4
	echo " I hope that helped! :^)"
	echo ""
	sleep 4
	echo " Continue anyway...?"
	echo ""
	sleep 2
	echo -n " Enter Y for Yes, any key for No: "
	read bbnotfound
	echo ""
	case $bbnotfound in
	  y|Y)echo " uh... right... okay..."
		  echo ""
		  echo $line
		  echo ""
		  sleep 2;;
		*)echo " Buh Bye..."
		  echo ""
		  exit 69;;
	esac
else
	if [ ! "`busybox --list | grep awk`" ]; then badbb=yes; echo " WARNING: awk applet NOT FOUND... Bad BusyBox!"; echo $line; sleep 2; fi
	if [ ! "`busybox --list | grep sed`" ]; then badbb=yes; echo " WARNING: sed applet NOT FOUND... Bad BusyBox!"; echo $line; sleep 2; fi
	if [ ! "`busybox --list | grep pgrep`" ]; then badbb=yes; echo " WARNING: pgrep applet NOT FOUND... Bad BusyBox!"; echo $line; sleep 2; fi
	if [ "$badbb" ]; then FAIL=yes
		echo ""
		echo " Your BusyBox is an EPIC FAIL... :p"
		echo ""
		sleep 4
		echo " It's version does NOT even matter because..."
		echo ""
		sleep 4
		echo $line
		echo "    It's MISSING basic applets and functions!"
		echo $line
		echo ""
		sleep 4
		echo " If you continue, problems can occur..."
		echo ""
		sleep 4
		echo "                         ...and even bootloops!"
		echo ""
		sleep 4
		echo " ...Please reinstall BusyBox and try again..."
		echo ""
		sleep 4
		echo " Get BusyBox from the V6 SuperCharger Thread!"
		echo ""
		sleep 4
		echo $line
		echo " And DON'T play stupid and ask me what's wrong!!"
		echo $line
		echo ""
		sleep 4
		su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
		echo ""
		echo $line
		echo ""
		sleep 4
		echo " I hope that helped! :^)"
		echo ""
		sleep 4
	fi
	test1=`busybox | awk 'NR==1{print $1}'`
	test2=`busybox | awk 'NR==1{print $2}'`
	test3=`echo 1000,2000,3000,4000,5000,6000 | awk -F , '{OFMT="%.0f";print $1/256, $2/256, $3/256, $4/256, $5/256, $6/256}'`
	if [ "$test2" ]; then echo " BusyBox $test2 Found!"
	else echo " ERROR! Can't determine BusyBox version!"; FAIL=yes
	fi
	echo ""
	sleep 1
	if [ "$test1" = "BusyBox" ] && [ "$test3" = "4 8 12 16 20 23" ]; then
		echo "   AWKing Awesome... AWK test passed!"
		echo ""
		sleep 1
		test4=`pgrep ini`
		if [ "$test4" ]; then echo "          Groovy... pgrep test passed too!"
		else FAIL=yes
			echo " BusyBox has holes in it..."
			echo ""
			sleep 4
			echo " ...BulletProof Apps ain't gonna work..."
			echo ""
			sleep 4
			echo $line
			echo "                          ...pgrep test FAILED!"
			echo $line
		fi
	else FAIL=yes
		echo " There was an AWK error..."
		echo ""
		sleep 4
		echo $line
		echo "                              ...what the AWK!?"
		echo $line
		echo ""
		sleep 4
		if [ "$test3" != "4 8 12 16 20 23" ]; then
			echo $line
			echo "   It can't even do... SIMPLE math! LOL WUT!?"
			echo $line
			echo ""
			sleep 4
		fi
		echo " If you continue, problems can occur..."
		echo ""
		sleep 4
		echo "                         ...and even bootloops!"
		echo ""
		sleep 4
		echo " ...Please reinstall BusyBox and try again..."
		echo ""
		sleep 4
		echo " Get BusyBox from the V6 SuperCharger Thread!"
		echo ""
		sleep 4
		echo $line
		echo " And DON'T DARE ask me to support broken shit!!"
		echo $line
		echo ""
		sleep 4
		su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
		echo ""
		echo $line
		echo ""
		sleep 4
		echo " I hope that helped! :^)"
		echo ""
		sleep 4
		echo " Continue anyway...?"
		echo ""
		sleep 2
		echo -n " Enter Y for Yes, any key for No: "
		read awkerror
		echo ""
		case $awkerror in
		  y|Y)echo " uh... right... okay..."
			  echo ""
			  echo $line;;
		    *)echo " Buh Bye..."
			  echo ""
			  exit 69;;
		esac
	fi
	echo ""
	sleep 1
fi 2>/dev/null
id=$(id); id=${id#*=}; id=${id%%[\( ]*}
if [ "$id" = "0" ] || [ "$id" = "root" ]; then echo "        Nice! You're Running as Root/SuperUser!"
else FAIL=yes
	echo $line
	echo " You are NOT running this script as root..."
	echo $line
	echo ""
	sleep 4
	echo $line
	echo "                      ...No SuperUser For You!!"
	echo $line
	echo ""
	sleep 4
	echo "     ...Please Run as Root and try again..."
	echo ""
	sleep 4
	echo " Loading Owner's Guide..."
	echo ""
	echo $line
	echo ""
	sleep 4
	su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://$storage/!SuperCharger.html"
	echo ""
	echo $line
	echo ""
	sleep 4
	echo " I hope that helped! :^)"
	echo ""
	sleep 4
	exit 69
fi
echo ""
sleep 1
echo $line
echo -n "            Test Drive Report: "
if [ "$FAIL" ]; then echo "FAIL!"
else echo "PASS!"
fi
echo $line
echo ""
sleep 2
ver=V6U9RC12B34ST
animspeed="busybox sleep 0.2"
smrun=`pgrep scriptmanager`
bbversion=`busybox | awk 'NR==1{print $1,$2}'`
opt=0;ran=0;gb=0;preics=yes;jb=0;memory=c;a=already_modified;b=bad_jar;ram1=9934;oomstick=0;ADJs=0;OOMs=0;minfrees=0
ram=$((`free | awk 'NR==2{print $2}'`/1024))
heapsize=$(($ram*16/100))
remainder=$(($heapsize%2))
heapsize=$(($heapsize+$remainder))
if [ "$ram" -lt 512 ]; then sdtweak=1024
else sdtweak=2048
fi
if [ ! -d "/data/V6_SuperCharger" ]; then mkdir /data/V6_SuperCharger; fi
if [ ! -d "$storage/V6_SuperCharger" ]; then mkdir $storage/V6_SuperCharger; fi
if [ ! -d "$storage/V6_SuperCharger/PowerShift_Scripts" ]; then mkdir $storage/V6_SuperCharger/PowerShift_Scripts; fi
if [ ! -d "$storage/V6_SuperCharger/BulletProof_One_Shots" ]; then mkdir $storage/V6_SuperCharger/BulletProof_One_Shots; fi
if [ ! -d "$storage/V6_SuperCharger/temp" ]; then mkdir $storage/V6_SuperCharger/temp; fi
TMP_DIR="$storage/V6_SuperCharger/temp"
initrcpath1="/init.rc"
initrcpath="/data$initrcpath1"
initrcbackup=$initrcpath.unsuper
LIMIT1=0;LIMIT2=3;LIMIT3=6;LIMIT4=10;LIMIT5=12;LIMIT6=15
newscadj="$LIMIT1,$LIMIT2,$LIMIT3,$LIMIT4,$LIMIT5,$LIMIT6";oldscadj1="0,3,5,7,14,15";oldscadj2="0,2,4,7,14,15";oldscadj3="0,3,6,10,14,15";oldscadj4="0,4,8,12,14,15";scamadj1="0,2,5,7,14,15";scamadj2="0,1,2,4,6,15"
minfreefile="/sys/module/lowmemorykiller/parameters/minfree"
if [ -f "/sys/module/lowmemorykiller/parameters/adj" ]; then adjfile="/sys/module/lowmemorykiller/parameters/adj"
elif [ -f "/data/V6_SuperCharger/SuperChargerAdj" ]; then adjfile="/data/V6_SuperCharger/SuperChargerAdj"
fi
if [ -f "/proc/1/oom_adj" ]; then oom_adj="oom_adj"
elif [ -f "/proc/1/oom_score_adj" ]; then  oom_adj="oom_score_adj"
fi
if [ -f "/data/V6_SuperCharger/SuperChargerMinfree" ]; then
	cp -fr /data/V6_SuperCharger/SuperChargerMinfree /data/V6_SuperCharger/SuperChargerMinfreeOld
	scminfreeold=`cat /data/V6_SuperCharger/SuperChargerMinfreeOld`
fi
if [ "`busybox ps -w`" ]; then w=" -w"; fi 2>/dev/null
mount -o remount,rw / 2>/dev/null
mount -o remount,rw rootfs 2>/dev/null
busybox mount -o remount,rw / 2>/dev/null
busybox mount -o remount,rw rootfs 2>/dev/null
mount -o remount,rw /system 2>/dev/null
busybox mount -o remount,rw /system 2>/dev/null
busybox mount -o remount,rw $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
for rc in `grep import $initrcpath1 | grep -v "#" | sed 's/.*import*.//'` `busybox find /system/ -iname "*.rc"`; do
	if [ "`echo $rc | grep -Ev "goldfish|ueventd"`" ] && [ ! "`echo $allrcpaths | grep $rc`" ]; then
 		if [ ! -f "$rc" ]; then
			echo "on early-boot" > $rc
			echo "on boot" > $rc
			touch $rc.unsuper
		fi
		chown 0.0 $rc; chmod 644 $rc
		allrcpaths="$allrcpaths $rc"
		if [ "`grep -ls "on boot" $rc`" ]; then rcpaths="$rcpaths $rc"; fi
	fi
done
mount -o remount,ro / 2>/dev/null
mount -o remount,ro rootfs 2>/dev/null
busybox mount -o remount,ro / 2>/dev/null
busybox mount -o remount,ro rootfs 2>/dev/null
mount -o remount,ro /system 2>/dev/null
busybox mount -o remount,ro /system 2>/dev/null
busybox mount -o remount,ro $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
load_options(){
	speed=`awk -F , '{print $1}' /data/V6_SuperCharger/SuperChargerOptions`
	buildprop=`awk -F , '{print $2}' /data/V6_SuperCharger/SuperChargerOptions`
	animation=`awk -F , '{print $3}' /data/V6_SuperCharger/SuperChargerOptions`
	initrc=`awk -F , '{print $4}' /data/V6_SuperCharger/SuperChargerOptions`
	launcheradj=`awk -F , '{print $5}' /data/V6_SuperCharger/SuperChargerOptions`
	panicmode=`awk -F , '{print $6}' /data/V6_SuperCharger/SuperChargerOptions`
	if [ -f "/data/V6_SuperCharger/!Detailing.sh" ];then detailinterval=`grep "^detailinterval=" /data/V6_SuperCharger/!Detailing.sh | sed 's/.*=//'`
	else detailinterval=`awk -F , '{print $7}' /data/V6_SuperCharger/SuperChargerOptions`
	fi
	if [ -f "/data/V6_SuperCharger/!WheelAlignment.sh" ];then zepalign=`grep "^bootzepalign=" /data/V6_SuperCharger/!WheelAlignment.sh | sed 's/.*=//'`
	else zepalign=`awk -F , '{print $8}' /data/V6_SuperCharger/SuperChargerOptions`
	fi
	if [ -f "/data/V6_SuperCharger/!FixEmissions.sh" ];then fixemissions=`grep "^bootfixemissions=" /data/V6_SuperCharger/!FixEmissions.sh | sed 's/.*=//'`
	else fixemissions=`awk -F , '{print $9}' /data/V6_SuperCharger/SuperChargerOptions`
	fi
	if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ];then fixalign=`grep "^bootfixalign=" /data/V6_SuperCharger/!FixAlignment.sh | sed 's/.*=//'`
	else fixalign=`awk -F , '{print $10}' /data/V6_SuperCharger/SuperChargerOptions`
	fi
	if [ -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ];then flushOmaticHours=`grep "^flushOmaticHours=" /data/V6_SuperCharger/!FastEngineFlush.sh | sed 's/.*=//'`
	else flushOmaticHours=`awk -F , '{print $11}' /data/V6_SuperCharger/SuperChargerOptions`
	fi
	accsd=`awk -F , '{print $12}' /data/V6_SuperCharger/SuperChargerOptions`
	tc3g=`awk -F , '{print $13}' /data/V6_SuperCharger/SuperChargerOptions`
	sleep="sleep $speed"
	if [ "$buildprop" -eq 1 ]; then prop="/system/build.prop"
	else prop="/data/local.prop"
	fi
	if [ ! "$detailinterval" ] || [ "`echo $detailinterval | grep "[^0-9]"`" ] || [ "$detailinterval" -gt 9 ]; then detailinterval=3; fi
	if [ ! "$flushOmaticHours" ] || [ "`echo $flushOmaticHours | grep "[^0-9]"`" ] || [ "$flushOmaticHours" -gt 24 ]; then flushOmaticHours=0; fi
}
if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
	load_options
	if [ ! "$tc3g" ]; then missingoptions=yes; animation=1; fi
else firstgear=yes; autoshowcalculated=yes; sleep="sleep 2"
fi
if [ ! "$animation" ] || [ "$animation" -eq 1 ]; then
	clear;$animspeed;echo $line;echo "";echo "";echo "";echo "";echo "";echo ""; echo "";echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "";echo "";echo "";echo "";echo "";echo ""; echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo $line;echo "";echo "";echo "";echo "";echo ""; echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "";echo $line;echo "";echo "";echo "";echo ""; echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    |/   #####";echo "";echo $line;echo "";echo "";echo ""; echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    ||  //  #";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    ||   //  #    #" ;echo "    ||  //  #";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";echo "";$animspeed
	clear;echo "";echo $line;echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;echo "";$animspeed
	clear;echo "";echo $line;echo "";echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;sleep 1
	clear;echo "";echo $line;echo "";echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #           -=SUPERCHARGER=-";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #";echo "    |/   #####";echo "";echo $line;sleep 1
	clear;echo " zoom...";echo $line;echo "";echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #           -=SUPERCHARGER=-";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #  Presented";echo "    |/   #####";echo "";echo $line;sleep 1
	clear;echo " zoOM... zoOM...";echo $line;echo "";echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #           -=SUPERCHARGER=-";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #  Presented by:";echo "    |/   #####";echo "";echo $line;sleep 1
	clear;echo " zOOM... zOOM...";echo $line;echo "";echo "    ||    //  #####";echo "    ||   //  #    #";echo "    ||  //  #           -=SUPERCHARGER=-";echo "    || //  #####";echo "    ||//  #    #";echo "    | /  #    #  Presented by:";echo "    |/   #####                 -=zeppelinrox=-";echo "";echo $line;sleep 1
else clear; echo ""; echo $line
fi
echo " NOTE: BUSYBOX v1.16.2 OR HIGHER IS RECOMMENDED!"
echo $line
echo ""
sleep 2
if [ "$smrun" ]; then echo "   Touch the screen to bring up soft keyboard"
else echo " Try Script Manager... it's easier!"
fi
echo ""
echo $line
echo ""
$sleep
echo " Additional BusyBox Info:"
echo ""
$sleep
echo " $bbversion"
echo " `busybox | awk 'NR==1{print}' | cut -d " " -f3-`"
echo ""
$sleep
if [ "$bbversion" \> "BusyBox v1.16.1" ] && [ "$bbversion" \< "BusyBox v1.18.3" ] || [ "$bbversion" \> "BusyBox v1.18.9" ]; then echo "           ...which is fine - if it's COMPLETE!"
else
	echo $line
	echo -n " WARNING!  Your BusyBox is "
	if [ "$bbversion" \> "BusyBox v1.18.2" ] && [ "$bbversion" \< "BusyBox v1.19.0" ]; then
		echo "greater than v1.18.2"
		echo ""
		sleep 2
		echo "                      ...and less that v1.19.0!"
		echo $line
		echo ""
		sleep 2
		echo " These versions can cause problems..."
	else
		echo "less than v1.16.2"
		echo $line
		echo ""
		sleep 2
		echo " Some commands may not even work..."
	fi
	echo ""
	sleep 2
	echo " ..and you may have issues such as bootloops..."
	echo ""
	sleep 2
	echo "                  ...proceed at your own risk!!"
	echo ""
	sleep 2
	echo " Get BusyBox from the V6 SuperCharger Thread!"
	echo ""
	echo $line
	echo ""
	sleep 2
	su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
fi
echo ""
alias echo="busybox echo"
terms(){
	cat >> "$1" <<EOF
# $ver
#
# When using scripting tricks, ideas, or code snippets from here, GIVE PROPER CREDIT.
# There are many things may look simple, but actually took a lot of time, trial, and error to get perfected.
# So DO NOT remove credits, put your name on top, and pretend it's your creation.
# That's called kanging and makes you a dumbass.
#
# This script can be used freely and can even be modified for PERSONAL USE ONLY.
# It can be freely incorporated into ROMs - provided that proper credit is given WITH a link back to the XDA SuperCharger thread.
# If you want to share it or make a thread about it, just provide a link to the main thread.
#      - This ensures that users will always be getting the latest versions.
# Prohibited: Any modification (excluding personal use), repackaging, redistribution, or mirrors of my work are NOT PERMITTED.
# Thanks, zeppelinrox.
#
EOF
}
update_options(){
	echo "$speed,$buildprop,$animation,$initrc,$launcheradj,$panicmode,$detailinterval,$zepalign,$fixemissions,$fixalign,$flushOmaticHours,$accsd,$tc3g" > /data/V6_SuperCharger/SuperChargerOptions
	cp -fr /data/V6_SuperCharger/SuperChargerOptions $storage/V6_SuperCharger/SuperChargerOptions
}
show_current_options(){
	echo "  Prior Scrolling Speed has been applied - $speed"
	echo $line
	$sleep
	if [ "$preics" ]; then
		echo -n "  Prop file used for SuperCharging - "
		if [ "$buildprop" -eq 0 ]; then echo "LOCAL.PROP"
		else echo "BUILD.PROP"
		fi
		echo $line
		$sleep
		echo -n "  SuperCharged Launcher Option is"
		if [ "$launcheradj" -eq 0 ]; then echo " BulletProof!!"
		elif [ "$launcheradj" -eq 2 ]; then echo " Hard To Kill!"
		else echo "... Die-Hard!!"
		fi
		echo $line
		$sleep
	fi
	echo -n "  Kernel & Virtual Memory Tweaks"
	if [ "$panicmode" -eq 3 ]; then kpanic=0; kpoops=0; echo " are Rock Hard!"
	elif [ "$panicmode" -eq 2 ]; then kpanic=30; kpoops=0; echo " - Rock & Roll!"
	elif [ "$panicmode" -eq 1 ]; then kpanic=30; kpoops=1; echo " ala Soft Rock!"
	else kpanic=30; kpoops=1; echo " - Disco Dance!"
	fi
	echo $line
	$sleep
	echo -n "         Accessories and SD Speed Tweaks - "
	if [ "$accsd" -eq 0 ]; then echo "NO!"
	else echo "YES!"
	fi
	echo $line
	$sleep
	echo -n "  3G TurboCharger Enhancement(3GTC Addon)- "
	if [ "$tc3g" -eq 0 ]; then echo "NO!"
	else echo "YES!"
	fi
	echo $line
	$sleep
	if [ -d "/system/etc/init.d" ]; then
		if [ "$detailinterval" -eq 0 ]; then echo "  Detailing(Clean Database) Runs On Boot - NO!"
		else echo "  Detailing(Clean Database) Runs Every $detailinterval Boots!"
		fi
		echo $line
		$sleep
		echo -n "  Wheel Alignment(ZipAlign) Runs On Boot - "
		if [ "$zepalign" -eq 1 ]; then echo "YES!"
		else echo "NO!"
		fi
		echo $line
		$sleep
		echo -n "  Fix Emissions (Fixes FCs) Runs On Boot - "
		if [ "$fixemissions" -eq 1 ]; then echo "YES!"
		else echo "NO!"
		fi
		echo $line
		$sleep
		echo -n "  Fix Alignment (Dual Tool) Runs On Boot - "
		if [ "$fixalign" -eq 1 ]; then echo "YES!"
		else echo "NO!"
		fi
		echo $line
		$sleep
		if [ "$flushOmaticHours" -gt 0 ]; then echo "  Engine Flush-O-Matic - Enabled @ Every - $flushOmaticHours"hrs
		else echo "  Engine Flush-O-Matic Mode is Currently - OFF!"
		fi
		echo $line
		$sleep
		if [ "$preics" ]; then
			echo -n "  System Integration of $initrcpath1 Setting - "
			if [ "$initrc" -eq 1 ]; then
				echo "ON!"
				echo $line
				echo ""
				$sleep
				echo "   Go to Driver Options and DISABLE..."
				echo ""
				$sleep
				echo "         ...if you have root/permission issues!"
			else
				echo "OFF!"
				echo $line
				echo ""
				$sleep
				echo "   Go to Driver Options and ENABLE..."
				echo ""
				$sleep
				echo "             ...for greater System Integration!"
			fi
			echo ""
			echo $line
			$sleep
		fi
	fi
	echo ""
}
Get_oomadj_Info(){
	currentminfree=`cat $minfreefile`
	ram2=`$low$memory "$0" | awk '{print $1}'`
	if [ -f "/data/V6_SuperCharger/SuperChargerAdj" ]; then scadj=`cat /data/V6_SuperCharger/SuperChargerAdj`; fi
	if [ -f "/data/V6_SuperCharger/SuperChargerMinfree" ]; then scminfree=`cat /data/V6_SuperCharger/SuperChargerMinfree`; fi
	if [ -f "/data/V6_SuperCharger/SuperChargerCustomMinfree" ]; then sccminfree=`cat /data/V6_SuperCharger/SuperChargerCustomMinfree`; fi
	if [ -f "/data/V6_SuperCharger/BulletProof_Apps_HitList" ]; then bpapplist=`cat /data/V6_SuperCharger/BulletProof_Apps_HitList`; fi
	if [ ! "$adjfile" ]; then oomadj1=0;oomadj2=1;oomadj3=2;oomadj4=4;oomadj5=9;oomadj6=15;currentadj="0,1,2,4,9,15"
	elif [ "`awk -F , '{print $3}' $adjfile`" -gt 15 ]; then
		oomadj1=`awk -F , '{printf "%.0f\n", $1*17/1000}' $adjfile`;oomadj2=`awk -F , '{printf "%.0f\n", $2*17/1000}' $adjfile`;oomadj3=`awk -F , '{printf "%.0f\n", $3*17/1000}' $adjfile`;oomadj4=`awk -F , '{printf "%.0f\n", $4*17/1000}' $adjfile`;oomadj5=`awk -F , '{printf "%.0f\n", $5*17/1000}' $adjfile`;oomadj6=15
		currentadj="$oomadj1,$oomadj2,$oomadj3,$oomadj4,$oomadj5,$oomadj6"
	else
		oomadj1=`awk -F , '{print $1}' $adjfile`;oomadj2=`awk -F , '{print $2}' $adjfile`;oomadj3=`awk -F , '{print $3}' $adjfile`;oomadj4=`awk -F , '{print $4}' $adjfile`;oomadj5=`awk -F , '{print $5}' $adjfile`;oomadj6=`awk -F , '{print $6}' $adjfile`
		currentadj=`cat $adjfile`
	fi
}
MFK_Calculator(){
	#
	# MFK Calculator (for min_free_kbytes) created by zeppelinrox.
	#
	if [ "$1" ] && [ "$postics" ] && [ ! "$servicesjarpatched" ]; then SSADJ=5
	elif [ "$1" ]; then SSADJ=$adj3
	fi
	if [ "$1" ] && [ "$SL3" -gt 0 ]; then SSMF=$SL3
	elif [ "$scminfree" ]; then SSMF=`echo $scminfree | awk -F , '{print $3}'`
	else SSMF=`awk -F , '{print $3}' $minfreefile`
	fi
	MFK=$(($SSMF*4/5))
}
free_space_error(){
	echo $line
	echo " WARNING: ERROR copying file to $1!"
	echo $line
	echo ""
	$sleep
	echo " Got enough free space?"
	echo ""
	$sleep
	echo " System Partition has `busybox df -h | awk '$NF=="/system"{print $4,"Free ("$5" Used)"}'`"
}
boot_script_blurb(){
	echo $line
	echo ""
	$sleep
	echo " $1 can run automatically on boot!"
	echo ""
	$sleep
	echo " The script is VERY sophisticated..."
	echo ""
	$sleep
	echo "           ...so boot time would be unaffected!"
	echo ""
}
integrate_initrc(){
	sed -i '/remount,rw \/data/ i\
if [ -f "'$initrcpath'" ] && [ "\`grep "SuperCharger" /system/build.prop\`" ] && [ "\`diff '$initrcpath' '$initrcpath1'\`" ]; then\
	mount -o remount,rw / 2>/dev/null;\
	mount -o remount,rw rootfs 2>/dev/null;\
	busybox mount -o remount,rw / 2>/dev/null;\
	busybox mount -o remount,rw rootfs 2>/dev/null;\
	cp -fr '$initrcpath' '$initrcpath1';\
	mount -o remount,ro / 2>/dev/null;\
	mount -o remount,ro rootfs 2>/dev/null;\
	busybox mount -o remount,ro / 2>/dev/null;\
	busybox mount -o remount,ro rootfs 2>/dev/null;\
fi 2>/dev/null; # System Integration Marker' $1
}
Apply_KVM_Tweaks(){
	echo -n "           ";busybox sysctl -w vm.oom_kill_allocating_task=0
	echo -n "                       ";busybox sysctl -w vm.panic_on_oom=0
	echo -n "                  ";busybox sysctl -w vm.overcommit_memory=1
	echo -n "                         ";busybox sysctl -w vm.swappiness=20
	if [ "$panicmode" -gt 0 ]; then
		echo -n "                  ";busybox sysctl -w kernel.panic_on_oops=$kpoops
		echo -n "                          ";busybox sysctl -w kernel.panic=$kpanic
	fi
	echo -n "  ";busybox sysctl -w kernel.random.write_wakeup_threshold=3840
	echo -n "   ";busybox sysctl -w kernel.random.read_wakeup_threshold=1376
	echo ""
	$sleep
	echo $line
	echo " Note: Last one's the -=Entropy-ness Enlarger=-!"
	echo $line
	echo ""
	$sleep
}
Apply_Accessories_SD_Speed(){
	echo " Applying Accessories and SD Speed Tweaks..."
	echo ""
	$sleep
	echo "  ...based on the $ram MB of RAM on your device!"
	echo ""
	$sleep
	if [ "`ls /sys/devices/virtual/bdi/179*/read_ahead_kb`" ]; then read_ahead=yes
		for i in /sys/devices/virtual/bdi/179*/read_ahead_kb; do echo $sdtweak > $i; done
	fi 2>/dev/null
	if [ -f "/sys/block/mmcblk0/bdi/read_ahead_kb" ]; then read_ahead=yes
		echo $sdtweak > /sys/block/mmcblk0/bdi/read_ahead_kb
	fi
	if [ -f "/sys/block/mmcblk0/queue/read_ahead_kb" ]; then read_ahead=yes
		echo $sdtweak > /sys/block/mmcblk0/queue/read_ahead_kb
	fi
	if [ "$read_ahead" ]; then echo "              SD Read Speed Tweak = $sdtweak KB"
	else
		echo $line
		echo "     Sorry! Can't Apply SD Read Speed Tweak!"
		echo $line
		echo ""
		$sleep
	fi
	if [ "`getprop | grep heapgrowthlimit`" ]; then
		setprop dalvik.vm.heapgrowthlimit $heapsize"m"
		echo "        dalvik.vm.heapgrowthlimit = $heapsize MB"
	fi
	setprop dalvik.vm.heapsize $heapsize"m"
	echo "               dalvik.vm.heapsize = $heapsize MB"
	if [ "`getprop | grep persist.sys.vm.heapsize`" ]; then
		setprop persist.sys.vm.heapsize $heapsize"m"
		echo "          persist.sys.vm.heapsize = $heapsize MB"
	fi
	setprop persist.sys.purgeable_assets 1
	echo "     persist.sys.purgeable_assets = 1"
	setprop wifi.supplicant_scan_interval 180
	echo "    wifi.supplicant_scan_interval = 180"
	setprop windowsmgr.max_events_per_sec 90
	echo "    windowsmgr.max_events_per_sec = 90"
	setprop pm.sleep_mode 1
	echo "                    pm.sleep_mode = 1"
	echo ""
}
Apply_3G_TCE(){
	echo " Applying 3G TurboCharger Enhancement..."
	echo ""
	$sleep
	setprop net.dns1 8.8.8.8
	setprop net.dns2 8.8.4.4
	setprop net.tcp.buffersize.default 6144,87380,110208,6144,16384,110208
	setprop net.tcp.buffersize.wifi 262144,524288,1048576,262144,524288,1048576
	setprop net.tcp.buffersize.lte 262144,524288,3145728,262144,524288,3145728
	setprop net.tcp.buffersize.hsdpa 6144,262144,1048576,6144,262144,1048576
	setprop net.tcp.buffersize.evdo_b 6144,262144,1048576,6144,262144,1048576
	setprop net.tcp.buffersize.umts 6144,87380,110208,6144,16384,110208
	setprop net.tcp.buffersize.hspa 6144,87380,262144,6144,16384,262144
	setprop net.tcp.buffersize.gprs 6144,8760,11680,6144,8760,11680
	setprop net.tcp.buffersize.edge 6144,26280,35040,6144,16384,35040
	echo -n "            ";busybox sysctl -w net.core.wmem_max=1048576
	echo -n "            ";busybox sysctl -w net.core.rmem_max=1048576
	echo -n "          ";busybox sysctl -w net.core.optmem_max=20480
	echo -n " ";busybox sysctl -w net.ipv4.tcp_moderate_rcvbuf=1
	echo -n "         ";busybox sysctl -w net.ipv4.route.flush=1
	echo -n "        ";busybox sysctl -w net.ipv4.udp_rmem_min=6144
	echo -n "        ";busybox sysctl -w net.ipv4.udp_wmem_min=6144
	echo -n "         ";busybox sysctl -w net.ipv4.tcp_rmem='6144 87380 1048576'
	echo -n "         ";busybox sysctl -w net.ipv4.tcp_wmem='6144 87380 1048576'
	echo ""
}
Re_Generate_99SuperCharger_sh(){
	echo "#!/system/bin/sh" > /data/99SuperCharger.sh
	echo "#" >> /data/99SuperCharger.sh
	for sc in /data/99SuperCharger.sh /system/etc/hw_config.sh; do
		if [ -f "$sc" ]; then cat >> $sc <<EOF
# V6 SuperCharger, OOM Grouping & Priority Fixes created by -=zeppelinrox=-
#
EOF
			terms $sc
			cat >> $sc <<EOF
# SuperMinFree Calculator & MFK Calculator (for min_free_kbytes) created by zeppelinrox also ;^]
# Entropy-ness Enlarger (sysctl tweak for kernel.random.read_wakeup_threshold that keeps entropy_avail full) discovered by zeppelinrox.
#
# See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article!
# See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why 'Free RAM' Is NOT Wasted RAM!"
# See http://goo.gl/4w0ba - MFK Calculator Info - explanation for vm.min_free_kbytes.
# See http://goo.gl/P8Bvu - How Entropy-ness Enlarger works.
# See http://goo.gl/Zc85j - Possible reasons why it may actually do something :p
#
EOF
			if [ "$sc" = "/data/99SuperCharger.sh" ]; then cat >> $sc <<EOF
  ################################
 #  SuperCharger Service Notes  #
################################
# To leave the SuperCharger Service running, insert a # at the beginning of the "stop super_service" entry near the bottom of this script (3rd or 4th last line).
#
# To stop the SuperCharger Service, run Terminal Emulator and type...
# "su" and Enter.
# "stop super_service" and Enter.
#
# To restart the SuperCharger Service so it stays running, type...
# "su" and Enter.
# "start super_service" and Enter.
#
# If the service is running and you type: "cat /proc/*/cmdline | grep Super".
# The output would be 2 items:
#     a. "/data/99SuperCharger.sh"
#     b. "Super" (created by your query so this doesn't mean anything)
#
# If it's not running, the output would be the last item ie. "Super" which was generated by the typed command.
#
# Similar results can be had with: "busybox ps | grep Super".
#
if [ -f "/data/!!SuperChargerBootLoopMessage.log" ]; then
# 	echo " \$( date +"%m-%d-%Y %H:%M:%S" ): \$0 Detected A BootLooped... ABORTING..." >> /data/Ran_SuperCharger.log;
	exit 69;
fi;
# echo " Delete this file to Re-Enable *99SuperCharger to run on boot..." > /data/!!SuperChargerBootLoopMessage.log;
#
EOF
				if [ ! "$allrcpaths" ]; then cat >> $sc <<EOF
# Ummm... this service won't work on your current ROM. Sorry :P
# Instead use Script Manager to run this script if you're on a stock ROM OR settings don't stick via the SuperCharger boot script found in /system/etc/init.d!
#
EOF
				fi
				cat >> $sc <<EOF
# echo ""; echo " See /data/Log_SuperCharger.log for the output!"; echo "";
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_SuperCharger.log file to see what may have fubarred.
# set -x;
# exec > /data/Log_SuperCharger.log 2>&1;
#
line=================================================;
mount -o remount,rw /data 2>/dev/null;
busybox mount -o remount,rw /data 2>/dev/null;
echo "";
echo \$line;
echo "   The -=V6 SuperCharger=- by -=zeppelinrox=-";
echo \$line;
echo "";
id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*};
if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
	echo " You are NOT running this script as root...";
	echo "";
	echo \$line;
	echo "                      ...No SuperUser For You!!";
	echo \$line;
	echo "";
	echo "     ...Please Run as Root and try again...";
	echo "";
	echo \$line;
	echo "";
	exit 69;
fi;
echo " To verify application of settings...";
echo "";
echo "       ...check out /data/Ran_SuperCharger.log!";
echo "";
echo \$line;
echo "";
Smart_Rename(){
	mount -o remount,rw /system 2>/dev/null;
	busybox mount -o remount,rw /system 2>/dev/null;
	busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;
	for i in \`busybox ls -r /system/etc/init.d | grep -v SuperCharger\`; do
		if [ "\$j" ]; then break; fi;
		if [ ! -d "\$i" ]; then j=\$i; fi;
	done;
	echo " SuperCharger to run on boot as...";
	echo "";
	echo \$line;
	if [ "\`echo \$j | grep KickAssKernel\`" ] && [ "\$i" \\< "99SuperCharger" ] || [ "\$j" \\< "99SuperCharger" ]; then desiredname="/system/etc/init.d/99SuperCharger";
	elif [ "\`echo \$j | grep KickAssKernel\`" ] && [ "\$i" \\< "S99SuperCharger" ] || [ "\$j" \\< "S99SuperCharger" ]; then desiredname="/system/etc/init.d/S99SuperCharger";
	else desiredname="/system/etc/init.d/SS99SuperCharger";
	fi;
	echo "        ...\$desiredname!";
	if [ "\$0" != "\$desiredname" ]; then
		mv \$0 \$desiredname;
		rm /data/!!SuperChargerBootLoopMessage.log;
		\$desiredname & exit 0;
	fi;
	echo \$line;
	echo "";
	if [ "\`ls /system/etc/init.d/*oopy*\`" ] && [ "\`ls /system/etc/init.d/*oopy*\`" != "/system/etc/init.d/zzloopy_runs_last_so_others_do_too" ]; then
		mv /system/etc/init.d/*oopy* /system/etc/init.d/zzloopy_runs_last_so_others_do_too;
		sed -i '1 a\\
#\\
# Hey you should try BulletProofing Apps from within V6 SuperCharger instead!\\
#' /system/etc/init.d/zzloopy_runs_last_so_others_do_too;
	fi 2>/dev/null;
	mount -o remount,ro /system 2>/dev/null;
	busybox mount -o remount,ro /system 2>/dev/null;
	busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;
};
EOF
			else cat >> $sc <<EOF
# DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!
#
line=================================================;
mount -o remount,rw /data 2>/dev/null;
busybox mount -o remount,rw /data 2>/dev/null;
echo "";
echo \$line;
echo "";
EOF
			fi
			cat >> $sc <<EOF
3G_TCE(){
	if [ "\`cat /proc/sys/net/core/rmem_max\`" -ne 1048576 ]; then
		  ##################################
		 #  3G TurboCharger Enhancement!  #
		##################################
		busybox sysctl -w net.core.wmem_max=1048576;
		busybox sysctl -w net.core.rmem_max=1048576;
		busybox sysctl -w net.core.optmem_max=20480;
		busybox sysctl -w net.ipv4.tcp_moderate_rcvbuf=1;            # Be sure that autotuning is in effect
		busybox sysctl -w net.ipv4.route.flush=1;
		busybox sysctl -w net.ipv4.udp_rmem_min=6144;
		busybox sysctl -w net.ipv4.udp_wmem_min=6144;
		busybox sysctl -w net.ipv4.tcp_rmem='6144 87380 1048576';
		busybox sysctl -w net.ipv4.tcp_wmem='6144 87380 1048576';
		echo "";
		echo \$line;
		echo "";
	fi;
};
SD_Speed(){
	ram=\$((\`free | awk 'NR==2{print \$2}'\`/1024))
	if [ "\$ram" -lt 512 ]; then sdtweak=1024
	else sdtweak=2048
	fi
	if [ "\`cat /sys/block/mmcblk0/bdi/read_ahead_kb\`" -ne \$sdtweak ]; then
		  #########################
		 #  SD Read Speed Tweak  #
		#########################
		if [ "\`ls /sys/devices/virtual/bdi/179*/read_ahead_kb\`" ]; then
			for i in /sys/devices/virtual/bdi/179*/read_ahead_kb; do echo \$sdtweak > \$i; done;
		fi 2>/dev/null;
		echo \$sdtweak > /sys/block/mmcblk0/bdi/read_ahead_kb 2>/dev/null;
		echo \$sdtweak > /sys/block/mmcblk0/queue/read_ahead_kb 2>/dev/null;
	fi;
};
KVM_Tweaks(){
	MFK=$MFK;
	if [ "\`cat /proc/sys/vm/min_free_kbytes\`" -ne \$MFK ]; then
		  ####################################
		 #  Kernel & Virtual Memory Tweaks  #
		####################################
		busybox sysctl -w vm.min_free_kbytes=\$MFK;
		busybox sysctl -w vm.oom_kill_allocating_task=0;
		busybox sysctl -w vm.panic_on_oom=0;
		busybox sysctl -w vm.overcommit_memory=1;
		busybox sysctl -w vm.swappiness=20;
		# busybox sysctl -w kernel.panic_on_oops=$kpoops;
		# busybox sysctl -w kernel.panic=$kpanic;
		busybox sysctl -w kernel.random.write_wakeup_threshold=3840;
		busybox sysctl -w kernel.random.read_wakeup_threshold=1376;  # Entropy-ness Enlarger - keeps entropy_avail full - MAY save battery and/or boost responsiveness
		echo "";
		echo \$line;
		echo "";
	fi;
};
SuperCharge(){
	applyscminfree=; applyscadj=;
	currentadj=\`cat /sys/module/lowmemorykiller/parameters/adj\` 2>/dev/null;
	currentminfree=\`cat /sys/module/lowmemorykiller/parameters/minfree\` 2>/dev/null;
	scadj=\`cat /data/V6_SuperCharger/SuperChargerAdj\`;
	scminfree=\`cat /data/V6_SuperCharger/SuperChargerMinfree\`;
	if [ "\$scminfree" ] && [ "\$currentminfree" != "\$scminfree" ]; then applyscminfree=yes; fi;
	if [ "\$scadj" ] && [ "\$currentadj" != "\$scadj" ]; then applyscadj=yes; fi;
	if [ "\$applyscminfree" ] || [ "\$applyscadj" ]; then
		  ###########################
		 #  Get 50% SuperCharged!  #
		###########################
		chmod 777 /sys/module/lowmemorykiller/parameters/adj 2>/dev/null;
		chmod 777 /sys/module/lowmemorykiller/parameters/minfree 2>/dev/null;
		if [ "\$scadj" ]; then echo \$scadj > /sys/module/lowmemorykiller/parameters/adj; fi 2>/dev/null;
		if [ "\$scminfree" ]; then echo \$scminfree > /sys/module/lowmemorykiller/parameters/minfree; fi 2>/dev/null;
EOF
			if [ "$buildprop" -eq 0 ]; then cat >> $sc <<EOF
		sed -i '/.*_ADJ/d;
				/.*_MEM/d' /system/build.prop;
EOF
				if [ -f "/system/bin/build.prop" ]; then cat >> $sc <<EOF
		sed -i '/.*_ADJ/d;
				/.*_MEM/d' /system/bin/build.prop;
EOF
				fi
			fi
			cat >> $sc <<EOF
		echo " \$( date +"%m-%d-%Y %H:%M:%S" ): Applied settings from \$0!" >> /data/Ran_SuperCharger.log;
		echo "         SuperCharger Settings Applied!";
	else
		echo " \$( date +"%m-%d-%Y %H:%M:%S" ): No need to reapply settings from \$0!" >> /data/Ran_SuperCharger.log;
		echo " SuperCharger Settings Were ALREADY Applied...";
		echo "";
		echo "            ...there's no need to reapply them!";
	fi;
	echo "";
	echo \$line;
	echo "";
};
HellzYeah(){
EOF
			if [ "$sc" = "/data/99SuperCharger.sh" ]; then cat >> $sc <<EOF
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done;
	# rm /data/!!SuperChargerBootLoopMessage.log;
	# SuperCharge;
	if [ ! "\`pgrep scriptmanager\`" ]; then
		echo " Waiting 2 minutes (avoid conflicts)... then...";echo "";
		echo " Gonna SuperCharge this Android... zoOM... zOOM!";
		echo "";
		echo \$line;
		echo "";
		sleep 120;
	fi;
	KVM_Tweaks;
	# 3G_TCE;
	# SD_Speed;
	SuperCharge;
	# sleep 360;
	# SuperCharge;
	echo " \$0 Executed...";
	echo "";
	echo "          ===========================";
	echo "           ) SuperCharge Complete! (";
	echo "          ===========================";
	echo "";
	if [ "\`echo \$0 | grep -v "init\.d"\`" ]; then stop super_service; fi;
};
# Smart_Rename;
# KVM_Tweaks;
# SuperCharge;
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_SuperCharger.log 2>&1;
	HellzYeah &
else HellzYeah;
fi;
exit 0;
EOF
			else cat >> $sc <<EOF
	KVM_Tweaks;
	# 3G_TCE;
	# SD_Speed;
	SuperCharge;
	echo " \$0 Executed...";
	echo "";
};
HellzYeah &
EOF
			fi
			echo "# End of V6 SuperCharged Entries." >> $sc
			if [ "$initrc" -eq 1 ]; then integrate_initrc $sc; fi
			if [ "$panicmode" -gt 0 ]; then sed -i '/kernel.panic/s/# //' $sc; fi
			if [ "$tc3g" -eq 1 ]; then sed -i '/3G_TCE;/s/# //' $sc; fi
			if [ "$accsd" -eq 1 ]; then sed -i '/SD_Speed;/s/# //' $sc; fi
		fi
	done 2>/dev/null
	chown 0.0 /data/99SuperCharger.sh; chmod 777 /data/99SuperCharger.sh
	cp -fr /data/99SuperCharger.sh $storage/V6_SuperCharger
	cp -fr /data/99SuperCharger.sh $storage/V6_SuperCharger/99super
	if [ "$1" ]; then echo " Re-Generating /system/xbin/99super..."; fi
	cp -fr /data/99SuperCharger.sh /system/xbin/99super
	if [ "`ls /system/etc/hw_config.sh*`" ]; then cp -fr /system/etc/hw_config.sh* $storage/V6_SuperCharger; fi 2>/dev/null
	if [ -d "/system/etc/init.d" ]; then cp -fr /data/99SuperCharger.sh /system/etc/init.d/99SuperCharger
		if [ ! "`diff /data/99SuperCharger.sh /system/etc/init.d/99SuperCharger`" ]; then scdiff=
			sed -i '/BootLoop/s/# //
					s/# echo/echo/
					s/# set -x/set -x/
					s/^# exec/exec/
					s/# SuperCharge;/SuperCharge;/
					/# sleep/,/exit 0/s/# //' /system/etc/init.d/99SuperCharger
			j=
			for i in `busybox ls -r /system/etc/init.d | grep -v SuperCharger`; do
				if [ "$j" ]; then break; fi
				if [ ! -d "$i" ]; then j=$i; fi
			done
			if [ "`echo $j | grep KickAssKernel`" ] && [ "$i" \< "99SuperCharger" ] || [ "$j" \< "99SuperCharger" ]; then desiredname="/system/etc/init.d/99SuperCharger"
			elif [ "`echo $j | grep KickAssKernel`" ] && [ "$i" \< "S99SuperCharger" ] || [ "$j" \< "S99SuperCharger" ]; then desiredname="/system/etc/init.d/S99SuperCharger"
			else desiredname="/system/etc/init.d/SS99SuperCharger"
			fi
			if [ "$1" ]; then echo " Re-Generating `echo $desiredname | sed 's/.*etc//'`..."; fi
			if [ "/system/etc/init.d/99SuperCharger" != "$desiredname" ]; then mv /system/etc/init.d/99SuperCharger $desiredname; fi
			cp -fr $desiredname $storage/V6_SuperCharger
		else scdiff=yes
		fi
	fi
}
Re_Generate_97BulletProof_Apps_sh(){
	cat > /data/97BulletProof_Apps.sh <<EOF
#!/system/bin/sh
#
# BulletProof Apps Boot Script created by -=zeppelinrox=-
#
EOF
	terms /data/97BulletProof_Apps.sh
	cat >> /data/97BulletProof_Apps.sh <<EOF
# Usage: 1. Runs automatically via custom rom's init.d folder or BulletProof Apps Service.
#        2. Type in Terminal: "su" and enter, "/data/97*" and enter.
#        3. Script Manager: launch it once like any other script OR with a widget (DO NOT PUT IT ON A SCHEDULE!)
#
# Important! Whether you run this with Terminal or Script Manager or widget, the script relaunches and kills itself after 30 seconds.
#            So you can close the app after 30 seconds and BulletProof Apps continues in the background!
#
# Note: To customize BulletProof frequency, change the "seconds" variable to the number of seconds you want.
#       Valid value is any whole number (no decimals) over 0.
#       Example: If you want it to run every minute, make the line read "seconds=60;".
#       WARNING: Making it too low may suck your battery faster than an Armstrong on a steroid. So don't be a nut.
#
# To verify that it's running, type in Terminal:
# 1. "pstree | grep Bullet" - for init.d script or usage option 2 (with Terminal)
# 2. "pstree | grep sleep" - if using the service or usage option 3 (with Script Manager)
# 3. "cat /proc/*/cmdline | grep Bullet" - Sure-Fire method ;^]
#     The output should be 3 items:
#         a. "/path/to/*97BulletProof_Apps*"
#         b. "BulletProof_Apps_is_In_Effect!" (sleep message)
#         c. "Bullet" (created by your query so this doesn't mean anything)
# 4. "busybox ps | grep Bullet" would give similar results as 3.
#
# This script loads a list of apps via /data/V6_SuperCharger/BulletProof_Apps_HitList.
# You can easily add to or edit the HitList right from your device!
# Just enter a unique segment of the proces name! However, the more info you give, the better ;^]
#
# This ALSO loads /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh.
# Read the comments in that file for "Fine Tuning" instrucions!
#
  ####################################
 #  BulletProof Apps Service Notes  #
####################################
# To leave the BulletProof Apps Service running, insert a # at the beginning of the "stop bullet_service" entry near the middle of this script.
#
# To stop the BulletProof Apps Service, run Terminal Emulator and type...
# "su" and Enter.
# "stop bullet_service" and Enter.
#
# To restart the BulletProof Apps Service, type...
# "su" and Enter.
# "start bullet_service" and Enter.
#
# If the service is running and you type: "cat /proc/*/cmdline | grep Bullet".
# The output would be 3 items:
#     a. "/data/97BulletProof_Apps.sh"
#     b. "BulletProof_Apps_is_In_Effect!" (sleep message)
#     c. "Bullet" (created by your query so this doesn't mean anything)
#
# If it's not running, the output would be the last item ie. "Bullet" which was generated by the typed command.
#
# Similar results can be had with: "busybox ps | grep Bullet".
#
EOF
	if [ ! "$allrcpaths" ]; then
		cat >> /data/97BulletProof_Apps.sh <<EOF
# Ummm... this service won't work on your current ROM. Sorry :P
#
EOF
	fi
	cat >> /data/97BulletProof_Apps.sh <<EOF
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_BulletProof_Apps.log file to see what may have fubarred.
# set -x;
# exec > /data/Log_BulletProof_Apps.log 2>&1;
#
clear;
line=================================================;
mount -o remount,rw /data 2>/dev/null;
busybox mount -o remount,rw /data 2>/dev/null;
# To set the next line manually, see comments at the top for instuctions!
seconds=30;
bpdelay="sleep \$seconds";
if [ "\`busybox ps -w\`" ]; then w=" -w"; fi 2>/dev/null;
BulletProof_Apps(){
	if [ "\`echo \$0 | grep "init\.d"\`" ]; then stop bullet_service; fi
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done;
	echo "" > /data/Ran_BulletProof_Apps.log;
	echo " This should update every 30 seconds!" >> /data/Ran_BulletProof_Apps.log;
	if [ "easyloglulz" ]; then
		echo " \$( date +"%m-%d-%Y %H:%M:%S" ): BulletProofing Apps with \$0!";
		echo "";
		echo \$line;
		echo " -=BulletProof Apps=- script by -=zeppelinrox=-";
		echo \$line;
		echo "";
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*};
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			echo " You are NOT running this script as root...";
			echo "";
			echo \$line;
			echo "                      ...No SuperUser For You!!";
			echo \$line;
			echo "";
			echo "     ...Please Run as Root and try again...";
			echo "";
			echo \$line;
			echo "";
			exit 69;
		elif [ "\`busybox ps | grep Bullet | grep Apps_is\`" ]; then
			echo " BulletProof Apps is already running!";
			echo "";
			exit 69;
		elif [ "\`pgrep scriptmanager\`" ]; then
			sleep 2;
			echo "         DO NOT PUT THIS ON A SCHEDULE!";
			echo "";
			sleep 2;
			echo "    It runs every 30 seconds automatically!";
			echo "    =======================================";
			echo "";
			sleep 2;
		fi;
		echo " To verify that it's working...";
		echo "";
		echo "   ...check out /data/Ran_BulletProof_Apps.log!";
		echo "";
		echo \$line;
		echo " zOOM... zOOM...";
		echo \$line;
		echo "";
		bpapplist=\`cat /data/V6_SuperCharger/BulletProof_Apps_HitList\`;
		for bpapp in \$bpapplist; do
			if [ "\`pgrep \$bpapp\`" ]; then
				for bp in \`pgrep \$bpapp\`; do
					echo -17 > /proc/\$bp/oom_adj;
					echo -1000 > /proc/\$bp/oom_score_adj;
					renice -10 \$bp;
					echo " BulletProofed \$bpapp!";
					echo -n " \$bpapp's oom score is ";
					cat /proc/\$bp/oom_score;
					echo -n " \$bpapp's oom priority is ";
					cat /proc/\$bp/oom_adj;
					cat /proc/\$bp/oom_score_adj;
					echo "";
				done 2>/dev/null;
			else
				echo " Can't find \$bpapp running...";
				echo "             ...so it can't be BulletProofed :(";
				echo "";
			fi;
		done;
		sh /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh;
		echo "         ==============================";
		echo "          ) BulletProofing Complete! (";
		echo "         ==============================";
		echo "";
		echo " Waiting 30 seconds to re-execute... then...";
		echo "";
		echo "                ...Gonna BulletProof Some More!";
		echo "";
		echo \$line;
		echo "    When this happens you can close this app!";
		echo \$line;
		echo "";
		echo " Hold on....";
		echo "";
	fi  | tee -a  /data/Ran_BulletProof_Apps.log;
	\$bpdelay | grep "BulletProof_Apps_is_In_Effect!";
	echo \$line;
	echo "        Ok done! You can close this App!";
	echo \$line;
	echo "";
	if [ "\`busybox --list | grep nohup\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then (busybox nohup \$0 > /dev/null &); exit 0;
	elif [ "\`busybox --list | grep start-stop-daemon\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then busybox start-stop-daemon -S -b -x \$0; exit 0;
	else \$0 > /dev/null & exit 0;
	fi;
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_BulletProof_Apps.log 2>&1;
	BulletProof_Apps &
else BulletProof_Apps;
fi;
exit 0;
EOF
	chown 0.0 /data/97BulletProof_Apps.sh; chmod 777 /data/97BulletProof_Apps.sh
	cp -fr /data/97BulletProof_Apps.sh $storage/V6_SuperCharger
	if [ -d "/system/etc/init.d" ]; then cp -fr /data/97BulletProof_Apps.sh /system/etc/init.d/97BulletProof_Apps
		if [ ! "`diff /data/97BulletProof_Apps.sh /system/etc/init.d/97BulletProof_Apps`" ]; then bpdiff=
			for i in /system/etc/init.d/S*; do Sfiles=$i;break;done
			if [ "$Sfiles" != "/system/etc/init.d/S*" ]; then mv /system/etc/init.d/97BulletProof_Apps /system/etc/init.d/S97BulletProof_Apps; fi
			if [ "$1" ]; then echo " Re-Generating `ls /system/etc/init.d/*BulletProof_Apps* | sed 's/.*etc//'`..."; fi
			cp -fr /system/etc/init.d/*BulletProof_Apps* $storage/V6_SuperCharger
		else bpdiff=yes
		fi
	fi
}
Re_Generate_PowerShift_Script(){
	cat > "/data/V6_SuperCharger/PowerShift_Scripts/$CONFIG-($MB1,$MB2,$MB3,$MB4,$MB5,$MB6)-PowerShift.sh" <<EOF
#!/system/bin/sh
#
# PowerShift Script for use with The V6 SuperCharger created by -=zeppelinrox=-
#
EOF
	terms "/data/V6_SuperCharger/PowerShift_Scripts/$CONFIG-($MB1,$MB2,$MB3,$MB4,$MB5,$MB6)-PowerShift.sh"
	cat >> "/data/V6_SuperCharger/PowerShift_Scripts/$CONFIG-($MB1,$MB2,$MB3,$MB4,$MB5,$MB6)-PowerShift.sh" <<EOF
# SuperMinFree Calculator & MFK Calculator (for min_free_kbytes) created by zeppelinrox also ;^]
#
# See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article!
# See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why 'Free RAM' Is NOT Wasted RAM!"
# See http://goo.gl/4w0ba - MFK Calculator Info - explanation for vm.min_free_kbytes.
#
clear
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
MFK=$MFK
echo ""
echo \$line
echo "    -=PowerShift=- script by -=zeppelinrox=-"
echo \$line
echo ""
sleep 1
id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
	sleep 2
	echo " You are NOT running this script as root..."
	echo ""
	sleep 3
	echo \$line
	echo "                      ...No SuperUser For You!!"
	echo \$line
	echo ""
	sleep 3
	echo "     ...Please Run as Root and try again..."
	echo ""
	echo \$line
	echo ""
	sleep 3
	exit 69
fi
mount -o remount,rw /system 2>/dev/null
busybox mount -o remount,rw /system 2>/dev/null
busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
echo " PowerShifting to a different gear!"
echo ""
sleep 1
echo \$line
awk -F , '{OFMT="%.0f"; print "   Current Minfrees = "\$1/256","\$2/256","\$3/256","\$4/256","\$5/256","\$6/256" MB"}' /sys/module/lowmemorykiller/parameters/minfree
echo \$line
echo ""
sleep 1
echo " Setting LowMemoryKiller to..."
echo ""
sleep 1
echo \$line
echo "         ...$MB1, $MB2, $MB3, $MB4, $MB5, $MB6 MB"
echo \$line
echo ""
sleep 1
echo $scminfree > /sys/module/lowmemorykiller/parameters/minfree
echo $scminfree > /data/V6_SuperCharger/SuperChargerMinfree
echo " OOM Minfree levels are now set to..."
echo ""
sleep 1
echo "         ...\`cat /sys/module/lowmemorykiller/parameters/minfree\`"
echo ""
sleep 1
echo "  They are also your new SuperCharger values!"
echo ""
echo \$line
echo ""
sleep 1
echo " Updating Kernel & Virtual Memory Tweaks..."
echo ""
sleep 1
echo -n "         ...";busybox sysctl -w vm.min_free_kbytes=\$MFK
echo ""
sleep 1
echo \$line
echo " Updating MFK in *99SuperCharger Boot Scripts..."
echo \$line
echo ""
sleep 1
sed -i 's/MFK=.*/MFK=$MFK;/' /system/etc/init.d/*SuperCharger* 2>/dev/null
sed -i 's/MFK=.*/MFK=$MFK;/' /data/99SuperCharger.sh 2>/dev/null
sed -i 's/MFK=.*/MFK=$MFK;/' /system/xbin/99super 2>/dev/null
mount -o remount,ro /system 2>/dev/null
busybox mount -o remount,ro /system 2>/dev/null
busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
echo "          ==========================="
echo "           ) PowerShift Completed! ("
echo "          ==========================="
echo ""
sleep 1
exit 0
EOF
	chown 0.0 /data/V6_SuperCharger/PowerShift_Scripts/*; chmod 777 /data/V6_SuperCharger/PowerShift_Scripts/*
	cp -fr /data/V6_SuperCharger/PowerShift_Scripts $storage/V6_SuperCharger
}
Re_Generate_BulletProof_1Shots(){
	if [ "$1" ]; then bp1shotlist="$1"
	else
		bp1shotlist=`ls /data/V6_SuperCharger/BulletProof_One_Shots | sed 's/.*-\|.sh//g'` 2>/dev/null
		echo $line
		echo " Re-Generating ALL BulletProof One-Shot Scripts!"
		echo $line
		echo ""
		$sleep
	fi
	for bpappname in $bp1shotlist; do
		cat > /data/V6_SuperCharger/BulletProof_One_Shots/1Shot-$bpappname.sh <<EOF
#!/system/bin/sh
#
# BulletProof "One-Shot" Script created by -=zeppelinrox=-
#
EOF
		terms /data/V6_SuperCharger/BulletProof_One_Shots/1Shot-$bpappname.sh
		cat >> /data/V6_SuperCharger/BulletProof_One_Shots/1Shot-$bpappname.sh <<EOF
# Usage: 1. Type in Terminal: "su" and enter, "/data/V6*/Bullet*/1Shot*" and enter. (This runs all 1Shot scripts)
#        2. Script Manager: launch it once like any other script OR with a widget (DO NOT PUT IT ON A SCHEDULE!)
#
# Important! Whether you run this with Terminal or Script Manager or widget, the script relaunches and kills itself after 30 seconds.
#            So you can close the app after 30 seconds and the BulletProof "One-Shot" continues in the background!
#
# To verify that it's running, just run the script again!
# OR you can type in Terminal:
# 1. "pstree | grep 1Shot" - for usage option 1 (with Terminal)
# 2. "pstree | grep sleep" - for usage option 2 (with Script Manager)
# 3. "cat /proc/*/cmdline | grep 1Shot" - Sure-Fire method ;^]
#     The output should be 3 items:
#         a. "/data/V6_SuperCharger/BulletProof_One_Shots/1Shot-$bpappname.sh"
#         b. "1Shot-$bpappname_is_In_Effect!" (sleep message)
#         c. "1Shot" (created by your query so this doesn't mean anything)
# 4. "busybox ps | grep 1Shot" would give similar results as 3.
#
clear
line=================================================
echo ""
echo \$line
echo " -=BulletProof=- \"One-Shot\" by -=zeppelinrox=-"
echo \$line
echo ""
sleep 1
if [ "\`busybox ps -w\`" ]; then w=" -w"; fi 2>/dev/null
id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
	sleep 2
	echo " You are NOT running this script as root..."
	echo ""
	sleep 3
	echo \$line
	echo "                      ...No SuperUser For You!!"
	echo \$line
	echo ""
	sleep 3
	echo "     ...Please Run as Root and try again..."
	echo ""
	echo \$line
	echo ""
	sleep 3
	exit 69
elif [ "\`busybox ps | grep $bpappname | grep $bpappname_is\`" ]; then
	echo " This 1Shot is already running!"
	echo ""
	exit 69
else
	if [ "\`pgrep $bpappname\`" ]; then
		for bp in \`pgrep $bpappname\`; do
			echo -17 > /proc/\$bp/oom_adj
			echo -1000 > /proc/\$bp/oom_score_adj
			renice -10 \$bp
			echo " BulletProofed $bpappname!"
			echo ""
			echo -n " $bpappname's oom score is "
			cat /proc/\$bp/oom_score
			echo ""
			echo -n " $bpappname's oom priority is "
			cat /proc/\$bp/oom_adj
			cat /proc/\$bp/oom_score_adj
			echo ""
		done 2>/dev/null
	else
		echo " Can't find $bpappname running..."
		echo ""
		echo "             ...so it can't be BulletProofed :("
		echo ""
	fi
	sleep 1
	echo "    ======================================="
	echo "     ) BulletProof \"One-Shot\" Completed! ("
	echo "    ======================================="
	echo ""
	sleep 1
	echo " Waiting 30 seconds to re-execute... then..."
	echo ""
	sleep 1
	echo " Gonna BulletProof $bpappname again!"
	echo ""
	sleep 1
	echo \$line
	echo "    When this happens you can close this app!"
	echo \$line
	echo ""
	sleep 1
	echo " Hold on...."
	echo ""
	sleep 30 | grep "1Shot-$bpappname_is_In_Effect!"
	echo \$line
	echo "        Ok done! You can close this App!"
	echo \$line
	echo ""
	sleep 1
	if [ "\`busybox --list | grep nohup\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then (busybox nohup \$0 > /dev/null &); exit 0
	elif [ "\`busybox --list | grep start-stop-daemon\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then busybox start-stop-daemon -S -b -x \$0; exit 0
	fi
fi
\$0 > /dev/null & exit 0
EOF
		if [ "bp1shotlist" ] && [ "bp1shotlist" != "$1" ] && [ ! "$2" ]; then
			echo " Re-Generated 1Shot-$bpappname.sh..."
			$sleep
		fi
	done
	chown 0.0 /data/V6_SuperCharger/BulletProof_One_Shots/*; chmod 777 /data/V6_SuperCharger/BulletProof_One_Shots/*
	cp -fr /data/V6_SuperCharger/BulletProof_One_Shots $storage/V6_SuperCharger
}
Re_Generate_BulletProof_Apps_Fine_Tuner_sh(){
	sed -n '/# Begin/,$p' /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh > /data/bpaft.tmp
	cat > /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh <<EOF
#!/system/bin/sh
#
# BulletProof Apps Fine Tuner created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh
	cat >> /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh <<EOF
# Use this file to "Fine Tune" App Priorities to your liking!
#
# The possible values of oom_adj range from -17 to 15.
# Newer kernels use oom_score_adj instead with values from -1000 to 1000.
# The higher the score, more likely the associated process is to be killed by OOM-killer.
# Basically, the conversion to the new system is oldstyle*1000/17 and the decimal is truncated.
# So if something had an ADJ of 6, it would now be 6*1000/17=352.94118... which truncates down to 352.
#
# A niceness (effects CPU Time) of -20 is the highest priority and 19 is the lowest priority.
# A higher priority process will get a larger chunk of the CPU time than a lower priority process.
# 0 is usually the default niceness for processes and is inherited from its parent process.
#
# In this script, by default, all apps have priorities applied as follows:
# echo -17 > /proc/\`pgrep *com.app.name*\`/oom_adj
# echo -1000 > /proc/\`pgrep *com.app.name*\`/oom_score_adj (one or the other will apply lol)
# renice -10 \`pgrep *com.app.name*\`
# The renice of -10 should be sufficient to keep it snappy but not interfere with other apps that you're using ;^]
#
# At the opposite end, if you wanted something to get killed off easily, you can change it to:
# echo 15 > /proc/\`pgrep *com.app.name*\`/oom_adj
# echo 1000 > /proc/\`pgrep *com.app.name*\`/oom_score_adj (for newer kernels)
# renice 19 \`pgrep *com.app.name*\`
#
# Typically, an app's (Secondary Servers) values (when SuperCharged) are:
# echo 6 > /proc/\`pgrep *com.app.name*\`/oom_adj
# echo 352 > /proc/\`pgrep *com.app.name*\`/oom_score_adj (for newer kernels)
# renice 0 \`pgrep *com.app.name*\`
#
line=================================================;
echo \$line;
echo "     -=BulletProof Apps Fine Tuner Module=-";
echo \$line;
echo "";
echo " Find this in /data/V6_SuperCharger folder...";
echo "";
echo "                       ...read its comments...";
echo "";
echo "             ...and \"Fine Tune\" App Priorities!";
echo "";
echo \$line;
echo "";
id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*};
if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
	echo " You are NOT running this script as root...";
	echo "";
	echo \$line;
	echo "                      ...No SuperUser For You!!";
	echo \$line;
	echo "";
	echo "     ...Please Run as Root and try again...";
	echo "";
	echo \$line;
	echo "";
	exit 69;
fi
`cat /data/bpaft.tmp`
EOF
	rm /data/bpaft.tmp
	chown 0.0 /data/V6_SuperCharger/BulletProof_Apps*; chmod 777 /data/V6_SuperCharger/BulletProof_Apps*
	cp -fr /data/V6_SuperCharger/BulletProof_Apps* $storage/V6_SuperCharger
}
Re_Generate_BulletProof_Fine_Tunes(){
	bpappname=$1
	sed -i '/Begin '$bpappname'/,/End '$bpappname'/d' /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh
	cat >> /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh <<EOF
# Begin $bpappname BulletProofing
if [ "\`pgrep $bpappname\`" ]; then
	for bp in \`pgrep $bpappname\`; do
		echo -17 > /proc/\$bp/oom_adj;
		echo -1000 > /proc/\$bp/oom_score_adj;
		renice -10 \$bp;
		echo " BulletProofed $bpappname!";
		echo -n " $bpappname's oom score is ";
		cat /proc/\$bp/oom_score;
		echo -n " $bpappname's oom priority is ";
		cat /proc/\$bp/oom_adj;
		cat /proc/\$bp/oom_score_adj;
		echo "";
	done 2>/dev/null;
else
	echo " Can't find $bpappname running...";
	echo "             ...so it can't be BulletProofed :(";
	echo "";
fi;
# End $bpappname BulletProofing
EOF
	cp -fr /data/V6_SuperCharger/BulletProof_Apps* $storage/V6_SuperCharger
}
Update_Scripts(){
	if [ "$1" = "vac" ]; then
		if [ -f "/data/V6_SuperCharger/!Detailing.sh" ]; then sed -i '/^detailinterval=/s/=.*/='$detailinterval'/' /data/V6_SuperCharger/!Detailing.sh; fi
		if [ -f "/system/xbin/vac" ]; then sed -i '/^detailinterval=/s/=.*/='$detailinterval'/' /system/xbin/vac; fi
		if [ -f "/system/etc/init.d/92vac" ]; then sed -i '/^detailinterval=/s/=.*/='$detailinterval'/' /system/etc/init.d/92vac; fi
	elif [ "$1" = "zepalign" ]; then
		if [ -f "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then sed -i '/^bootzepalign=/s/=.*/='$zepalign'/' /data/V6_SuperCharger/!WheelAlignment.sh; fi
		if [ -f "/system/xbin/zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='$zepalign'/' /system/xbin/zepalign; fi
		if [ -f "/system/etc/init.d/93zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='$zepalign'/' /system/etc/init.d/93zepalign; fi
	elif [ "$1" = "fixfc" ]; then
		if [ -f "/data/V6_SuperCharger/!FixEmissions.sh" ]; then sed -i '/^bootfixemissions=/s/=.*/='$fixemissions'/' /data/V6_SuperCharger/!FixEmissions.sh; fi
		if [ -f "/system/xbin/fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='$fixemissions'/' /system/xbin/fixfc; fi
		if [ -f "/system/etc/init.d/94fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='$fixemissions'/' /system/etc/init.d/94fixfc; fi
	elif [ "$1" = "fixalign" ]; then
		if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then sed -i '/^bootfixalign=/s/=.*/='$fixalign'/' /data/V6_SuperCharger/!FixAlignment.sh; fi
		if [ -f "/system/xbin/fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='$fixalign'/' /system/xbin/fixalign; fi
		if [ -f "/system/etc/init.d/95fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='$fixalign'/' /system/etc/init.d/95fixalign; fi
	elif [ "$1" = "flush" ]; then
		if [ -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then sed -i '/^flushOmaticHours=/s/=.*/='$flushOmaticHours'/' /data/V6_SuperCharger/!FastEngineFlush.sh; fi
		if [ -f "/system/xbin/flush" ]; then sed -i '/^flushOmaticHours=/s/=.*/='$flushOmaticHours'/' /system/xbin/flush; fi
		if [ -f "/system/etc/init.d/96superflush" ]; then sed -i '/^flushOmaticHours=/s/=.*/='$flushOmaticHours'/' /system/etc/init.d/96superflush; fi
	fi
}
Configure_Detailing(){
	$sleep
	echo " AND you can specify how often it runs..."
	echo ""
	$sleep
	echo "  ...so if you input 4, it runs every 4th boot!"
	echo ""
	$sleep
	echo $line
	echo -n " Current Status: Detailing "
	if [ "$detailinterval" -eq 0 ]; then echo "DOES NOT Run On Boot!"
	else echo "Runs Every $detailinterval Boots!"
	fi
	echo $line
	echo ""
	$sleep
	echo $line
	echo " You can also configure this within the script!"
	echo $line
	echo ""
	$sleep
	echo " Run Detailing on boot?"
	echo " ======================"
	echo ""
	$sleep
	echo -n " Enter Y for Yes, any key for No: "
	read bootdetailing
	echo ""
	echo $line
	case $bootdetailing in
	  y|Y)if [ ! -f "/data/V6_SuperCharger/!Detailing.sh" ]; then
			echo " Detailing has to run once from the menu!"
			echo $line
			echo ""
			$sleep
			echo $line
		  fi
		  while :; do
			echo ""
			$sleep
			echo -n " How often? 1=every boot to 9=every 9th boot: "
			read detailinterval
			echo ""
			echo $line
			case $detailinterval in
			  [1-9])echo "       Detailing Set To Run Every $detailinterval Boots!"
					break;;
				  *)echo "      Invalid entry... Please try again :p"
					echo $line;;
			esac
		  done;;
		*)detailinterval=0
		  echo "           Declined Detailing On Boot!";;
	esac
	Update_Scripts vac
	update_options
}
Configure_WheelAlignment(){
	$sleep
	echo $line
	echo -n " Status: Wheel Alignment "
	if [ "$zepalign" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo $line
	echo ""
	$sleep
	echo $line
	echo " You can also configure this within the script!"
	echo $line
	echo ""
	$sleep
	echo " Run Wheel Alignment on boot?"
	echo " ============================"
	echo ""
	$sleep
	echo " Note: If you say Yes, Fix Alignment On Boot..."
	echo "      ...gets disabled (avoids overlapping mods)"
	echo ""
	$sleep
	echo -n " Enter Y for Yes, any key for No: "
	read bootzepalign
	echo ""
	echo $line
	case $bootzepalign in
	  y|Y)zepalign=1; fixalign=0
		  if [ ! -f "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then
			echo " Wheel Alignment has to run once from the menu!"
			echo $line
			echo ""
			$sleep
			echo $line
		  fi
		  echo "       Wheel Alignment Set To Run On Boot!";;
		*)zepalign=0
		  echo "     Boot Align Declined... does that rhyme?";;
	esac
	Update_Scripts zepalign
	Update_Scripts fixalign
	update_options
}
Configure_FixEmissions(){
	$sleep
	echo $line
	echo -n " Status: Fix Emissions "
	if [ "$fixemissions" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo $line
	echo ""
	$sleep
	echo $line
	echo " You can also configure this within the script!"
	echo $line
	echo ""
	$sleep
	echo " Run Fix Emissions on boot?"
	echo " =========================="
	echo ""
	$sleep
	echo " Note: If you say Yes, Fix Alignment On Boot..."
	echo "      ...gets disabled (avoids overlapping mods)"
	echo ""
	$sleep
	echo -n " Enter Y for Yes, any key for No: "
	read bootfixemissions
	echo ""
	echo $line
	case $bootfixemissions in
	  y|Y)fixemissions=1; fixalign=0
		  if [ ! -f "/data/V6_SuperCharger/!FixEmissions.sh" ]; then
			echo " Fix Emissions has to run once from the menu!"
			echo $line
			echo ""
			$sleep
			echo $line
		  fi
		  echo "        Fix Emissions Set To Run On Boot!";;
		*)fixemissions=0
		  echo "          No FCing Fix On Boot For You!";;
	esac
	Update_Scripts fixfc
	Update_Scripts fixalign
	update_options
}
Configure_FixAlignment(){
	$sleep
	echo $line
	echo -n " Status: Fix Alignment "
	if [ "$fixalign" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo $line
	echo ""
	$sleep
	echo $line
	echo " You can also configure this within the script!"
	echo $line
	echo ""
	$sleep
	echo " Run Fix Alignment on boot?"
	echo " =========================="
	echo ""
	$sleep
	echo " Note 1: If you say Yes..."
	echo "         Wheel Alignment and Fix Emissions..."
	echo "         ...On Boot are automatically disabled!"
	echo ""
	$sleep
	echo " Note 2: If you say No..."
	echo "         Wheel Alignment and Fix Emissions..."
	echo "              ...boot options become available!"
	echo ""
	$sleep
	echo -n " Enter Y for Yes, any key for No: "
	read bootfixalign
	echo ""
	echo $line
	case $bootfixalign in
	  y|Y)fixalign=1; zepalign=0; fixemissions=0
		  if [ ! -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then
			echo " Fix Alignment has to run once from the menu!"
			echo $line
			echo ""
			$sleep
			echo $line
		  fi
		  echo "        Fix Alignment Set To Run On Boot!";;
		*)fixalign=0
		  echo "   Boot Fix Align Declined... does that rhyme?";;
	esac
	Update_Scripts zepalign
	Update_Scripts fixfc
	Update_Scripts fixalign
	update_options
}
Configure_Engine_Flush(){
	echo $line
	echo ""
	$sleep
	echo " Current Status..."
	echo ""
	$sleep
	echo $line
	if [ "$flushOmaticHours" -gt 0 ]; then echo " Engine Flush-O-Matic is ON @ $flushOmaticHours hour intervals!"
	else echo " Engine Flush-O-Matic is Currently OFF!"
	fi
	echo $line
	echo ""
	$sleep
	echo " You can turn it on or off..."
	echo ""
	$sleep
	echo "        ...or just change how often it runs ;^]"
	echo ""
	$sleep
	echo $line
	echo " You can also configure this within the script!"
	echo $line
	echo ""
	$sleep
	if [ -d "/system/etc/init.d" ]; then
		echo " Note that when it's enabled..."
		echo ""
		$sleep
		echo $line
		echo " -=Engine Flush-O-Matic=- on boot is AUTOMAGIC!"
		echo $line
		echo ""
		$sleep
		echo " If disabled, it will Flush once after boot up!"
		echo ""
		$sleep
	fi
	echo " Enable Engine Flush-O-Matic?"
	echo " ============================"
	while :; do
		echo ""
		$sleep
		echo -n " Enter E to Enable, D to Disable: "
		read able
		echo ""
		echo $line
		case $able in
			e|E)if [ ! -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then
					echo " Engine Flush has to run once from the menu!"
					echo $line
					echo ""
					$sleep
					echo $line
				fi
				echo "       -=Engine Flush-O-Matic=- ENABLED!!"
				echo $line
				echo ""
				$sleep
				echo " How often do you want it to flush?"
				while :; do
					echo ""
					$sleep
					echo -n " Enter a value from 1 to 24 (hours): "
					read flushOmaticHours
					echo ""
					echo $line
					case $flushOmaticHours in
					  [1-9]|1[0-9]|2[0-4])echo " Engine Flush-O-Matic Set To Run Every $flushOmaticHours Hours!"
										  break 2;;
										*)echo "      Invalid entry... Please try again :p"
										  echo $line;;
					esac
				done;;
			d|D)flushOmaticHours=0
				echo "       -=Engine Flush-O-Matic=- DISABLED!!"
				break;;
			  *)echo "      Invalid entry... Please try again :p"
				echo $line;;
		esac
	done
	Update_Scripts flush
	update_options
}
Re_Generate_Detailing_sh(){
	cat > /data/V6_SuperCharger/!Detailing.sh <<EOF
#!/system/bin/sh
#
# Detailing Script (SQLite VACUUM & REINDEX to optimize databases) created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/\!Detailing.sh
	cat >> /data/V6_SuperCharger/!Detailing.sh <<EOF
# This will optimize (defrag, reindex, debloat) ALL sqlite3 databases found on your device.
# Resulting in faster database access and less ram usage for smoother performance.
#
# Option 1. By default, this will optimize only databases which were recently changed and probably need it.
#           ie. It won't bother with those that have a modification time older than the log file!
# Option 2. Or, when asked, you can force it to optimize all apps! (Obviously, like other sqlite scripts, this takes longer).
#
# The code is HIGHLY optimized... so it's REALLY FAST!
#
# Get full stats from the log file!
#
# Note: You can change the "detailinterval" variable to any valid value that you want.
#       Valid values are from 1 to 9 (boots).
#       If 0, it won't run on boot.
#       If the value is invalid or missing, it defaults to running every 3rd boot.
#       Example: If you want it to run every 4th boot, make the line read "detailinterval=4".
#
# Props: avgjoemomma (from XDA) for the added reindex bit :)
#
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_Detailing.log file to see what may have fubarred.
# set -x
# exec > /data/Log_Detailing.log 2>&1
#
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
# To set the next line manually, see comments at the top for instuctions!
detailinterval=$detailinterval
if [ ! "\$detailinterval" ] || [ "\`echo \$detailinterval | grep "[^0-9]"\`" ] || [ "\$detailinterval" -gt 9 ]; then detailinterval=3; fi
counterfile=/data/!Detailing_Counter
counter1=\`cat \$counterfile | awk 'NR==1{print}'\` 2>/dev/null
Configure(){
	echo ""
	echo " Detailing On Boot..."
	echo " ===================="
	echo ""
	sleep 1
	echo " If desired, you can change Detailing options.."
	echo ""
	sleep 1
	echo "        ...this script is VERY sophisticated..."
	echo ""
	sleep 1
	echo "           ...so boot time would be unaffected!"
	echo ""
	sleep 1
	echo " AND you can specify how often it runs..."
	echo ""
	sleep 1
	echo "  ...so if you input 4, it runs every 4th boot!"
	echo ""
	sleep 1
	echo \$line
	echo -n " Current Status: Detailing "
	if [ "\$detailinterval" -eq 0 ]; then echo "DOES NOT Run On Boot!"
	else echo "Runs Every \$detailinterval Boots!"
	fi
	echo \$line
	echo ""
	sleep 1
	echo " You can also configure this in Driver Options!"
	echo ""
	sleep 1
	echo \$line
	echo "   Also READ THE COMMENTS inside this script!"
	echo \$line
	echo ""
	sleep 1
	echo " Change Detailing Options?"
	echo ""
	sleep 1
	echo -n " Enter Y for Yes, any key for No: "
	read changeoptions
	echo ""
	echo \$line
	case \$changeoptions in
		y|Y)mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
			echo ""
			sleep 1
			echo " Run Detailing on boot?"
			echo ""
			sleep 1
			echo -n " Enter Y for Yes, any key for No: "
			read bootdetailing
			echo ""
			case \$bootdetailing in
			  y|Y)while :; do
					echo \$line
					echo ""
					sleep 1
					echo -n " How often? 1=every boot to 9=every 9th boot: "
					read detailinterval
					echo ""
					echo \$line
					case \$detailinterval in
					  [1-9])echo "       Detailing Set To Run Every \$detailinterval Boots!"
							break;;
						  *)echo "      Invalid entry... Please try again :p";;
					esac
				  done;;
				*)detailinterval=0
				  echo "           Declined Detailing On Boot!";;
			esac
			sed -i '/^detailinterval=/s/=.*/='\$detailinterval'/' \$0
			if [ "\$0" != "/data/V6_SuperCharger/!Detailing.sh" ]; then sed -i '/^detailinterval=/s/=.*/='\$detailinterval'/' /data/V6_SuperCharger/!Detailing.sh; fi 2>/dev/null
			if [ "\$0" != "/system/xbin/vac" ]; then sed -i '/^detailinterval=/s/=.*/='\$detailinterval'/' /system/xbin/vac; fi 2>/dev/null
			if [ "\$0" != "/system/etc/init.d/92vac" ]; then sed -i '/^detailinterval=/s/=.*/='\$detailinterval'/' /system/etc/init.d/92vac; fi 2>/dev/null
			if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
				awk 'BEGIN{OFS=FS=","}{\$7='\$detailinterval';print}' /data/V6_SuperCharger/SuperChargerOptions > /data/V6_SuperCharger/SuperChargerOptions.tmp
				mv /data/V6_SuperCharger/SuperChargerOptions.tmp /data/V6_SuperCharger/SuperChargerOptions
			fi
			mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;;
		  *)echo "               No Change For You!";;
	esac
	echo \$line
	sleep 1
}
install(){
	if [ ! -f "\$1" ]; then
		echo ""
		echo " Installing myself to \${1#*etc}"
		sleep 2
		mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		dd if=\$0 of=\$1
		chown 0.0 \$1; chmod 777 \$1
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	elif [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " \$1 is already installed..."
		sleep 2
	fi
	if [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " To run, type in Terminal: \"su -c \${1##*/}\""
		sleep 2
	fi
}
Details_Details(){
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done
	if [ "\`echo \$0 | grep "init\.d"\`" ]; then
		if [ "\$detailinterval" -eq 0 ]; then exit 69; fi
		if [ ! "\$counter1" ] || [ "\$counter1" -ge "\$detailinterval" ]; then counter2=1
			echo "\$counter2" > \$counterfile
			echo " SQLite databases are optimized at \$detailinterval boot intervals!" >> \$counterfile
			echo "" >> \$counterfile
			echo " Detailing ran on the most recent boot..." >> \$counterfile
			echo " It was executed on \`date\`" >> \$counterfile
			echo "" >> \$counterfile
		else counter2=\$((\$counter1+1))
			sed -i '1s/'\$counter1'/'\$counter2'/' \$counterfile
			echo " Detailing last ran \$counter2 reboots ago..." >> \$counterfile
			echo " It exited peacefully on \`date\`" >> \$counterfile
			echo "" >> \$counterfile
			exit 69
		fi
	else
		if [ -d "/system/etc/init.d" ]; then install /system/etc/init.d/92vac; fi
		echo 1 > \$counterfile
		echo " SQLite databases are optimized at \$detailinterval boot intervals!" >> \$counterfile
		echo "" >> \$counterfile
		echo " Detailing was run manually so the counter has been reset..." >> \$counterfile
		echo " It was executed on \`date\`" >> \$counterfile
		echo "" >> \$counterfile
	fi
	if [ ! "\`echo \$0 | grep xbin\`" ]; then install /system/xbin/vac; fi
	LOG_FILE=/data/Ran_Detailing.log
	lastran=/data/!Detailing_Last_Ran
	mv \$LOG_FILE \$lastran 2>/dev/null
	if [ "easyloglulz" ]; then
		echo ""
		echo \$line
		echo "    -=Detailing=- script by -=zeppelinrox=-"
		echo \$line
		echo ""
		sleep 2
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			sleep 1
			echo " You are NOT running this script as root..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No SuperUser For You!!"
			echo \$line
			echo ""
			sleep 3
			echo "     ...Please Run as Root and try again..."
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ ! "\`which sqlite3\`" ]; then
			sleep 1
			echo " Doh... sqlite3 binary was NOT found..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No Vacuuming For You!!"
			echo \$line
			echo ""
			sleep 3
			echo " Load the XDA SuperCharger thread..."
			echo ""
			sleep 3
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			echo \$line
			echo ""
			sleep 3
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://$storage/!SuperCharger.html"
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ -f "\$lastran" ]; then
			echo " Optimize ALL databases or recently changed?"
			echo ""
			sleep 1
			echo -n " Enter (A)LL, any key for recently modified: "
			stty -icanon min 0 time 200
			read how
			stty sane
			if [ ! "\$how" ]; then echo ""; fi
			echo ""
			case \$how in
				a|A)rm \$lastran;;
				  *);;
			esac
			echo \$line
			echo ""
			sleep 1
		fi
		echo " Commencing SQLite VACUUM & REINDEX!"
		echo ""
		sleep 1
		echo " Please IGNORE any errors that say..."
		echo "        ======"
		echo ""
		sleep 1
		echo " \"malformed database\" OR \"collation sequence\"!"
		echo "  ==================      =================="
		echo ""
		sleep 1
		echo "   ...as they won't effect SQLite Optimization!"
		echo ""
		sleep 1
		echo \$line
		echo " This may take awhile... please wait..."
		echo \$line
		echo ""
		sleep 1
	fi | tee \$LOG_FILE
	busybox find /*d*/ -iname "*.db" > /data/dbs.tmp
	TOTAL=\`cat /data/dbs.tmp | wc -l\`
	START=\`busybox date +%s\`
	BEGAN=\`date\`
	OPTIMIZED=0
	INCREMENT=3
	PROGRESS=0
	PROGRESS_BAR=""
	echo " Start Detailing: \$BEGAN" >> \$LOG_FILE
	echo "" >> \$LOG_FILE
	busybox sync
	while read db; do
		PROGRESS=\$((\$PROGRESS+1))
		PERCENT=\$(( \$PROGRESS * 100 / \$TOTAL ))
		if [ "\$PERCENT" -eq "\$INCREMENT" ]; then
			INCREMENT=\$(( \$INCREMENT + 3 ))
			PROGRESS_BAR="\$PROGRESS_BAR="
		fi
		clear
		echo ""
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo "        -=Detailing=- by -=zeppelinrox=-"
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo ""
		echo "        Processing DBs - \$PERCENT% (\$PROGRESS of \$TOTAL)"
		echo ""
		echo "     Needed Optimizing - \$OPTIMIZED"
		echo ""
		if [ ! -f "\$lastran" ] || [ "\$db" -nt "\$lastran" ]; then
			OPTIMIZED=\$((\$OPTIMIZED+1))
			echo "  VACUUMING: \$db" | tee -a \$LOG_FILE
			sqlite3 \$db 'VACUUM;' | tee -a \$LOG_FILE;
			echo " REINDEXING: \$db" | tee -a \$LOG_FILE
			sqlite3 \$db 'REINDEX;' | tee -a \$LOG_FILE;
		fi
	done < /data/dbs.tmp
	busybox sync
	rm /data/dbs.tmp
	rm \$lastran 2>/dev/null
	STOP=\`busybox date +%s\`
	ENDED=\`date\`
	RUNTIME=\`busybox expr \$STOP - \$START\`
	HOURS=\`busybox expr \$RUNTIME / 3600\`
	REMAINDER=\`busybox expr \$RUNTIME % 3600\`
	MINS=\`busybox expr \$REMAINDER / 60\`
	SECS=\`busybox expr \$REMAINDER % 60\`
	RUNTIME=\`busybox printf "%02d:%02d:%02d\n" "\$HOURS" "\$MINS" "\$SECS"\`
	echo "" | tee -a \$LOG_FILE
	echo \$line | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " ALL \$TOTAL Databases for ALL Apps are Optimized!" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo " Optimized \$OPTIMIZED! (Were modified since last run)" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo "                 ...Say Hello To Optimized DBs!"
	echo ""
	echo \$line
	echo ""
	sleep 1
	echo "      Start Time: \$BEGAN" | tee -a \$LOG_FILE
	echo "       Stop Time: \$ENDED" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo " Completion Time: \$RUNTIME" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " See \$LOG_FILE for more details!"
	echo ""
	sleep 1
	echo "           ==========================" | tee -a \$LOG_FILE
	echo "            ) Detailing Completed! (" | tee -a \$LOG_FILE
	echo "           ==========================" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo ""
	sleep 1
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_Detailing.log 2>&1
	Details_Details & exit 0
fi
if [ -d "/system/etc/init.d" ]; then Configure; fi
Details_Details
exit 0
EOF
	chown 0.0 /data/V6_SuperCharger/!Detailing.sh; chmod 777 /data/V6_SuperCharger/!Detailing.sh
	cp -fr /data/V6_SuperCharger/!Detailing.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!Detailing.sh $storage/V6_SuperCharger/vac
	if [ "$1" ]; then echo " Re-Generating /system/xbin/vac..."; fi
	cp -fr /data/V6_SuperCharger/!Detailing.sh /system/xbin/vac
	if [ -d "/system/etc/init.d" ]; then
		if [ "$1" ]; then echo " Re-Generating /init.d/92vac..."; fi
		cp -fr /data/V6_SuperCharger/!Detailing.sh /system/etc/init.d/92vac
		cp -fr /data/V6_SuperCharger/!Detailing.sh $storage/V6_SuperCharger/92vac
	fi
}
Re_Generate_WheelAlignment_sh(){
	cat > /data/V6_SuperCharger/!WheelAlignment.sh <<EOF
#!/system/bin/sh
#
# "ZepAlign" / Wheel Alignment Script (ZipAlign) created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/\!WheelAlignment.sh
	cat >> /data/V6_SuperCharger/!WheelAlignment.sh <<EOF
# ZipAligns all data and system apks (apps) that have not yet been ZipAligned.
# ZipAlign optimizes all your apps, resulting in less RAM comsumption and a faster device! ;^]
#
# Option 1. By default, this will check and/or zipalign only apks which were recently added and may need it.
# Option 2. Or, when asked, you can force it to zipalign all apks! (Obviously, this takes a bit longer).
#
# The code is HIGHLY optimized... so it's REALLY FAST!
#
# Get full stats from the log file!
#
# Tweaks & Enhancements by zeppelinrox...
#      - Added BRAINS: By default, it will only check apks that were added since last run (ie. newer than the log file!)
#      - Added support for /vendor/app (POST-ICS)
#      - Added support for /mnt/asec
#      - Added support for more data directories ie. dbdata, datadata, etc.
#      - Added debugging
#      - Tweaked interface... just a bit ;^]
#
# Props: Automatic ZipAlign by Wes Garner (original script)
#        oknowton for the change from MD5 to zipalign -c 4
#
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_ZepAlign.log file to see what may have fubarred.
# set -x
# exec > /data/Log_ZepAlign.log 2>&1
#
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
bootupdelay="sleep 180"
# Next line only applies to the init.d boot script. "bootzepalign=1" means run on boot. Anything else disables it.
bootzepalign=$zepalign
Configure(){
	echo ""
	echo " Wheel Alignment On Boot..."
	echo " =========================="
	echo ""
	sleep 1
	echo " If desired, you can change boot options.."
	echo ""
	sleep 1
	echo "        ...this script is VERY sophisticated..."
	echo ""
	sleep 1
	echo "           ...so boot time would be unaffected!"
	echo ""
	sleep 1
	echo \$line
	echo -n " Status: Wheel Alignment "
	if [ "\$bootzepalign" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo \$line
	echo ""
	sleep 1
	echo " You can also configure this in Driver Options!"
	echo ""
	sleep 1
	echo \$line
	echo "   Also READ THE COMMENTS inside this script!"
	echo \$line
	echo ""
	sleep 1
	echo " Change Wheel Alignment Options?"
	echo ""
	sleep 1
	echo -n " Enter Y for Yes, any key for No: "
	read changeoptions
	echo ""
	echo \$line
	case \$changeoptions in
		y|Y)mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
			echo ""
			sleep 1
			echo " Run Wheel Alignment on boot?"
			echo ""
			sleep 1
			echo " Note: If you say Yes, Fix Alignment On Boot..."
			echo "      ...gets disabled (avoids overlapping mods)"
			echo ""
			sleep 1
			echo -n " Enter Y for Yes, any key for No: "
			read bootzepalign
			echo ""
			echo \$line
			case \$bootzepalign in
			  y|Y)zepalign=1; fixalign=0
				  echo "       Wheel Alignment Set To Run On Boot!";;
				*)zepalign=0
				  echo "     Boot Align Declined... does that rhyme?";;
			esac
			sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' \$0
			if [ "\$0" != "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /data/V6_SuperCharger/!WheelAlignment.sh; fi 2>/dev/null
			if [ "\$0" != "/system/xbin/zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /system/xbin/zepalign; fi 2>/dev/null
			if [ "\$0" != "/system/etc/init.d/93zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /system/etc/init.d/93zepalign; fi 2>/dev/null
			if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /data/V6_SuperCharger/!FixAlignment.sh; fi
			if [ -f "/system/xbin/fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/xbin/fixalign; fi
			if [ -f "/system/etc/init.d/95fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/etc/init.d/95fixalign; fi
			if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
				awk 'BEGIN{OFS=FS=","}{\$8='\$zepalign',\$10='\$fixalign';print}' /data/V6_SuperCharger/SuperChargerOptions > /data/V6_SuperCharger/SuperChargerOptions.tmp
				mv /data/V6_SuperCharger/SuperChargerOptions.tmp /data/V6_SuperCharger/SuperChargerOptions
			fi
			mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;;
		  *)echo "               No Change For You!";;
	esac
	echo \$line
	sleep 1
}
install(){
	if [ ! -f "\$1" ]; then
		echo ""
		echo " Installing myself to \${1#*etc}"
		sleep 2
		mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		dd if=\$0 of=\$1
		chown 0.0 \$1; chmod 777 \$1
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	elif [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " \$1 is already installed..."
		sleep 2
	fi
	if [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " To run, type in Terminal: \"su -c \${1##*/}\""
		sleep 2
	fi
}
ZepAlign(){
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done
	if [ "\`echo \$0 | grep "init\.d"\`" ] && [ "\$bootzepalign" -ne 1 ]; then exit 69
	elif [ "\`echo \$0 | grep "init\.d"\`" ]; then \$bootupdelay
	elif [ -d "/system/etc/init.d" ]; then install /system/etc/init.d/93zepalign
	fi
	if [ ! "\`echo \$0 | grep xbin\`" ]; then install /system/xbin/zepalign; fi
	LOG_FILE=/data/Ran_ZepAlign.log
	lastran=/data/!ZepAlign_Last_Ran
	mv \$LOG_FILE \$lastran 2>/dev/null
	if [ "easyloglulz" ]; then
		echo ""
		echo \$line
		echo "  -=Wheel Alignment=- script by -=zeppelinrox=-"
		echo \$line
		echo ""
		sleep 2
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			sleep 1
			echo " You are NOT running this script as root..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No SuperUser For You!!"
			echo \$line
			echo ""
			sleep 3
			echo "     ...Please Run as Root and try again..."
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ ! "\`which zipalign\`" ]; then
			sleep 1
			echo " Doh... zipalign binary was NOT found..."
			echo ""
			sleep 3
			echo \$line
			echo "                    ...No ZepAligning For You!!"
			echo \$line
			echo ""
			sleep 3
			echo " Load the XDA SuperCharger thread..."
			echo ""
			sleep 3
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			echo \$line
			echo ""
			sleep 3
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://$storage/!SuperCharger.html"
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ -f "\$lastran" ]; then
			echo " ZipAlign ALL Apps or only recently installed?"
			echo ""
			sleep 1
			echo -n " Enter (A)LL, any key for recently added: "
			stty -icanon min 0 time 200
			read how
			stty sane
			if [ ! "\$how" ]; then echo ""; fi
			echo ""
			case \$how in
				a|A)rm \$lastran;;
				  *);;
			esac
			echo \$line
			echo ""
			sleep 1
		fi
	fi | tee \$LOG_FILE
	mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	START=\`busybox date +%s\`
	BEGAN=\`date\`
	TOTAL=\$((\`ls /d*/*/*.apk | wc -l\`+\`ls /system/*/*.apk | wc -l\`+\`ls /vendor/*/*.apk | wc -l\`+\`ls /mnt/asec/*/*.apk | wc -l\`)) 2>/dev/null
	INCREMENT=3
	PROGRESS=0
	PROGRESS_BAR=""
	NEW=0; ALIGNED=0; ALREADY=0; FAILED=0; SKIPPED=0
	echo " Start Wheel Alignment ( \"ZepAlign\" ): \$BEGAN" >> \$LOG_FILE
	echo "" >> \$LOG_FILE
	busybox sync
	for apk in /d*/*/*.apk /system/*/*.apk /vendor/*/*.apk /mnt/asec/*/*.apk; do
		PROGRESS=\$((\$PROGRESS+1))
		PERCENT=\$(( \$PROGRESS * 100 / \$TOTAL ))
		if [ "\$PERCENT" -eq "\$INCREMENT" ]; then
			INCREMENT=\$(( \$INCREMENT + 3 ))
			PROGRESS_BAR="\$PROGRESS_BAR="
		fi
		clear
		echo ""
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo "       Wheel Alignment by -=zeppelinrox=-"
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo ""
		echo "       Processing APKs - \$PERCENT% (\$PROGRESS of \$TOTAL)"
		echo ""
		if [ ! -f "\$lastran" ] || [ "\$apk" -nt "\$lastran" ] && [ -f "\$apk" ]; then NEW=\$((\$NEW+1))
			if [ "\$(busybox basename \$apk)" = "framework-res.apk" ] || [ "\$(busybox basename \$apk)" = "SystemUI.apk" ] || [ "\$(busybox basename \$apk)" = "com.htc.resources.apk" ]; then
				echo " NOT ZipAligning (Problematic) \$apk..." | tee -a \$LOG_FILE
				SKIPPED=\$((\$SKIPPED+1))
				skippedapp=\`echo "\$skippedapp, \$(busybox basename \$apk)" | sed 's/^, //'\`
			else
				zipalign -c 4 \$apk
				ZIPCHECK=\$?
				if [ "\$ZIPCHECK" -eq 1 ]; then
					echo " ZipAligning \$apk..." | tee -a \$LOG_FILE
					zipalign -f 4 \$apk /cache/\$(busybox basename \$apk)
					rc="\$?"
					if [ "\$rc" -eq 0 ]; then
						if [ -e "/cache/\$(busybox basename \$apk)" ]; then
							busybox cp -f -p /cache/\$(busybox basename \$apk) \$apk | tee -a \$LOG_FILE
							ALIGNED=\$((\$ALIGNED+1))
						else
							echo " ZipAligning \$apk... Failed (No Output File!)" | tee -a \$LOG_FILE
							FAILED=\$((\$FAILED+1))
							failedapp=\`echo "\$failedapp, \$(busybox basename \$apk)" | sed 's/^, //'\`
						fi
					else echo " ZipAligning \$apk... Failed (rc: \$rc!)" | tee -a \$LOG_FILE
						FAILED=\$((\$FAILED+1))
						failedapp=\`echo "\$failedapp, \$(busybox basename \$apk)" | sed 's/^, //'\`
					fi
					if [ -e "/cache/\$(busybox basename \$apk)" ]; then busybox rm /cache/\$(busybox basename \$apk); fi
				else
					echo " ZipAlign already completed on \$apk" | tee -a \$LOG_FILE
					ALREADY=\$((\$ALREADY+1))
				fi
			fi
		fi
	done
	busybox sync
	rm \$lastran 2>/dev/null
	mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	STOP=\`busybox date +%s\`
	ENDED=\`date\`
	RUNTIME=\`busybox expr \$STOP - \$START\`
	HOURS=\`busybox expr \$RUNTIME / 3600\`
	REMAINDER=\`busybox expr \$RUNTIME % 3600\`
	MINS=\`busybox expr \$REMAINDER / 60\`
	SECS=\`busybox expr \$REMAINDER % 60\`
	RUNTIME=\`busybox printf "%02d:%02d:%02d\n" "\$HOURS" "\$MINS" "\$SECS"\`
	echo "" | tee -a \$LOG_FILE
	echo \$line | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " Done \"ZepAligning\" ALL data and system APKs..." | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " \$NEW	Apps were checked (added since last run)" | tee -a \$LOG_FILE
	echo " \$ALIGNED	Apps were zipaligned" | tee -a \$LOG_FILE
	echo " \$ALREADY	Apps were already zipaligned" | tee -a \$LOG_FILE
	echo " \$FAILED	Apps were NOT zipaligned due to error" | tee -a \$LOG_FILE
	if [ "\$failedapp" ]; then echo "	(\$failedapp)" | tee -a \$LOG_FILE; fi
	echo " \$SKIPPED	Problematic Apps were skipped" | tee -a \$LOG_FILE
	if [ "\$skippedapp" ]; then echo "	(\$skippedapp)" | tee -a \$LOG_FILE; fi
	echo "" | tee -a \$LOG_FILE
	echo " \$TOTAL	Apps were processed!" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo "                ...Say Hello To Optimized Apps!"
	echo ""
	echo \$line
	echo ""
	sleep 1
	echo "      Start Time: \$BEGAN" | tee -a \$LOG_FILE
	echo "       Stop Time: \$ENDED" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo " Completion Time: \$RUNTIME" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " See \$LOG_FILE for more details!"
	echo ""
	sleep 1
	echo "        ================================" | tee -a \$LOG_FILE
	echo "         ) Wheel Alignment Completed! (" | tee -a \$LOG_FILE
	echo "        ================================" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_ZepAlign.log 2>&1
	ZepAlign & exit 0
fi
if [ -d "/system/etc/init.d" ]; then Configure; fi
ZepAlign
exit 0
EOF
	chown 0.0 /data/V6_SuperCharger/!WheelAlignment.sh; chmod 777 /data/V6_SuperCharger/!WheelAlignment.sh
	cp -fr /data/V6_SuperCharger/!WheelAlignment.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!WheelAlignment.sh $storage/V6_SuperCharger/zepalign
	if [ "$1" ]; then echo " Re-Generating /system/xbin/zepalign..."; fi
	cp -fr /data/V6_SuperCharger/!WheelAlignment.sh /system/xbin/zepalign
	if [ -d "/system/etc/init.d" ]; then
		if [ "$1" ]; then echo " Re-Generating /init.d/93zepalign..."; fi
		cp -fr /data/V6_SuperCharger/!WheelAlignment.sh /system/etc/init.d/93zepalign
		cp -fr /data/V6_SuperCharger/!WheelAlignment.sh $storage/V6_SuperCharger/93zepalign
	fi
}
Re_Generate_FixEmissions_sh(){
	cat > /data/V6_SuperCharger/!FixEmissions.sh <<EOF
#!/system/bin/sh
#
# Fix Emissions Script (Fix Permissions) created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/\!FixEmissions.sh
	cat >> /data/V6_SuperCharger/!FixEmissions.sh <<EOF
# Sets permissions for android data directories and apks.
# This should fix app force closes (FCs).
#
# The code is HIGHLY optimized... so it's REALLY FAST! - setting permissions for 300 apps in approximately 1 minute.
#
# Get full stats from the log file!
#
# Tweaks & Enhancements by zeppelinrox...
#      - Only applies permissions if they are not what they're supposed to be!
#      - Removed the usage of the "pm list packages" command - it didn't work on boot.
#      - Added support for /vendor/app (POST-ICS).
#      - No longer excludes framework-res.apk or com.htc.resources.apk
#      - Added support for more data directories ie. dbdata, datadata, etc.
#      - Added debugging.
#      - Enhanced logging!
#      - Tweaked interface... just a bit ;^]
#
# Props: Originally and MOSTLY (erm... something like 75% of it lol) by Jared Rummler (JRummy16).
# However, I actually meshed together 3 different Fix Permissions scripts and added my own spices ;^]
#
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_FixEmissions.log file to see what may have fubarred.
# set -x
# exec > /data/Log_FixEmissions.log 2>&1
#
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
bootupdelay="sleep 300"
# Next line only applies to the init.d boot script. "bootfixemissions=1" means run on boot. Anything else disables it.
bootfixemissions=$fixemissions
Configure(){
	echo ""
	echo " Fix Emissions On Boot..."
	echo " ========================"
	echo ""
	sleep 1
	echo " If desired, you can change boot options.."
	echo ""
	sleep 1
	echo "        ...this script is VERY sophisticated..."
	echo ""
	sleep 1
	echo "           ...so boot time would be unaffected!"
	echo ""
	sleep 1
	echo \$line
	echo -n " Status: Fix Emissions "
	if [ "\$bootfixemissions" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo \$line
	echo ""
	sleep 1
	echo " You can also configure this in Driver Options!"
	echo ""
	sleep 1
	echo \$line
	echo "   Also READ THE COMMENTS inside this script!"
	echo \$line
	echo ""
	sleep 1
	echo " Change Fix Emissions Options?"
	echo ""
	sleep 1
	echo -n " Enter Y for Yes, any key for No: "
	read changeoptions
	echo ""
	echo \$line
	case \$changeoptions in
		y|Y)mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
			echo ""
			sleep 1
			echo " Run Fix Emissions on boot?"
			echo ""
			sleep 1
			echo " Note: If you say Yes, Fix Alignment On Boot..."
			echo "      ...gets disabled (avoids overlapping mods)"
			echo ""
			sleep 1
			echo -n " Enter Y for Yes, any key for No: "
			read bootfixemissions
			echo ""
			echo \$line
			case \$bootfixemissions in
			  y|Y)fixemissions=1; fixalign=0
				  echo "        Fix Emissions Set To Run On Boot!";;
				*)fixemissions=0
				  echo "          No FCing Fix On Boot For You!";;
			esac
			sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' \$0
			if [ "\$0" != "/data/V6_SuperCharger/!FixEmissions.sh" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /data/V6_SuperCharger/!FixEmissions.sh; fi 2>/dev/null
			if [ "\$0" != "/system/xbin/fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /system/xbin/fixfc; fi 2>/dev/null
			if [ "\$0" != "/system/etc/init.d/94fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /system/etc/init.d/94fixfc; fi 2>/dev/null
			if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /data/V6_SuperCharger/!FixAlignment.sh; fi
			if [ -f "/system/xbin/fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/xbin/fixalign; fi
			if [ -f "/system/etc/init.d/95fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/etc/init.d/95fixalign; fi
			if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
				awk 'BEGIN{OFS=FS=","}{\$9='\$fixemissions',\$10='\$fixalign';print}' /data/V6_SuperCharger/SuperChargerOptions > /data/V6_SuperCharger/SuperChargerOptions.tmp
				mv /data/V6_SuperCharger/SuperChargerOptions.tmp /data/V6_SuperCharger/SuperChargerOptions
			fi
			mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;;
		  *)echo "               No Change For You!";;
	esac
	echo \$line
	sleep 1
}
install(){
	if [ ! -f "\$1" ]; then
		echo ""
		echo " Installing myself to \${1#*etc}"
		sleep 2
		mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		dd if=\$0 of=\$1
		chown 0.0 \$1; chmod 777 \$1
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	elif [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " \$1 is already installed..."
		sleep 2
	fi
	if [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " To run, type in Terminal: \"su -c \${1##*/}\""
		sleep 2
	fi
}
Fix_Emissions(){
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done
	if [ "\`echo \$0 | grep "init\.d"\`" ] && [ "\$bootfixemissions" -ne 1 ]; then exit 69
	elif [ "\`echo \$0 | grep "init\.d"\`" ]; then \$bootupdelay
	elif [ -d "/system/etc/init.d" ]; then install /system/etc/init.d/94fixfc
	fi
	if [ ! "\`echo \$0 | grep xbin\`" ]; then install /system/xbin/fixfc; fi
	LOG_FILE=/data/Ran_FixEmissions.log
	if [ "easyloglulz" ]; then
		echo ""
		echo \$line
		echo "   -=Fix Emissions=- script by -=zeppelinrox=-"
		echo \$line
		echo ""
		sleep 2
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			sleep 1
			echo " You are NOT running this script as root..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No SuperUser For You!!"
			echo \$line
			echo ""
			sleep 3
			echo "     ...Please Run as Root and try again..."
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		fi
	fi | tee \$LOG_FILE
	mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	START=\`busybox date +%s\`
	BEGAN=\`date\`
	TOTAL=\`cat /d*/system/packages.xml | grep -c "^<package.*serId"\`
	INCREMENT=3
	PROGRESS=0
	PROGRESS_BAR=""
	echo " Start Fix Emissions: \$BEGAN" >> \$LOG_FILE
	echo "" >> \$LOG_FILE
	echo " Setting & Fixing Permissions For..." >> \$LOG_FILE
	echo "" >> \$LOG_FILE
	busybox sync
	grep "^<package.*serId" /d*/system/packages.xml | while read pkgline; do
		PKGNAME=\`echo \$pkgline | sed 's%.* name="\(.*\)".*%\1%' | cut -d '"' -f1\`
		CODEPATH=\`echo \$pkgline | sed 's%.* codePath="\(.*\)".*%\1%' |  cut -d '"' -f1\`
		DATAPATH=/d*/d*/\$PKGNAME
		PKGUID=\`echo \$pkgline | sed 's%.*serId="\(.*\)".*%\1%' | cut -d '"' -f1\`
		PROGRESS=\$((\$PROGRESS+1))
		PERCENT=\$(( \$PROGRESS * 100 / \$TOTAL ))
		if [ "\$PERCENT" -eq "\$INCREMENT" ]; then
			INCREMENT=\$(( \$INCREMENT + 3 ))
			PROGRESS_BAR="\$PROGRESS_BAR="
		fi
		clear
		echo ""
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo "       \"Fix Emissions\" by -=zeppelinrox=-"
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo ""
		echo "       Processing Apps - \$PERCENT% (\$PROGRESS of \$TOTAL)"
		echo ""
		echo " Setting & Fixing Permissions For..."
		echo ""
		echo " ...\$PKGNAME"
		echo " \$PKGNAME (\$CODEPATH)" >> \$LOG_FILE
		if [ -e "\$CODEPATH" ]; then
			APPDIR=\`busybox dirname \$CODEPATH\`
			if [ "\$APPDIR" = "/system/app" ] || [ "\$APPDIR" = "/vendor/app" ] || [ "\$APPDIR" = "/system/framework" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "0 0" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*644"\`" ]; then
				chown 0:0 \$CODEPATH
				chmod 644 \$CODEPATH
			elif [ "\$APPDIR" = "`ls -d /d*/app`" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "1000 1000" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*644"\`" ]; then
				chown 1000:1000 \$CODEPATH
				chmod 644 \$CODEPATH
			elif [ "\$APPDIR" = "`ls -d /d*/app-private`" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "1000 \$PKGUID" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*640"\`" ]; then
				chown 1000:\$PKGUID \$CODEPATH
				chmod 640 \$CODEPATH
			fi
			if [ -d "\$DATAPATH" ]; then
				if [ "\`busybox stat -t \$DATAPATH | awk '{print \$5,\$6}'\`" != "\$PKGUID \$PKGUID" ] && [ ! "\`busybox stat \$DATAPATH | grep "Access.*755"\`" ]; then
					chown \$PKGUID:\$PKGUID \$DATAPATH
					chmod 755 \$DATAPATH
				fi
				DIRS=\`busybox find \$DATAPATH -mindepth 1 -type d\`
				for file in \$DIRS; do
					PERM=755
					NEWUID=\$PKGUID
					NEWGID=\$PKGUID
					FNAME=\`busybox basename \$file\`
					case \$FNAME in
							lib)if [ ! "\`busybox stat \$file | grep "Access.*755"\`" ]; then chmod 755 \$file; fi
								NEWUID=1000
								NEWGID=1000
								PERM=755;;
		 shared_prefs|databases)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=660;;
						  cache)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=600;;
						  files)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=775;;
							  *)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=771;;
					esac
					if [ "\`busybox stat -t \$file | awk '{print \$5,\$6}'\`" != "\$NEWUID \$NEWGID" ]; then chown \$NEWUID:\$NEWGID \$file; fi
					busybox find \$file -type f -maxdepth 2 ! -perm \$PERM -exec chmod \$PERM {} ';'
					busybox find \$file -type f -maxdepth 1 ! -user \$NEWUID -exec chown \$NEWUID {} ';'
					busybox find \$file -type f -maxdepth 1 ! -group \$NEWGID -exec chown :\$NEWGID {} ';'
				done
			fi
		fi | tee -a \$LOG_FILE
	done
	busybox sync
	mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	STOP=\`busybox date +%s\`
	ENDED=\`date\`
	RUNTIME=\`busybox expr \$STOP - \$START\`
	HOURS=\`busybox expr \$RUNTIME / 3600\`
	REMAINDER=\`busybox expr \$RUNTIME % 3600\`
	MINS=\`busybox expr \$REMAINDER / 60\`
	SECS=\`busybox expr \$REMAINDER % 60\`
	RUNTIME=\`busybox printf "%02d:%02d:%02d\n" "\$HOURS" "\$MINS" "\$SECS"\`
	echo "" | tee -a \$LOG_FILE
	echo \$line | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " FIXED Permissions For ALL \$TOTAL Apps..." | tee -a \$LOG_FILE
	echo ""| tee -a \$LOG_FILE
	sleep 1
	echo "          ...Say Buh Bye To Force Close Errors!"
	echo ""
	echo \$line
	echo ""
	sleep 1
	echo "      Start Time: \$BEGAN" | tee -a \$LOG_FILE
	echo "       Stop Time: \$ENDED" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo " Completion Time: \$RUNTIME" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " See \$LOG_FILE for more details!"
	echo ""
	sleep 1
	echo "         ==============================" | tee -a \$LOG_FILE
	echo "          ) Fix Emissions Completed! (" | tee -a \$LOG_FILE
	echo "         ==============================" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_FixEmissions.log 2>&1
	Fix_Emissions & exit 0
fi
if [ -d "/system/etc/init.d" ]; then Configure; fi
Fix_Emissions
exit 0
EOF
	mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
	chown 0.0 /data/V6_SuperCharger/!FixEmissions.sh; chmod 777 /data/V6_SuperCharger/!FixEmissions.sh
	cp -fr /data/V6_SuperCharger/!FixEmissions.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!FixEmissions.sh $storage/V6_SuperCharger/fixfc
	if [ "$1" ]; then echo " Re-Generating /system/xbin/fixfc..."; fi
	cp -fr /data/V6_SuperCharger/!FixEmissions.sh /system/xbin/fixfc
	if [ -d "/system/etc/init.d" ]; then
		if [ "$1" ]; then echo " Re-Generating /init.d/94fixfc..."; fi
		cp -fr /data/V6_SuperCharger/!FixEmissions.sh /system/etc/init.d/94fixfc
		cp -fr /data/V6_SuperCharger/!FixEmissions.sh $storage/V6_SuperCharger/94fixfc
	fi
}
Re_Generate_FixAlignment_sh(){
	cat > /data/V6_SuperCharger/!FixAlignment.sh <<EOF
#!/system/bin/sh
#
# Fix Alignment Script (ZipAlign AND Fix Permissions) created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/\!FixAlignment.sh
	cat >> /data/V6_SuperCharger/!FixAlignment.sh <<EOF
# Combines my "ZepAlign" / Wheel Alignment Script (ZipAlign) with my Fix Emissions Script (Fix Permissions).
# Due to the combining of tools and enhancements... it's STUPIDLY FAST!
#
  ###############################
 # Wheel Alignment Information #
###############################
# ZipAligns all data and system apks (apps) that have not yet been ZipAligned.
# ZipAlign optimizes all your apps, resulting in less RAM comsumption and a faster device! ;^]
#
# Option 1. By default, this will check and/or zipalign only apks which were recently added and may need it.
# Option 2. Or, when asked, you can force it to zipalign all apks! (Obviously, this takes a bit longer).
#
# The code is HIGHLY optimized... so it's REALLY FAST!
#
# Get full stats from the log file!
#
# Tweaks & Enhancements by zeppelinrox...
#      - Added BRAINS: By default, it will only check apks that were added since last run (ie. newer than the log file!)
#      - Added support for /vendor/app (POST-ICS)
#      - Added support for /mnt/asec
#      - Added support for more data directories ie. dbdata, datadata, etc.
#      - Added debugging
#      - Tweaked interface... just a bit ;^]
#
# Props: Automatic ZipAlign by Wes Garner (original script)
#        oknowton for the change from MD5 to zipalign -c 4
#
  #############################
 # Fix Emissions Information #
#############################
# Sets permissions for android data directories and apks.
# This should fix app force closes (FCs).
#
# The code is HIGHLY optimized... so it's REALLY FAST! - setting permissions for 300 apps in approximately 1 minute.
#
# Get full stats from the log file!
#
# Tweaks & Enhancements by zeppelinrox...
#      - Only applies permissions if they are not what they're supposed to be!
#      - Removed the usage of the "pm list packages" command - it didn't work on boot.
#      - Added support for /vendor/app (POST-ICS).
#      - No longer excludes framework-res.apk or com.htc.resources.apk
#      - Added support for more data directories ie. dbdata, datadata, etc.
#      - Added debugging.
#      - Enhanced logging!
#      - Tweaked interface... just a bit ;^]
#
# Props: Originally and MOSTLY (erm... something like 75% of it lol) by Jared Rummler (JRummy16).
# However, I actually meshed together 3 different Fix Permissions scripts and added my own spices ;^]
#
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_FixAlign.log file to see what may have fubarred.
# set -x
# exec > /data/Log_FixAlign.log 2>&1
#
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
bootupdelay="sleep 180"
# Next line only applies to the init.d boot script. "bootfixalign=1" means run on boot. Anything else disables it.
bootfixalign=$fixalign
Configure(){
	echo ""
	echo " Fix Alignment On Boot..."
	echo " =========================="
	echo ""
	sleep 1
	echo " If desired, you can change boot options.."
	echo ""
	sleep 1
	echo "        ...this script is VERY sophisticated..."
	echo ""
	sleep 1
	echo "           ...so boot time would be unaffected!"
	echo ""
	sleep 1
	echo \$line
	echo -n " Status: Fix Alignment "
	if [ "\$bootfixalign" -eq 1 ]; then echo "DOES Run On Boot!"
	else echo "DOES NOT Run On Boot!"
	fi
	echo \$line
	echo ""
	sleep 1
	echo " You can also configure this in Driver Options!"
	echo ""
	sleep 1
	echo \$line
	echo "   Also READ THE COMMENTS inside this script!"
	echo \$line
	echo ""
	sleep 1
	echo " Change Fix Alignment Options?"
	echo ""
	sleep 1
	echo -n " Enter Y for Yes, any key for No: "
	read changeoptions
	echo ""
	echo \$line
	case \$changeoptions in
		y|Y)mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
			echo ""
			sleep 1
			echo " Run Fix Alignment on boot?"
			echo ""
			sleep 1
			echo " Note 1: If you say Yes..."
			echo "         Wheel Alignment and Fix Emissions..."
			echo "         ...On Boot are automatically disabled!"
			echo ""
			sleep 1
			echo " Note 2: If you say No..."
			echo "         Wheel Alignment and Fix Emissions..."
			echo "              ...boot options become available!"
			echo ""
			sleep 1
			echo -n " Enter Y for Yes, any key for No: "
			read bootfixalign
			echo ""
			echo \$line
			case \$bootfixalign in
			  y|Y)fixalign=1; zepalign=0; fixemissions=0
				  echo "        Fix Alignment Set To Run On Boot!";;
				*)fixalign=0
				  echo "   Boot Fix Align Declined... does that rhyme?";;
			esac
			sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' \$0
			if [ "\$0" != "/data/V6_SuperCharger/!FixAlignment.sh" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /data/V6_SuperCharger/!FixAlignment.sh; fi 2>/dev/null
			if [ "\$0" != "/system/xbin/fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/xbin/fixalign; fi 2>/dev/null
			if [ "\$0" != "/system/etc/init.d/95fixalign" ]; then sed -i '/^bootfixalign=/s/=.*/='\$fixalign'/' /system/etc/init.d/95fixalign; fi 2>/dev/null
			if [ -f "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /data/V6_SuperCharger/!WheelAlignment.sh; fi
			if [ -f "/system/xbin/zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /system/xbin/zepalign; fi
			if [ -f "/system/etc/init.d/93zepalign" ]; then sed -i '/^bootzepalign=/s/=.*/='\$zepalign'/' /system/etc/init.d/93zepalign; fi
			if [ -f "/data/V6_SuperCharger/!FixEmissions.sh" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /data/V6_SuperCharger/!FixEmissions.sh; fi
			if [ -f "/system/xbin/fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /system/xbin/fixfc; fi
			if [ -f "/system/etc/init.d/94fixfc" ]; then sed -i '/^bootfixemissions=/s/=.*/='\$fixemissions'/' /system/etc/init.d/94fixfc; fi
			if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
				awk 'BEGIN{OFS=FS=","}{\$8='\$zepalign',\$9='\$fixemissions',\$10='\$fixalign';print}' /data/V6_SuperCharger/SuperChargerOptions > /data/V6_SuperCharger/SuperChargerOptions.tmp
				mv /data/V6_SuperCharger/SuperChargerOptions.tmp /data/V6_SuperCharger/SuperChargerOptions
			fi
			mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro /system 2>/dev/null
			busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;;
		  *)echo "               No Change For You!";;
	esac
	echo \$line
	sleep 1
}
install(){
	if [ ! -f "\$1" ]; then
		echo ""
		echo " Installing myself to \${1#*etc}"
		sleep 2
		mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		dd if=\$0 of=\$1
		chown 0.0 \$1; chmod 777 \$1
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	elif [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " \$1 is already installed..."
		sleep 2
	fi
	if [ "\`echo \$1 | grep xbin\`" ]; then
		echo ""
		echo " To run, type in Terminal: \"su -c \${1##*/}\""
		sleep 2
	fi
}
Fix_Align(){
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done
	if [ "\`echo \$0 | grep "init\.d"\`" ] && [ "\$bootfixalign" -ne 1 ]; then exit 69
	elif [ "\`echo \$0 | grep "init\.d"\`" ]; then \$bootupdelay
	elif [ -d "/system/etc/init.d" ]; then install /system/etc/init.d/95fixalign
	fi
	if [ ! "\`echo \$0 | grep xbin\`" ]; then install /system/xbin/fixalign; fi
	LOG_FILE=/data/Ran_FixAlign.log
	lastran=/data/!FixAlign_Last_Ran
	if [ "\`grep "zipaligned" \$LOG_FILE\`" ]; then mv \$LOG_FILE \$lastran; fi 2>/dev/null
	zipalign="yes"
	if [ "easyloglulz" ]; then
		echo ""
		echo \$line
		echo "   -=Fix Alignment=- script by -=zeppelinrox=-"
		echo \$line
		echo ""
		sleep 2
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			sleep 1
			echo " You are NOT running this script as root..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No SuperUser For You!!"
			echo \$line
			echo ""
			sleep 3
			echo "     ...Please Run as Root and try again..."
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ ! "\`which zipalign\`" ]; then
			zipalign=
			sleep 1
			echo " Doh... zipalign binary was NOT found..."
			echo ""
			sleep 3
			echo \$line
			echo "                    ...No ZepAligning For You!!"
			echo \$line
			echo ""
			sleep 3
			echo " Load the XDA SuperCharger thread..."
			echo ""
			sleep 3
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			echo \$line
			echo ""
			sleep 3
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://\$storage/!SuperCharger.html"
			echo ""
			echo \$line
			echo ""
			sleep 3
			echo \$line
			echo "    So... for now... can ONLY Fix Emissions!"
			echo \$line
			echo ""
			sleep 3
		elif [ -f "\$lastran" ]; then
			echo " ZipAlign ALL Apps or only recently installed?"
			echo ""
			sleep 1
			echo -n " Enter (A)LL, any key for recently added: "
			stty -icanon min 0 time 200
			read how
			stty sane
			if [ ! "\$how" ]; then echo ""; fi
			echo ""
			case \$how in
				a|A)rm \$lastran;;
				  *);;
			esac
			echo \$line
			echo ""
			sleep 1
		fi
	fi | tee \$LOG_FILE
	mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	START=\`busybox date +%s\`
	BEGAN=\`date\`
	TOTAL=\`cat /d*/system/packages.xml | grep -c "^<package.*serId"\`
	INCREMENT=3
	PROGRESS=0
	PROGRESS_BAR=""
	NEW=0; ALIGNED=0; ALREADY=0; FAILED=0; SKIPPED=0
	echo " Start Fix Alignment: \$BEGAN" >> \$LOG_FILE
	grep "^<package.*serId" /d*/system/packages.xml > /data/pkgline.tmp
	busybox sync
	while read pkgline; do
		PKGNAME=\`echo \$pkgline | sed 's%.* name="\(.*\)".*%\1%' | cut -d '"' -f1\`
		CODEPATH=\`echo \$pkgline | sed 's%.* codePath="\(.*\)".*%\1%' |  cut -d '"' -f1\`
		DATAPATH=/d*/d*/\$PKGNAME
		PKGUID=\`echo \$pkgline | sed 's%.*serId="\(.*\)".*%\1%' | cut -d '"' -f1\`
		PROGRESS=\$((\$PROGRESS+1))
		PERCENT=\$(( \$PROGRESS * 100 / \$TOTAL ))
		if [ "\$PERCENT" -eq "\$INCREMENT" ]; then
			INCREMENT=\$(( \$INCREMENT + 3 ))
			PROGRESS_BAR="\$PROGRESS_BAR="
		fi
		clear
		echo ""
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo "       \"Fix Alignment\" by -=zeppelinrox=-"
		echo -n "                                        >"
		echo -e "\r       \$PROGRESS_BAR>"
		echo ""
		echo "       Processing Apps - \$PERCENT% (\$PROGRESS of \$TOTAL)"
		echo "" | tee -a \$LOG_FILE
		echo " Fix Aligning \$PKGNAME..." | tee -a \$LOG_FILE
		echo ""
		if [ -e "\$CODEPATH" ]; then
			if [ ! -f "\$lastran" ] || [ "\$CODEPATH" -nt "\$lastran" ] && [ "\$zipalign" ]; then NEW=\$((\$NEW+1))
				if [ "\$(busybox basename \$CODEPATH)" = "framework-res.apk" ] || [ "\$(busybox basename \$CODEPATH)" = "SystemUI.apk" ] || [ "\$(busybox basename \$CODEPATH)" = "com.htc.resources.apk" ]; then
					echo " NOT ZipAligning (Problematic) \$CODEPATH..." | tee -a \$LOG_FILE
					SKIPPED=\$((\$SKIPPED+1))
					skippedapp=\`echo "\$skippedapp, \$(busybox basename \$CODEPATH)" | sed 's/^, //'\`
				else
					zipalign -c 4 \$CODEPATH
					ZIPCHECK=\$?
					if [ "\$ZIPCHECK" -eq 1 ]; then
						echo " ZipAligning \$CODEPATH..." | tee -a \$LOG_FILE
						zipalign -f 4 \$CODEPATH /cache/\$(busybox basename \$CODEPATH)
						rc="\$?"
						if [ "\$rc" -eq 0 ]; then
							if [ -e "/cache/\$(busybox basename \$CODEPATH)" ]; then
								busybox cp -f -p /cache/\$(busybox basename \$CODEPATH) \$CODEPATH | tee -a \$LOG_FILE
								ALIGNED=\$((\$ALIGNED+1))
							else
								echo " ZipAligning \$CODEPATH... Failed (No Output File!)" | tee -a \$LOG_FILE
								FAILED=\$((\$FAILED+1))
								failedapp=\`echo "\$failedapp, \$(busybox basename \$CODEPATH)" | sed 's/^, //'\`
							fi
						else echo " ZipAligning \$CODEPATH... Failed (rc: \$rc!)" | tee -a \$LOG_FILE
							FAILED=\$((\$FAILED+1))
							failedapp=\`echo "\$failedapp, \$(busybox basename \$CODEPATH)" | sed 's/^, //'\`
						fi
						if [ -e "/cache/\$(busybox basename \$CODEPATH)" ]; then busybox rm /cache/\$(busybox basename \$CODEPATH); fi
					else
						echo " ZipAlign already completed on \$CODEPATH" | tee -a \$LOG_FILE
						ALREADY=\$((\$ALREADY+1))
					fi
				fi
			fi
			APPDIR=\`busybox dirname \$CODEPATH\`
			if [ "\$APPDIR" = "/system/app" ] || [ "\$APPDIR" = "/vendor/app" ] || [ "\$APPDIR" = "/system/framework" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "0 0" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*644"\`" ]; then
				chown 0:0 \$CODEPATH
				chmod 644 \$CODEPATH
			elif [ "\$APPDIR" = "`ls -d /d*/app`" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "1000 1000" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*644"\`" ]; then
				chown 1000:1000 \$CODEPATH
				chmod 644 \$CODEPATH
			elif [ "\$APPDIR" = "`ls -d /d*/app-private`" ] && [ "\`busybox stat -t \$CODEPATH | awk '{print \$5,\$6}'\`" != "1000 \$PKGUID" ] && [ ! "\`busybox stat \$CODEPATH | grep "Access.*640"\`" ]; then
				chown 1000:\$PKGUID \$CODEPATH
				chmod 640 \$CODEPATH
			fi
			if [ -d "\$DATAPATH" ]; then
				if [ "\`busybox stat -t \$DATAPATH | awk '{print \$5,\$6}'\`" != "\$PKGUID \$PKGUID" ] && [ ! "\`busybox stat \$DATAPATH | grep "Access.*755"\`" ]; then
					chown \$PKGUID:\$PKGUID \$DATAPATH
					chmod 755 \$DATAPATH
				fi
				DIRS=\`busybox find \$DATAPATH -mindepth 1 -type d\`
				for file in \$DIRS; do
					PERM=755
					NEWUID=\$PKGUID
					NEWGID=\$PKGUID
					FNAME=\`busybox basename \$file\`
					case \$FNAME in
							lib)if [ ! "\`busybox stat \$file | grep "Access.*755"\`" ]; then chmod 755 \$file; fi
								NEWUID=1000
								NEWGID=1000
								PERM=755;;
		 shared_prefs|databases)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=660;;
						  cache)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=600;;
						  files)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=775;;
							  *)if [ ! "\`busybox stat \$file | grep "Access.*771"\`" ]; then chmod 771 \$file; fi
								PERM=771;;
					esac
					if [ "\`busybox stat -t \$file | awk '{print \$5,\$6}'\`" != "\$NEWUID \$NEWGID" ]; then chown \$NEWUID:\$NEWGID \$file; fi
					busybox find \$file -type f -maxdepth 2 ! -perm \$PERM -exec chmod \$PERM {} ';'
					busybox find \$file -type f -maxdepth 1 ! -user \$NEWUID -exec chown \$NEWUID {} ';'
					busybox find \$file -type f -maxdepth 1 ! -group \$NEWGID -exec chown :\$NEWGID {} ';'
				done
			fi
			echo " Fixed Permissions..." | tee -a \$LOG_FILE
		fi
	done < /data/pkgline.tmp
	busybox sync
	rm /data/pkgline.tmp
	rm \$lastran 2>/dev/null
	mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro /system 2>/dev/null
	busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	STOP=\`busybox date +%s\`
	ENDED=\`date\`
	RUNTIME=\`busybox expr \$STOP - \$START\`
	HOURS=\`busybox expr \$RUNTIME / 3600\`
	REMAINDER=\`busybox expr \$RUNTIME % 3600\`
	MINS=\`busybox expr \$REMAINDER / 60\`
	SECS=\`busybox expr \$REMAINDER % 60\`
	RUNTIME=\`busybox printf "%02d:%02d:%02d\n" "\$HOURS" "\$MINS" "\$SECS"\`
	echo "" | tee -a \$LOG_FILE
	echo \$line | tee -a \$LOG_FILE
	if [ "\$zipalign" ]; then
		echo "" | tee -a \$LOG_FILE
		sleep 1
		echo " Done \"ZepAligning\" ALL data and system APKs..." | tee -a \$LOG_FILE
		echo "" | tee -a \$LOG_FILE
		sleep 1
		echo " \$NEW	Apps were checked (added since last run)" | tee -a \$LOG_FILE
		echo " \$ALIGNED	Apps were zipaligned" | tee -a \$LOG_FILE
		echo " \$ALREADY	Apps were already zipaligned" | tee -a \$LOG_FILE
		echo " \$FAILED	Apps were NOT zipaligned due to error" | tee -a \$LOG_FILE
		if [ "\$failedapp" ]; then echo "	(\$failedapp)" | tee -a \$LOG_FILE; fi
		echo " \$SKIPPED	Problematic Apps were skipped" | tee -a \$LOG_FILE
		if [ "\$skippedapp" ]; then echo "	(\$skippedapp)" | tee -a \$LOG_FILE; fi
		echo "" | tee -a \$LOG_FILE
		echo " \$TOTAL	Apps were processed!" | tee -a \$LOG_FILE
		echo "" | tee -a \$LOG_FILE
		sleep 1
		echo "                ...Say Hello To Optimized Apps!"
		echo ""
		echo \$line | tee -a \$LOG_FILE
	fi
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " FIXED Permissions For ALL \$TOTAL Apps..." | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo "          ...Say Buh Bye To Force Close Errors!"
	echo ""
	echo \$line
	echo ""
	sleep 1
	echo "      Start Time: \$BEGAN" | tee -a \$LOG_FILE
	echo "       Stop Time: \$ENDED" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	echo " Completion Time: \$RUNTIME" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
	echo " See \$LOG_FILE for more details!"
	echo ""
	sleep 1
	echo "         ==============================" | tee -a \$LOG_FILE
	echo "          ) Fix Alignment Completed! (" | tee -a \$LOG_FILE
	echo "         ==============================" | tee -a \$LOG_FILE
	echo "" | tee -a \$LOG_FILE
	sleep 1
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	exec > /data/BootLog_FixAlign.log 2>&1
	Fix_Align & exit 0
fi
if [ -d "/system/etc/init.d" ]; then Configure; fi
Fix_Align
exit 0
EOF
	chown 0.0 /data/V6_SuperCharger/!FixAlignment.sh; chmod 777 /data/V6_SuperCharger/!FixAlignment.sh
	cp -fr /data/V6_SuperCharger/!FixAlignment.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!FixAlignment.sh $storage/V6_SuperCharger/fixalign
	if [ "$1" ]; then echo " Re-Generating /system/xbin/fixalign..."; fi
	cp -fr /data/V6_SuperCharger/!FixAlignment.sh /system/xbin/fixalign
	if [ -d "/system/etc/init.d" ]; then
		if [ "$1" ]; then echo " Re-Generating /init.d/95fixalign..."; fi
		cp -fr /data/V6_SuperCharger/!FixAlignment.sh /system/etc/init.d/95fixalign
		cp -fr /data/V6_SuperCharger/!FixAlignment.sh $storage/V6_SuperCharger/95fixalign
	fi
}
Re_Generate_FastEngineFlush_sh(){
	cat > /data/V6_SuperCharger/!FastEngineFlush.sh <<EOF
#!/system/bin/sh
#
# 2 in 1 Engine Flush Script created by -=zeppelinrox=-
# The 2 Modes are: -=Fast Engine Flush=- and -=Engine Flush-O-Matic=-
#
EOF
	terms /data/V6_SuperCharger/\!FastEngineFlush.sh
	cat >> /data/V6_SuperCharger/!FastEngineFlush.sh <<EOF
# See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article which also discusses the "drop system cache" function!
# See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why 'Free RAM' Is NOT Wasted RAM!"
#
# Credit imoseyon for making the drop caches command more well known :)
# See http://www.droidforums.net/forum/liberty-rom-d2/122733-tutorial-sysctl-you-guide-better-preformance-battery-life.html
# Credit dorimanx (Cool XDA dev!) for the neat idea to show before and after stats :D
#
# Note: To enable "Engine Flush-O-Matic" mode, change the "flushOmaticHours" variable to the number of hours you want.
#       Valid values are from 1 to 24 (hours).
#       If 0, or if the value is invalid or missing, "Engine Flush-O-Matic" mode is disabled.
#       Example: If you want it to run every 4 hours, make the line read "flushOmaticHours=4".
#
# Usage: 1. Type in Terminal: "su" and enter, "flush" and enter. ("flush" is indentical to !FastEngineFlush.sh but easier to type :p)
#        2. Script Manager: launch it once like any other script OR with a widget (DO NOT PUT IT ON A SCHEDULE!)
#
# Important! Whether you run this with Terminal or Script Manager or widget, the script relaunches and kills itself after the first run.
#            So let it run ONCE, close the app, and "Engine Flush-O-Matic" continues in the background!
#
# To verify that it's running, just run the script again!
# OR you can type in Terminal:
# 1. "pstree | grep -i flus" - for usage option 1 (with Terminal)
# 2. "pstree | grep sleep" - for usage option 2 (with Script Manager)
# 3. "cat /proc/*/cmdline | grep -i flush" - Sure-Fire method ;^]
#     The output should be 3 items:
#         a. "/data/V6_SuperCharger/!FastEngineFlush.sh" OR "/system/etc/init.d/96superflush" OR "/system/xbin/flush"(depending on which script ran)
#         b. "Engine_Flush-O-Matic_is_In_Effect!" (sleep message)
#         c. "flush" (created by your query so this doesn't mean anything)
# 4. "busybox ps | grep -i flus" would give similar results as 3.
#
# For debugging, delete the # at the beginning of the following 2 lines, and check /data/Log_FastEngineFlush.log file to see what may have fubarred.
# set -x
# exec > /data/Log_FastEngineFlush.log 2>&1
#
line=================================================
cd "\${0%/*}" 2>/dev/null
mount -o remount,rw /data 2>/dev/null
busybox mount -o remount,rw /data 2>/dev/null
# To set the next line manually, see comments at the top for instuctions!
flushOmaticHours=$flushOmaticHours
if [ ! "\$flushOmaticHours" ] || [ "\`echo \$flushOmaticHours | grep "[^0-9]"\`" ] || [ "\$flushOmaticHours" -gt 24 ]; then flushOmaticHours=0; fi
intervalsecs="sleep \$((\$flushOmaticHours*60*60))"
bootupminutedelay=7
bootupdelay="sleep \$((\$bootupminutedelay*60))"
if [ "\`busybox ps -w\`" ]; then w=" -w"; fi 2>/dev/null
Configure(){
	echo ""
	sleep 1
	echo " If desired, you can change options for..."
	echo ""
	sleep 1
	echo \$line
	echo "            -=Engine Flush-O-Matic=-"
	echo \$line
	echo ""
	sleep 1
	echo " Current Status..."
	echo ""
	sleep 1
	echo \$line
	if [ "\$flushOmaticHours" -gt 0 ]; then	echo " Engine Flush-O-Matic is ON @ \$flushOmaticHours hour intervals!"
	else echo " Engine Flush-O-Matic is Currently OFF!"
	fi
	echo \$line
	echo ""
	sleep 1
	echo " You can turn it on or off..."
	echo ""
	sleep 1
	echo "        ...or just change how often it runs ;^]"
	echo ""
	sleep 1
	if [ -d "/system/etc/init.d" ]; then
		echo " Note that when it's enabled..."
		echo ""
		sleep 1
		echo \$line
		echo " -=Engine Flush-O-Matic=- on boot is AUTOMAGIC!"
		echo \$line
		echo ""
		sleep 1
		echo " If disabled, it will Flush once after boot up!"
		echo ""
		sleep 1
	fi
	echo " Change Engine Flush-O-Matic Options?"
	echo ""
	sleep 1
	echo -n " Enter Y for Yes, any key for No: "
	read changeoptions
	echo ""
	echo \$line
	case \$changeoptions in
	  y|Y)changedopt=yes
		  mount -o remount,rw /system 2>/dev/null
		  busybox mount -o remount,rw /system 2>/dev/null
		  busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		  echo "        -=Engine Flush-O-Matic=- Options"
		  while :; do
			echo \$line
			echo ""
			sleep 1
			echo -n " Enter E to Enable, D to Disable: "
			read able
			echo ""
			echo \$line
			case \$able in
				e|E)echo "       -=Engine Flush-O-Matic=- ENABLED!!"
					echo \$line
					echo ""
					sleep 1
					echo " How often do you want it to flush?"
					while :; do
						echo ""
						sleep 1
						echo -n " Enter a value from 1 to 24 (hours): "
						read flushOmaticHours
						echo ""
						echo \$line
						case \$flushOmaticHours in
						  [1-9]|1[0-9]|2[0-4])echo " Engine Flush-O-Matic Set To Run Every \$flushOmaticHours Hours!"
											  break 2;;
											*)echo "      Invalid entry... Please try again :p"
											  echo \$line;;
						esac
					done;;
				d|D)flushOmaticHours=0
					echo "       -=Engine Flush-O-Matic=- DISABLED!!"
					break;;
				  *)echo "      Invalid entry... Please try again :p";;
			esac
		  done
		  sed -i '/^flushOmaticHours=/s/=.*/='\$flushOmaticHours'/' \$0
		  if [ "\$0" != "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then sed -i '/^flushOmaticHours=/s/=.*/='\$flushOmaticHours'/' /data/V6_SuperCharger/!FastEngineFlush.sh; fi 2>/dev/null
		  if [ "\$0" != "/system/xbin/flush" ]; then sed -i '/^flushOmaticHours=/s/=.*/='\$flushOmaticHours'/' /system/xbin/flush; fi 2>/dev/null
		  if [ "\$0" != "/system/etc/init.d/96superflush" ]; then sed -i '/^flushOmaticHours=/s/=.*/='\$flushOmaticHours'/' /system/etc/init.d/96superflush; fi 2>/dev/null
		  if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then
			awk 'BEGIN{OFS=FS=","}{\$11='\$flushOmaticHours';print}' /data/V6_SuperCharger/SuperChargerOptions > /data/V6_SuperCharger/SuperChargerOptions.tmp
			mv /data/V6_SuperCharger/SuperChargerOptions.tmp /data/V6_SuperCharger/SuperChargerOptions
		  fi
		  mount -o remount,ro /system 2>/dev/null
		  busybox mount -o remount,ro /system 2>/dev/null
		  busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null;;
		*)echo "               No Change For You!";;
	esac
	echo \$line
	echo ""
	sleep 3
}
install(){
	if [ ! -f "\$1" ]; then
		echo " Installing myself to \${1#*etc}"
		echo ""
		sleep 2
		mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw /system 2>/dev/null
		busybox mount -o remount,rw \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
		dd if=\$0 of=\$1
		chown 0.0 \$1; chmod 777 \$1
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro \$(busybox mount | awk '\$3=="/system"{print \$1,\$3}') 2>/dev/null
	elif [ "\`echo \$1 | grep xbin\`" ]; then
		echo " \$1 is already installed..."
		sleep 3
	fi
	if [ "\`echo \$1 | grep xbin\`" ]; then
		echo " To run, type in Terminal: \"su -c \${1##*/}\""
		echo ""
		sleep 3
	fi
}
Flush_Engine(){
	while [ ! "\`ps | grep android | grep -v grep\`" ]; do sleep 10; done
	echo "" | tee -a /data/Ran_EngineFlush-O-Matic.log
	if [ -d "/system/etc/init.d" ] && [ ! "\`echo \$0 | grep "init\.d"\`" ]; then install /system/etc/init.d/96superflush; fi
	if [ ! "\`echo \$0 | grep xbin\`" ]; then install /system/xbin/flush; fi
	if [ "\$flushOmaticHours" -gt 0 ]; then
		flushmode="   -=Engine Flush-O-Matic=- by -=zeppelinrox=-"
		echo " Engine Flush-O-Matic is enabled!" >> /data/Ran_EngineFlush-O-Matic.log
		echo "" >> /data/Ran_EngineFlush-O-Matic.log
	else flushmode="    -=Fast Engine Flush=- by -=zeppelinrox=-"
	fi
	echo " \$( date +"%m-%d-%Y %H:%M:%S" )" | tee -a /data/Ran_EngineFlush-O-Matic.log
	animspeed="busybox sleep 0.125"
	if [ -f "/data/FOMbootup" ]; then rm /data/FOMbootup
		echo " Delaying First Flush for \$bootupminutedelay minutes (make sure something stinks lol)" | tee -a /data/Ran_EngineFlush-O-Matic.log
		echo "" | tee -a /data/Ran_EngineFlush-O-Matic.log
		\$bootupdelay | grep "Flush_On_Boot_Delay_is_In_Effect!"
	elif [ -f "/data/FOMsleep" ]; then rm /data/FOMsleep
		echo " Now letting stuff build up for \$flushOmaticHours hours... heh." | tee -a /data/Ran_EngineFlush-O-Matic.log
		echo "" | tee -a /data/Ran_EngineFlush-O-Matic.log
		\$intervalsecs | grep "Engine_Flush-O-Matic_is_In_Effect!"
	else
		clear;sleep 1;echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |   |";echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |   D";echo "              |   |";echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";\$animspeed
		clear;echo "";echo \$line;echo "               ___";echo "              |   D";echo "              |   |";echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;\$animspeed;\$animspeed
		clear;echo "";echo \$line;echo "              |   D";echo "              |   |";echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |   |";echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |   |";echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "              |___|            __";echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                || ________  -( (-";echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                |_(--------)  '-'";echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                   \      /";echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "                    )_.._(";echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "                                         zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "                               zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "                     zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo "           zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo " zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo " zoom...                                zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo " zoom...                     zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo " zoom...           zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";\$animspeed
		clear;echo " zoom... zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
		clear;echo " zOOM... zOOM...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
		clear;echo " zoom... zoom...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
		clear;echo " zOOM... zOOM...";echo \$line;echo "\$flushmode";echo \$line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 1
		clear;echo " zOOM... zOOM...";echo \$line;echo "\$flushmode";echo \$line;echo "";busybox sleep 1
	fi
	echo "" > /data/Ran_EngineFlush-O-Matic.log
	if [ "easyloglulz" ]; then
		echo " zOOM... zOOM..."
		echo \$line
		echo "\$flushmode"
		echo \$line
		echo ""
		sleep 1
		echo " \$( date +"%m-%d-%Y %H:%M:%S" ): Flushing Engine with \$0!"
		echo ""
		sleep 1
		id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
		if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
			sleep 2
			echo " You are NOT running this script as root..."
			echo ""
			sleep 3
			echo \$line
			echo "                      ...No SuperUser For You!!"
			echo \$line
			echo ""
			sleep 3
			echo "     ...Please Run as Root and try again..."
			echo ""
			echo \$line
			echo ""
			sleep 3
			exit 69
		elif [ "\`busybox ps | grep Engine_ | grep Matic_\`" ]; then
			echo " -=Engine Flush-O-Matic=- is already in memory!"
			echo ""
			sleep 1
			echo " Do you want to flush now anyway?"
			echo ""
			sleep 1
			echo " Note: You can't enter another \"Flush Cycle\"!"
			echo ""
			sleep 1
			echo -n " Enter Y for Yes, any key for No: "
			stty -icanon min 0 time 200
			read FOMactive
			stty sane
			if [ ! "\$FOMactive" ]; then echo ""; fi
			echo ""
			echo \$line
			case \$FOMactive in
			  y|Y)echo " Alrighty Then!"
				  echo \$line
				  echo ""
				  sleep 1;;
				*)echo " No Flush For You!"
				  echo \$line
				  echo ""
				  exit 69;;
			esac
		fi
		ram=\$((\`free | awk 'NR==2{print \$2}'\`/1024))
		ramused=\$((\`free | awk 'NR==2{print \$3}'\`/1024))
		ramkbytesfree=\`free | awk 'NR==2{print \$4}'\`
		ramkbytescached=\`cat /proc/meminfo | grep Cached | awk 'NR==1{print \$2}'\`
		ramfree=\$((\$ramkbytesfree/1024));ramcached=\$((\$ramkbytescached/1024));ramreportedfree=\$((\$ramfree + \$ramcached))
		echo " Note that \"Used RAM\" INCLUDES Cached Apps!!"
		echo ""
		sleep 1
		echo \$line
		echo " RAM Stats BEFORE Engine Flush..."
		echo \$line
		echo ""
		sleep 1
		echo " Total: \$ram MB  Used: \$ramused MB  True Free: \$ramfree MB"
		echo ""
		sleep 1
		echo " Reported Free by most tools: \$ramreportedfree MB Free RAM!"
		echo ""
		sleep 1
		echo \$line
		echo " True Free \$ramfree MB = \"Free\" \$ramreportedfree - Cached Apps \$ramcached"
		echo \$line
		echo ""
		sleep 1
		echo " ...OR...    True Free RAM   \$ramfree"
		echo "               Cached Apps + \$ramcached"
		echo "                           ========"
		echo "       Reported \"Free\" RAM = \$ramreportedfree MB"
		echo ""
		sleep 1
		busybox sync;
		echo \$line
		echo -n " Engine Flush In Progress... ";busybox sysctl -w vm.drop_caches=3
		echo \$line
		echo ""
		sleep 3
		busybox sysctl -w vm.drop_caches=1 1>/dev/null
		ramused=\$((\`free | awk 'NR==2{print \$3}'\`/1024))
		ramkbytesfree=\`free | awk 'NR==2{print \$4}'\`
		ramkbytescached=\`cat /proc/meminfo | grep Cached | awk 'NR==1{print \$2}'\`
		ramfree=\$((\$ramkbytesfree/1024));ramcached=\$((\$ramkbytescached/1024));ramreportedfree=\$((\$ramfree + \$ramcached))
		echo \$line
		echo "                ...RAM Stats AFTER Engine Flush"
		echo \$line
		echo ""
		sleep 1
		echo " Total: \$ram MB  Used: \$ramused MB  True Free: \$ramfree MB"
		echo ""
		sleep 1
		echo " Reported Free by most tools: \$ramreportedfree MB Free RAM!"
		echo ""
		sleep 1
		echo \$line
		echo " True Free \$ramfree MB = \"Free\" \$ramreportedfree - Cached Apps \$ramcached"
		echo \$line
		echo ""
		sleep 1
		echo " ...OR...    True Free RAM   \$ramfree"
		echo "               Cached Apps + \$ramcached"
		echo "                           ========"
		echo "       Reported \"Free\" RAM = \$ramreportedfree MB"
		echo ""
		sleep 1
		echo \$line
		echo "                  ...Enjoy Your Quick Boost ;^]"
		echo \$line
		echo ""
		sleep 1
		echo "      ====================================="
		if [ "\$flushOmaticHours" -gt 0 ]; then	echo "       ) Engine Flush-O-Matic Completed! ("
		else echo "       )   Fast Engine Flush Completed!  ("
		fi
		echo "      ====================================="
		echo ""
		sleep 1
	fi | tee -a /data/Ran_EngineFlush-O-Matic.log
	if [ ! "\$flushOmaticHours" -gt 0 ]; then exit 0
	elif [ "\$FOMactive" ] || [ "\`busybox ps | grep Engine_ | grep Matic_\`" ]; then
		echo \$line
		echo " -=Engine Flush-O-Matic=- is already in memory!"
		echo \$line
		echo ""
		sleep 1
		exit 69
	elif [ "\$changedopt" ]; then
		echo " After closing this app you may wonder..."
		echo ""
		sleep 1
		echo " Is -=Engine Flush-O-Matic=- working?"
		echo " ===================================="
		echo ""
		sleep 1
		echo " Check out /data/Ran_EngineFlush-O-Matic.log!"
		echo ""
		sleep 1
		echo " Or... in Terminal Emulator, you can type..."
		echo ""
		sleep 1
		echo " \"pstree | grep -i flus\" OR \"pstree|grep sleep\""
		echo ""
		sleep 1
		echo " OR... get COMPLETE information with..."
		echo ""
		sleep 1
		echo "      ...\"cat /proc/*/cmdline | grep -i flush\"!"
		echo ""
		sleep 1
		echo " The output should look like this:"
		echo ""
		sleep 1
		echo "   /data/V6_SuperCharger/!FastEngineFlush.sh..."
		echo "   OR /system/etc/init.d/96superflush"
		echo "   OR /system/xbin/flush (just one of them)"
		echo "   Engine_Flush-O-Matic_is_In_Effect!"
		echo "   flush"
		echo ""
		sleep 1
		echo " Easier: Similar results can be had with..."
		echo ""
		sleep 1
		echo "                 ...\"busybox ps | grep -i flus\""
		echo ""
		sleep 1
		echo " ...OR run this script again...I'll tell ya LOL"
		echo ""
		sleep 1
		echo \$line
		echo "   Also READ THE COMMENTS inside this script!"
		echo \$line
		echo ""
		sleep 1
		echo \$line
		echo " Now executing -=Engine Flush-O-Matic=-..."
		echo \$line
		echo ""
		sleep 1
	fi
	echo \$line
	echo "       Here We Go Again... in \$flushOmaticHours hours LOL"
	echo \$line
	echo ""
	sleep 1
	echo \$line
	echo "         Oh Hey! You can close this App!"
	echo \$line
	echo ""
	sleep 1
	if [ "\`busybox --list | grep nohup\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then echo "cookie!" > /data/FOMsleep; (busybox nohup \$0 > /dev/null &)
	elif [ "\`busybox --list | grep start-stop-daemon\`" ] && [ ! "\`busybox ps\$w | grep "/\${0##*/}" | grep {\`" ]; then echo "cookie!" > /data/FOMsleep; busybox start-stop-daemon -S -b -x \$0
	else echo "cookie!" > /data/FOMsleep; \$0 > /dev/null & exit 0
	fi
}
if [ ! "\`ps | grep android | grep -v grep\`" ]; then
	echo "cookie!" > /data/FOMbootup
	rm /data/Ran_EngineFlush-O-Matic.log
	exec > /data/BootLog_FastEngineFlush.log 2>&1
	Flush_Engine & exit 0
fi
Configure
Flush_Engine
EOF
	chown 0.0 /data/V6_SuperCharger/!FastEngineFlush.sh; chmod 777 /data/V6_SuperCharger/!FastEngineFlush.sh
	cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh $storage/V6_SuperCharger/flush
	if [ "$1" ]; then echo " Re-Generating /system/xbin/flush..."; fi
	cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh /system/xbin/flush
	if [ -d "/system/etc/init.d" ]; then
		if [ "$1" ]; then echo " Re-Generating /init.d/96superflush..."; fi
		cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh /system/etc/init.d/96superflush
		cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh $storage/V6_SuperCharger/96superflush
	fi
}
Re_Generate_SuperClean_sh(){
	cat > /data/V6_SuperCharger/!SuperClean.sh <<EOF
#!/system/bin/sh
#
# SuperClean & ReStart Script (Wipe Dalvik Cache & Reboot) created by -=zeppelinrox=-
#
EOF
	terms /data/V6_SuperCharger/\!SuperClean.sh
	cat >> /data/V6_SuperCharger/!SuperClean.sh <<EOF
clear
line=================================================
echo ""
echo \$line
echo "  -=SuperClean & ReStart=- by -=zeppelinrox=-"
echo \$line
echo ""
sleep 1
id=\$(id); id=\${id#*=}; id=\${id%%[\\( ]*}
if [ "\$id" != "0" ] && [ "\$id" != "root" ]; then
	sleep 2
	echo " You are NOT running this script as root..."
	echo ""
	sleep 3
	echo \$line
	echo "                      ...No SuperUser For You!!"
	echo \$line
	echo ""
	sleep 3
	echo "     ...Please Run as Root and try again..."
	echo ""
	echo \$line
	echo ""
	sleep 3
	exit 69
fi
echo " Commencing SuperClean & ReStart!"
echo ""
sleep 2
for cachedir in /*/dalvik-*; do rm -r \$cachedir/* 2>/dev/null; done
echo " All cleaned up and ready to..."
echo ""
sleep 2
echo \$line
echo "                    !!POOF!!"
echo \$line
echo ""
sleep 2
busybox sync
if [ -f "/proc/sys/kernel/sysrq" ]; then
	echo 1 > /proc/sys/kernel/sysrq 2>/dev/null
	echo b > /proc/sysrq-trigger 2>/dev/null
fi
echo "  If it don't go poofie, just reboot manually!"
echo ""
reboot; busybox reboot
echo "          ==========================="
echo "           ) SuperClean Completed! ("
echo "          ==========================="
echo ""
sleep 1
exit 0
EOF
	chown 0.0 /data/V6_SuperCharger/!SuperClean.sh; chmod 777 /data/V6_SuperCharger/!SuperClean.sh
	cp -fr /data/V6_SuperCharger/!SuperClean.sh $storage/V6_SuperCharger
	cp -fr /data/V6_SuperCharger/!SuperClean.sh $storage/V6_SuperCharger/sclean
	cp -fr /data/V6_SuperCharger/!SuperClean.sh /system/xbin/sclean
}
script_version_check(){
	for regen in /data/99SuperCharger.sh /data/97BulletProof_Apps.sh /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh `ls /data/V6_SuperCharger/!*\.sh` `ls /data/V6_SuperCharger/BulletProof_One_Shots/*`; do
		if [ ! "$1" ] && [ ! "$didtitle" ] && [ ! "`grep $ver $regen`" ] && [ -f "$regen" ]; then
			mount -o remount,rw / 2>/dev/null
			mount -o remount,rw rootfs 2>/dev/null
			busybox mount -o remount,rw / 2>/dev/null
			busybox mount -o remount,rw rootfs 2>/dev/null
			mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw /system 2>/dev/null
			busybox mount -o remount,rw $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
			if [ -d "/sqlite_stmt_journals" ]; then madesqlitefolder=0
			else mkdir /sqlite_stmt_journals; madesqlitefolder=1
			fi
			echo ""
			$sleep
			echo " Doh... I found outdated script thingies..."
			echo ""
			$sleep
			echo "                      ...so going to run the..."
			echo ""
			$sleep
			echo $line
			echo "    \\\\\\\\ Super Smart Script Re-Generator ////"
			echo "     ======================================="
			echo ""
			$sleep
			didtitle=yes
			missingoptions=yes
		fi
		if [ "$1" ] || [ ! "`grep $ver $regen`" ] && [ -f "$regen" ]; then
			echo " Re-Generating `echo $regen | sed 's/.*\///'`..."
			if [ ! "`echo $regen | grep "1Shot"`" ]; then Re_Generate_`echo $regen | sed 's/.*\/\|.*!//g'| sed 's/\.sh/_sh/'` echo
			else Re_Generate_BulletProof_1Shots `echo $regen | sed 's/.*-\|\.sh//g'` noecho
			fi
			$sleep
		fi
	done
	if [ "$didtitle" ]; then
		echo ""
		echo $line
		echo " Hey that was easy! (well... for YOU it was :p)"
		echo $line
		echo ""
		$sleep
		echo -n " Press The Enter Key... "
		read enter
		echo ""
		echo $line
		didtitle=
		if [ "$madesqlitefolder" -eq 1 ]; then rm -r /sqlite_stmt_journals; fi 2>/dev/null
		mount -o remount,ro / 2>/dev/null
		mount -o remount,ro rootfs 2>/dev/null
		busybox mount -o remount,ro / 2>/dev/null
		busybox mount -o remount,ro rootfs 2>/dev/null
		mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro /system 2>/dev/null
		busybox mount -o remount,ro $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
	fi
}
bOOM_Stick(){
	bOOM_Stick_Title_Sequence(){
		if [ "$1" = "zOOM" ]; then
			echo "                     ________  ______  ____  ___"
			echo "_____________________   / __ \  / __ \  /  |/  /"
			echo "________________/_  /  / / / / / / / / / /|_/ /"
			echo "_________________/ /_ / /_/ / / /_/ / / /  / /"
			echo "________________/___/ \____/  \____/ /_/  /_/"
			echo ""
			echo "________________________________________ _______"
			echo "________/ ___/ /_  __/ /  _/ / ____/ / //_/  / /"
			echo "________\__ \   / /    / /  / /     /  <    / /"
			echo "__________/ /  / /   _/ /  / /___  / /| |  /_/"
			echo "______/____/  /_/   /___/  \____/ /_/ |_| (_)"
			echo ""
		elif [ "$1" = "vrOOM" ]; then
			echo "________________________________________________"
			echo "                         __       __     _   _"
			echo "                       /    )   /    )   /  /|"
			echo "               )__    /    /   /    /   /| / |"
			echo "        | /   /   )  /    /   /    /   / |/  |"
			echo "________|/___/______(____/___(____/___/__/___|__"
			echo ""
			echo "________________________________________________"
			echo "         __   ______  __     __     _    _    /"
			echo "       /    )   /     /    /    )   /  ,'    /"
			echo "       \       /     /    /        /_,'     /"
			echo "        \     /     /    /        /  \     /"
			echo "___(____/____/_____/____(____/___/____\___o_____"
			echo ""
		fi | tee /data/!bOOM_Stick_COOKED.log
	}
	Ash(){
		echo ""
		echo " :ttFFyr,"
		echo "      .;10Z8Ft@RF;.             ,     l"
		echo "             .iH8@@@@@@@QE0Wyl.r F   @Qh:i,,,:Y;"
		echo "                      .:lY1B@Q@Q@QLL@Q@Q@@@Q@Q@@"
		echo "                         ,   ,,:, YJ,@@,.vh0R@Q1"
		echo "                    h@@@@Q@         @Q@L"
		echo "                   SQ@Q@@@@@         @Q@"
		echo "                  @Q@Q1   UQW         @@l"
		echo "                  0@Q ..,lFEQ          @@@"
		echo "                  :FL  r, ,             @@@"
		echo "                   ,h    rv             Q@"
		echo "                       ..LrBl  ,     .@Q@:"
		echo "                        ,vl@Q@QB   ,@@Q0"
		echo "                    R  L@Q@Q@@@Q.,hQ@8"
		echo "                   ,@K  :;@@QR@@Q@Q@L"
		echo "                 ,. @Q@M UCHQQFR@Q@@"
		echo "               iv,t0Q@Q@Q@0JR@,0Q@Qr"
		echo "              .L@Cl Q@@Q@FB0ZQZ@@Q@Fl"
		echo "              MEQ0, :@Q@0tQ@R@Q@Q@Q@@:"
		echo "              .@0:   :JQ8Q@Q@@SJ.B@Q@:"
		echo "              i@FL v@@Q@@@QZQ@  F@@@Q."
		echo "              ;Z@QFR@Q@Q@RQQ@.KR@QQ@@"
		echo "              i0Q@QRQYFORZ@@Q  :.FQl"
	}
	bOOM_Stick_End_Credits(){
		echo " Alright you Primitive Screwheads, listen up!"
		echo ""
		$sleep
		echo " You see this? This... is my..."
		echo ""
		$sleep
		if [ "$1" = "zOOM" ]; then
			echo "___________________  ________  ______  ____  ___"
			echo "________________/ /_    / __ \  / __ \  /  |/  /"
			echo "_______________/ __ \  / / / / / / / / / /|_/ /"
			echo "______________/ /_/ / / /_/ / / /_/ / / /  / /"
			echo "_____________/_,___/  \____/  \____/ /_/  /_/"
			Ash
			echo "________________________________________ _______"
			echo "________/ ___/ /_  __/ /  _/ / ____/ / //_/  / /"
			echo "________\__ \   / /    / /  / /     /  <    / /"
			echo "__________/ /  / /   _/ /  / /___  / /| |  /_/"
			echo "______/____/  /_/   /___/  \____/ /_/ |_| (_)"
		elif [ "$1" = "vrOOM" ]; then
			echo "________________________________________________"
			echo "                         __       __     _   _"
			echo "                /      /    )   /    )   /  /|"
			echo "               /__    /    /   /    /   /| / |"
			echo "              /   )  /    /   /    /   / |/  |"
			echo "_____________(___/__(____/___(____/___/__/___|__"
			Ash
			echo "________________________________________________"
			echo "         __   ______  __     __     _    _    /"
			echo "       /    )   /     /    /    )   /  ,'    /"
			echo "       \       /     /    /        /_,'     /"
			echo "        \     /     /    /        /  \     /"
			echo "___(____/____/_____/____(____/___/____\___o_____"
		else
			echo "     __      ____    ____    __  ___"
			echo "    / /_    / __ \  / __ \  /  |/  /"
			echo "   / __ \  / / / / / / / / / /|_/ /"
			echo "  / /_/ / / /_/ / / /_/ / / /  / /"
			echo " /_,___/  \____/  \____/ /_/  /_/"
			Ash
			echo "         _____  ______  ____  ______  __ __   __"
			echo "        / ___/ /_  __/ /  _/ / ____/ / //_/  / /"
			echo "        \__ \   / /    / /  / /     /  <    / /"
			echo "       ___/ /  / /   _/ /  / /___  / /| |  /_/"
			echo "      /____/  /_/   /___/  \____/ /_/ |_| (_)"
		fi
		echo ""
		$sleep
		echo " Too many \"Drive Me Crazy\" with lack of info..."
		echo ""
		$sleep
		echo "          ...so you have 2 versions in /data..."
		echo ""
		$sleep
		echo "                     ...The RAW and the COOKED!"
		echo ""
		$sleep
		echo $line
		echo " Post them with your launcher status questions!"
		echo $line
		echo ""
		$sleep
		echo " FYI, when the launcher is Die-Hard..."
		echo ""
		$sleep
		echo "           ...it's the ONLY process with ADJ 1!"
		echo ""
	}
	bOOM(){
		adj=`echo $psinfo | awk '{print $1}'`; apkname=
		appname=`echo $psinfo | awk '{print $3}'`
		if [ "$adj" -eq "$HL" ] && [ "$lname" = "$appname" ]; then
			echo " Home Launcher is on the NEXT line! (ADJ=$HL)"
		fi
		if [ "$boomstick" = "vrOOM" ]; then
			if [ "`echo $appname | grep -v "/"`" ] || [ "`echo $appname | grep "\."`" ]; then
				workappname=`echo $appname | sed 's:.*/::'`
				apkname=`busybox find / -iname "*$workappname*.apk" -maxdepth 3 | tail -n 1`
			fi
		fi
		if [ "$apkname" ]; then	echo " $psinfo  ($apkname)"
		else echo " $psinfo"
		fi
		if [ "$adj" -eq "$HL" ] && [ "$lname" = "$appname" ]; then echo ""; fi
	}
	echo "" | tee /data/!bOOM_Stick_COOKED.log
	bOOM_Stick_Title_Sequence $boomstick
	echo "" > /data/!bOOM_Stick_RAW.log
	echo " ADJ  PID    Process" >> /data/!bOOM_Stick_RAW.log
	echo "" >> /data/!bOOM_Stick_RAW.log
	for i in `busybox ps | grep -v "\]$" | awk '{print $1}'`; do
		if [ -f "/proc/$i/$oom_adj" ]; then
			adj=`cat /proc/$i/$oom_adj`
			appname=$(echo `cat /proc/$i/cmdline | awk '{print $1}' | sed 's/grep//'`)
			echo " $adj  $i  $appname" >> /data/!bOOM_Stick_RAW.tmp
			if [ "/proc/1/$oom_adj" -lt -20 ]; then
				if [ "$adj" -eq -1000 ]; then adj=-16
				elif [ "$adj" -eq 1000 ]; then adj=15
				elif [ "${adj#-}" -gt 20 ]; then adj=`echo $adj | awk '{printf "%.0f\n", $1*17/1000}'`
				fi
			fi
			echo " $adj  $i  $appname" >> /data/!bOOM_Stick.tmp
		fi
	done 2>/dev/null
	sort -n -k1 -k2 /data/!bOOM_Stick_RAW.tmp >> /data/!bOOM_Stick_RAW.log
	sort -n -k1 -k2 /data/!bOOM_Stick.tmp >> /data/!bOOM_Stick_COOKED.tmp
	if [ "$boomstick" ]; then
		echo "        ================================="
		echo "----=== zeppelinrox's bOOM Stick Verifier ===---"
		echo "        ================================="
		echo ""
		if [ "$boomstick" = "vrOOM" ]; then
			echo " Using vrOOM Stick Mode (Verbose)..."; echo ""
			echo " ADJ  PID    Process/Path        (APK)"
		else
			echo " Using zOOM Stick Mode (Quick)..."; echo ""
			echo " ADJ  PID    Process"
		fi
		echo ""
		echo " FOREGROUND_APP OOM GROUPING"
		echo " ==========================="
		if [ "$HL" -gt -18 ] && [ "$HL" -lt "$oomadj1" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>-18 && $1<'$oomadj1'{print}' | while read psinfo; do bOOM; done
		if [ "$HL" -eq "$oomadj1" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1=='$oomadj1'{print}' | while read psinfo; do bOOM; done
		echo ""
		if [ "$scadj" ] && [ "$currentadj" = "$scadj" ] && [ "$oomstick" -eq 1 ] && [ "$HL" -ne "$oomadj1" ]; then
			echo " HOME_LAUNCHER OOM GROUPING!"
			echo " ==========================="
			cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj1' && $1<'$oomadj2'{print}' | while read psinfo; do bOOM; done
			echo ""
			echo " VISIBLE_APP OOM GROUPING"
			echo " ========================"
			cat /data/!bOOM_Stick_COOKED.tmp | awk '$1=='$oomadj2'{print}' | while read psinfo; do bOOM; done
		else
			echo " VISIBLE_APP OOM GROUPING"
			echo " ========================"
			if [ "$HL" -gt "$oomadj1" ] && [ "$HL" -le "$oomadj2" ]; then
				echo ""
				echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
				echo ""
			fi
			cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj1' && $1<='$oomadj2'{print}' | while read psinfo; do bOOM; done
		fi
		echo ""
		echo " SECONDARY_SERVER OOM GROUPING"
		echo " ============================="
		if [ "$HL" -gt "$oomadj2" ] && [ "$HL" -le "$oomadj3" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj2' && $1<='$oomadj3'{print}' | while read psinfo; do bOOM; done
		echo ""
		echo " HIDDEN_APP OOM GROUPING"
		echo " ======================="
		if [ "$HL" -gt "$oomadj3" ] && [ "$HL" -le "$oomadj4" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj3' && $1<='$oomadj4'{print}' | while read psinfo; do bOOM; done
		echo ""
		echo " CONTENT_PROVIDER OOM GROUPING"
		echo " ============================="
		if [ "$HL" -gt "$oomadj4" ] && [ "$HL" -le "$oomadj5" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj4' && $1<='$oomadj5'{print}' | while read psinfo; do bOOM; done
		echo ""
		echo " EMPTY_APP OOM GROUPING"
		echo " ======================"
		if [ "$HL" -gt "$oomadj5" ] && [ "$HL" -le "$oomadj6" ]; then
			echo ""
			echo " HOME LAUNCHER IS IN HERE! (ADJ=$HL)"
			echo ""
		fi
		cat /data/!bOOM_Stick_COOKED.tmp | awk '$1>'$oomadj5' && $1<='$oomadj6'{print}' | while read psinfo; do bOOM; done
		echo ""
		echo $line
		if [ "$boomstick" = "vrOOM" ]; then echo "             vrOOM Stick Complete!"
		else echo "              zOOM Stick Complete!"
		fi
	fi >> /data/!bOOM_Stick_COOKED.log
	awk '/====/,0' /data/!bOOM_Stick_COOKED.log
	echo $line | tee -a  /data/!bOOM_Stick_COOKED.log
	echo "" | tee -a /data/!bOOM_Stick_COOKED.log
	$sleep
	if [ "$1" ]; then bOOM_Stick_End_Credits $1; fi
	rm /data/!bOOM_Stick*.tmp
}
install_sc_service(){
	for scs in $initrcpath $allrcpaths; do
		cat >> $scs <<EOF
# SuperCharger_Service created by -=zeppelinrox=-
#
# DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!
#
  ################################
 #  SuperCharger Service Notes  #
################################
# To restart the SuperCharger Service so it stays running, run Terminal Emulator and type...
# "su" and Enter.
# "start super_service" and Enter.
#
# To stop the SuperCharger Service, type...
# "su" and Enter.
# "stop super_service" and Enter.
#
# If the service is running and you type: "cat /proc/*/cmdline | grep Super".
# The output would be 2 items:
#     a. "/data/99SuperCharger.sh"
#     b. "Super" (created by your query so this doesn't mean anything)
#
# If it's not running, the output would be the last item ie. "Super" which was generated by the typed command.
#
# Similar results can be had with: "busybox ps | grep Super".
#
service super_service /system/bin/sh /data/99SuperCharger.sh
    class post-zygote_services
    user root
    group root
#
# End of SuperCharged_Service Entries.
EOF
		if [ "$scs" != "$initrcpath" ] && [ ! "$scsinfo" ]; then echo "   ...$scs!"; fi
		if [ ! "$scservice" ]; then $sleep; fi
	done
}
install_bp_service(){
	if [ "$1" ]; then
		echo $line
		echo " Installing BulletProof Apps Service to..."
		echo $line
		echo ""
		$sleep
	fi
	for bps in $initrcpath $allrcpaths; do
		sed -i '/BulletProof_Apps_Service/,/BulletProofed_Apps_Service/d' $bps
		cat >> $bps <<EOF
# BulletProof_Apps_Service created by -=zeppelinrox=-
#
# DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!
#
  ####################################
 #  BulletProof Apps Service Notes  #
####################################
# To stop the BulletProof Apps Service, run Terminal Emulator and type...
# "su" and Enter.
# "stop bullet_service" and Enter.
#
# To restart the BulletProof Apps Service, type...
# "su" and Enter.
# "start bullet_service" and Enter.
#
# If the service is running and you type: "cat /proc/*/cmdline | grep Bullet".
# The output would be 3 items:
#     a. "/data/97BulletProof_Apps.sh"
#     b. "BulletProof_Apps_is_In_Effect!" (sleep message)
#     c. "Bullet" (created by your query so this doesn't mean anything)
#
# If it's not running, the output would be the last item ie. "Bullet" which was generated by the typed command.
#
# Similar results can be had with: "busybox ps | grep Bullet".
#
service bullet_service /system/bin/sh /data/97BulletProof_Apps.sh
    class post-zygote_services
    user root
    group root
#
# End of BulletProofed_Apps_Service Entries.
EOF
		cp -fr $bps $storage/V6_SuperCharger
		if [ "$bps" != "$initrcpath" ] && [ "$1" ]; then echo "   ...$bps!"; $sleep; fi
	done
}
homeadj=`getprop ro.HOME_APP_ADJ`;FA=`getprop ro.FOREGROUND_APP_ADJ`;PA=`getprop ro.PERCEPTIBLE_APP_ADJ`;VA=`getprop ro.VISIBLE_APP_ADJ`;low=w
api="`grep ro.build.version.sdk /system/build.prop | sed 's/.*=//' | tr -d '\r'`"
if [ "$api" -ge 14 ]; then postics=yes;preics=;FA=0;PA=2
	if [ "$api" -ge 16 ]; then jb=1; fi
elif [ "$PA" ]; then gb=1
fi
for launchers in `grep set.*/*.Launcher /d*/system/packages.xml | sed 's:/*.L.*::' | sed 's/.*="//'` `grep "^<package.*serId" /d*/system/packages.xml | grep -E "adwfreak|zeam|tw3|tw4|tw5|nextgen|shell|home|trebuchet|launcher" | sed 's%.* name="\(.*\)".*%\1%' | cut -d '"' -f1` adwfreak zeam tw3 tw4 tw5 nextgen shell home trebuchet launcher acore; do
	validlauncher=`pgrep -l $launchers | awk '{print $2}' | grep -Ev "/|notification|gowidget|downloadservice"` 2>/dev/null
	if [ "$validlauncher" ] && [ ! "`echo $llist | grep $validlauncher`" ]; then llist="$llist $validlauncher"; fi 2>/dev/null
done
for l in $llist; do
  for lpid in `pgrep $l`; do loom_adj=`cat /proc/$lpid/$oom_adj`
	if [ "$loom_adj" -eq -1000 ]; then loom_adj=-16
	elif [ "$loom_adj" -eq 1000 ]; then loom_adj=15
	elif [ "${loom_adj#-}" -gt 20 ]; then loom_adj=`echo $loom_adj | awk '{printf "%.0f\n", $1*17/1000}'`
	fi
	if [ "$l" = "android.process.acore" ] && [ "$loom_adj" -lt 0 ]; then continue
	elif [ ! "$HL" ] || [ "$HL" -gt "$loom_adj" ]; then
		if [ "$lname" ] && [ "$lname" != "android.process.acore" ] && [ "$l" = "android.process.acore" ]; then
			echo $line
			echo ""
			$sleep
			echo " Erm... Is $lname the launcher?"
			echo ""
			$sleep
			echo -n " Enter N for No, any key for Yes: "
			read islauncher
			echo ""
			case $islauncher in
			  n|N);;
				*)continue;;
			esac
		fi
		HL=$loom_adj
		lname=$l
		if [ "$preics" ] && [ "$HL" -eq "$homeadj" ] && [ "$HL" -lt "$VA" ] && [ "$HL" -eq "$(($FA+1))" ]; then diehard=yes; break; fi
	fi
  done
done 2>/dev/null
if [ "$postics" ]; then
	adjs1=0; adjs3=0; adjs5=0; adjs6=0; adjs7=0
	if [ -f "/system/framework/services.odex" ]; then odex=yes; fi
	for i in `busybox ps | grep -v "\]$" | awk '{print $1}'`; do
		if [ -f "/proc/$i/$oom_adj" ]; then
			adj=`cat /proc/$i/$oom_adj`
			if [ "$adj" -eq -1000 ]; then adj=-16
			elif [ "$adj" -eq 1000 ]; then adj=15
			elif [ "${adj#-}" -gt 20 ]; then adj=`echo $adj | awk '{printf "%.0f\n", $1*17/1000}'`
			fi
			if [ "$adj" -eq 1 ]; then adjs1=$(($adjs1+1)); fi
			if [ "$adj" -eq 3 ]; then adjs3=$(($adjs3+1)); fi
			if [ "$adj" -eq 5 ]; then adjs5=$(($adjs5+1)); fi
			if [ "$adj" -eq 6 ]; then adjs6=$(($adjs6+1)); fi
			if [ "$adj" -eq 7 ]; then adjs7=$(($adjs7+1)); fi
		fi
	done 2>/dev/null
	if [ ! "$HL" ]; then HL=6; fi
	if [ "$odex" ] && [ "$adjs1" -gt 1 ]; then showparlor=yes; VA=1
	elif [ "$HL" -eq 1 ] && [ "$adjs1" -eq 1 ] || [ "$adjs3" -gt 0 ]; then servicesjarpatched=hellzyeah; VA=3
	elif [ "$HL" -eq 0 ] || [ "$HL" -eq 2 ] && [ "$adjs1" -eq 0 ]; then servicesjarpatched=hellzyeah; VA=3
	else VA=1
		if [ "$HL" -gt 2 ]; then
			if [ "$adjs5" -gt 1 ] && [ "$adjs6" -gt 1 ]; then showparlor=yes
			elif [ "$adjs7" -gt 0 ] || [ "$adjs5" -gt 0 ] && [ "$adjs6" -eq 1 ]; then showparlor=yes
			elif [ "$adjs7" -gt 0 ] || [ "$adjs6" -gt 0 ] && [ "$adjs5" -eq 1 ]; then showparlor=yes
			else servicesjarpatched=hellzyeah; usedwebapp=yes
			fi
		elif [ "$HL" -eq 1 ]; then servicesjarpatched=hellzyeah; usedwebapp=yes
		elif [ "$adjs7" -gt 0 ] || [ "$adjs5" -gt 0 ] && [ "$adjs6" -eq 0 ]; then showparlor=yes
		elif [ "$adjs7" -gt 0 ] || [ "$adjs6" -gt 0 ] && [ "$adjs5" -eq 0 ]; then showparlor=yes
		else servicesjarpatched=hellzyeah; usedwebapp=yes
		fi
		if [ -f "$storage/ultimatic.tmp" ]; then showparlor=; rm $storage/ultimatic.tmp; fi
	fi
fi
if [ "$preics" ] && [ "$HL" -gt "$homeadj" ]; then hijackedadj=$HL
	if [ "$homeadj" -eq "$(($FA+1))" ]; then hijackedlname=$lname; fi
elif [ "$servicesjarpatched" ] && [ "$HL" -gt 2 ]; then hijackedadj=$HL
	if [ "$adjs1" -eq 1 ]; then hijackedlname=$lname; fi
fi
if [ "$hijackedlname" ]; then
	for i in `busybox ps | grep -v "\]$" | awk '{print $1}'`; do
		if [ "`cat /proc/$i/$oom_adj`" -eq 1 ] || [ "`cat /proc/$i/$oom_adj`" -eq 58 ]; then
			HL=1
			lname=`cat /proc/$i/cmdline | sed 's:.*/::'`
			break
		fi
	done 2>/dev/null
fi
if [ "$lname" ]; then
	echo $line
	if [ "$hijackedadj" ] && [ ! "$hijackedlname" ]; then echo " $lname is NOT the Home Launcher!"
	else echo " $lname is the Home Launcher!"
	fi
	echo $line
	echo ""
	$sleep
	if [ "$hijackedadj" ]; then
		echo $line
		if [ "$hijackedlname" ]; then
			echo " BUT it may have HIJACKED Home Launcher Status!"
			echo $line
			echo ""
			$sleep
			echo " Since $hijackedlname... "
			echo ""
			$sleep
			echo "                 ...has an ADJ priority of $hijackedadj :P"
			echo ""
		else echo "  Home Launcher Status may have been HIJACKED!"
		fi
		echo $line
		echo ""
		$sleep
	fi
	echo -n " Verify groupings with the bOOM Stick"
	if [ "$lname" = "android.process.acore" ] && [ ! "$diehard" ]; then
		echo "..."
		echo ""
		$sleep
		echo "   ...since launchers often HIDE INSIDE IT..."
		echo ""
		$sleep
		echo "                  ...since I'm not 100% sure :P"
	else echo "!"
	fi
else
	echo $line
	echo ""
	$sleep
	echo " No home launcher detected in memory..."
	echo ""
	$sleep
	echo "      ...so it must have gotten killed already!"
fi
echo ""
echo $line
echo ""
$sleep
echo -n " Press The Enter Key... "
read enter
echo ""
echo $line
if [ "$preics" ] && [ "$lname" = "android.process.acore" ] && [ ! "$diehard" ] || [ ! "$HL" ]; then
	echo ""
	$sleep
	echo " Is Home is \"Locked in Memory\"?"
	echo ""
	$sleep
	echo " If it is, Enter Y for Yes, any key for No..."
	echo ""
	$sleep
	echo -n " Just say \"No\" if you don't know: "
	read homelocked
	echo ""
	case $homelocked in
	  y|Y)HL=$VA
		  echo " WHAT? You need to disable that feature!";;
		*)HL=$homeadj
		  echo " Good Stuff!";;
	esac
	echo ""
	echo $line
fi
Get_oomadj_Info
MFK_Calculator
if [ ! -f "$storage/V6_SuperCharger/SuperChargerAdj" ]; then rookie=yes; fi
if [ -f "$storage/V6_SuperCharger/SuperChargerAdj" ] && [ ! "`grep "SuperCharger" /system/build.prop`" ]; then newsupercharger=woohoo
	if [ -f "$initrcpath" ]; then rm $initrcpath; fi
	echo ""
	$sleep
	echo " Oh wait... Did you flash a new ROM or kernel?"
	echo ""
	$sleep
	echo " I Can Automagically..."
	echo ""
	$sleep
	echo $line
	echo "           Run The Re-SuperCharger!!"
	echo $line
	echo ""
	$sleep
	echo " This lets you restore settings and scripts..."
	echo ""
	$sleep
	echo "  ...without overwriting your new system files!"
	echo ""
	$sleep
	echo " You may need to install separately..."
	echo ""
	$sleep
	echo " ...a Launcher, Nitro Lag Nullifier & 3G Turbo."
	echo ""
	echo $line
	echo ""
	$sleep
	echo " Your previous V6 SuperCharger Settings are..."
	echo ""
	$sleep
	awk -F , '{print "               "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}' $storage/V6_SuperCharger/SuperChargerMinfree
	echo ""
	$sleep
	echo " Re-SuperCharge from $storage?"
	echo ""
	$sleep
	echo -n " Enter Y for Yes, any key for No: "
	read resuper
	echo ""
	echo $line
	case $resuper in
		y|Y)echo " Re-SuperCharger will Auto Load!"
			autoresupercharge=indeed;;
		  *)echo " Re-SuperCharging Declined... meh..."
			if [ "$firstgear" ]; then
				echo $line
				echo ""
				$sleep
				echo " Going to load Driver Options instead!"
				echo ""
			fi;;
	esac
elif [ "$firstgear" ]; then
	echo "                  Hey Rookie!!"
	echo $line
	echo ""
	$sleep
	echo " First Time SuperChargers..."
	echo ""
	$sleep
	echo "         ...will make a Pit Stop in..."
	echo ""
	$sleep
	echo "                             ...Driver Options!"
	echo ""
elif [ "$missingoptions" ]; then
	echo "           Missing Some NEW Options!!"
	echo $line
	echo ""
	$sleep
	echo " You need to refresh them so..."
	echo ""
	$sleep
	echo "         ...gonna make a Pit Stop in..."
	echo ""
	$sleep
	echo "                             ...Driver Options!"
	echo ""
else
	if [ "$panicmode" -eq 3 ]; then kpanic=0; kpoops=0
	elif [ "$panicmode" -eq 2 ]; then kpanic=30; kpoops=0
	else kpanic=30; kpoops=1
	fi
	script_version_check
	show_current_options
	echo " All settings can be changed in Driver Options!"
	echo ""
	$sleep
	echo $line
	echo " Note: You can bake $initrcpath into your ROM!"
fi 2>/dev/null
echo $line
echo ""
$sleep
if [ -f "/data/!!SuperChargerBootLoopMessage.log" ]; then
	echo $line
	echo "       DAMMIT... A Boot Loop Was Detected!"
	echo $line
	echo ""
	$sleep
	echo " Do Over! Re-Enabling /init.d/*99SuperCharger..."
	echo ""
	echo $line
	echo ""
	$sleep
	rm /data/!!SuperChargerBootLoopMessage.log
fi
chmod 777 $minfreefile
if [ "$adjfile" ]; then chmod 777 $adjfile; fi
echo -n " Press the Enter Key... and Come Get Some!! "
read getsome
while :; do
 MB0=4;MB1=0;MB2=0;MB3=0;MB4=0;MB5=0;MB6=0
 SL0=0;SL1=0;SL2=0;SL3=0;SL4=0;SL5=0;SL6=0
 scpercent=0;newlauncher=0;showbuildpropopt=0;break=0;restore=0;quickcharge=0;calculatorcharge=0;revert=0;ReSuperCharge=0;UnSuperCharged=0;UnSuperChargerError=0;SuperChargerScriptManagerHelp=0;SuperChargerHelp=0;scservice=;bpservice=
 Get_oomadj_Info
 for rc in $allrcpaths; do
	if [ -f "$rc.unsuper" ]; then allrcbackups="$allrcbackups $rc.unsuper"; fi
	if [ "`grep "super_service" $rc`" ]; then scservice="scsinstalled"; fi
	if [ "`grep "bullet_service" $rc`" ]; then bpservice="bpsinstalled"; fi
 done
 if [ "$opt" -ne 69 ]; then echo ""; else $sleep; fi
 echo $line
 echo " For Help & Info, see $storage/!SuperCharger.html"
 echo $line
 $sleep
 echo " \\\\\\\\ T H E  V 6   S U P E R C H A R G E R ////"
 echo "  ============================================"
 echo "        \\\\\\\\    Driver's Console    ////"
 echo "         =============================="
 echo ""
 echo "1. SuperCharger & Launcher Status{Update 9 RC12}"
 echo "                                               }"
 echo "==================== 256 HP ===================="
 echo "2. UnLedded  (Multitasking){8,12,22,24,26,28 MB}"
 echo "3. Ledded        (Balanced){8,12,26,28,30,32 MB}"
 echo "4. Super UL    (Aggressive){8,12,28,30,35,50 MB}"
 echo "                                               }"
 echo "==================== 512 HP ===================="
 echo "5. UnLedded (Multitasking){8,14,40,50,60, 75 MB}"
 echo "6. Ledded       (Balanced){8,14,55,70,85,100 MB}"
 echo "7. Super UL   (Aggressive){8,14,75,90,95,125 MB}"
 echo "                                               }"
 echo "=================== 768+ HP ===================="
 echo "8. Super 768HP(Aggressive){8,16,150,165,180,200}"
 echo "9. Super 1000HP(Agressive){8,16,200,220,240,275}"
 echo "                                               }"
 echo $line
 echo -n "10. Quick V6 Cust-OOMizer "
 if [ "$sccminfree" ]; then echo $sccminfree | awk -F , '{print "{"$1/256","$2/256","$3/256","$4/256","$5/256","$6/256"}"}'
 else echo "  {Create Or Restore!}"
 fi
 echo $line
 echo "11. OOM Grouping Fixes + Hard To Kill Launcher }"
 echo "12. OOM Grouping Fixes + Die-Hard Launcher     }"
 echo "13. OOM Grouping Fixes + BulletProof Launcher  }"
 echo $line
 echo "14. UnSuperCharger             {UnDo Everything}"
 echo $line
 echo "15. The bOOM Stick        {Verify OOM Groupings}"
 echo "16. BulletProof Apps               {Hit or Miss}"
 echo "17. Engine Flush-O-Matic   {ReCoupe RAM Booster}"
 echo "18. Detailing         {Vacuum & Reindex SQL DBs}"
 echo "19. Wheel Alignment              {ZipAlign APKs}"
 echo "20. Fix Emissions             {Fix FCing Errors}"
 echo "21. Fix Alignment           {ZipAlign & Fix FCs}"
 echo "22. Nitro Lag Nullifier           {Experimental}"
 echo $line
 echo "23. System Installer            {Terminal Usage}"
 echo "24. Re-SuperCharger        {Restore V6 Settings}"
 echo "25. Jelly ISCream Parlor  {Install services.jar}"
 echo "26. PowerShifting         {Switch Presets FAST!}"
 echo $line
 echo "27. Owner's Guide      {Open !SuperCharger.html}"
 echo "28. Help Centre             {Open XDA SC Thread}"
 echo "29. Driver Options                    {Settings}"
 echo "30. SuperCharge You                    {Really!}"
 echo "31. ReStart Your Engine       {Reboot Instantly}"
 echo "32. SuperClean & ReStart  {Wipe Dalvik & Reboot}"
 echo "33. Eject                                 {Exit}"
 echo $line
 echo " \\\\\\\\      The One and ONLY OOM Fixer!     ////"
 echo "  ============================================"
 if [ "$ran" -eq 0 ] && [ ! "$rookie" ]; then
	echo "    So is it working? READ MESSAGES BELOW ;^]"
	echo $line
	echo "     The Next 4 Sections Are Worth 25% Each!"
	echo $line
 fi
 echo ""
 echo -n "   Launcher is"
 if [ "$postics" ] && [ ! "$servicesjarpatched" ]; then echo " NOT Patched.... so.... weak :("; status=4
 elif [ "$usedwebapp" ]; then echo " Patched via WebApp ie. Very Weak!"; status=3
 elif [ "$HL" -gt "$VA" ]; then echo ".... so.... weak.... :("; status=4
 elif [ "$HL" -eq "$VA" ]; then echo " Locked In Memory ie. Very Weak!"; status=3
 else oomstick=1; scpercent=$(($scpercent+25))
	if [ "$HL" -eq "$FA" ]; then echo -n " BULLETPROOF ="; status=0
	elif [ "$HL" -eq "$(($FA+1))" ]; then echo -n " DIE-HARD! ie."; status=1
	else echo -n " HARD TO KILL="; status=2
	fi
	echo -n " SUPERCHARGED"
	if [ "$ran" -eq 1 ]; then echo "!"
	else echo "!  $scpercent%"
	fi
 fi
 echo ""
 echo $line
 sleep 2
 echo -n "   SuperCharger ADJ Entries "
 if [ "$servicesjarpatched" ]; then ADJs=1; scpercent=$(($scpercent+25))
	echo -n "ARE Patched In"
	if [ "$ran" -eq 1 ]; then echo "!"
	else echo "! $scpercent%"
	fi
 elif [ "$postics" ]; then
	echo "ARE NOT Patched In!"
	echo "   Select The \"Jelly ISCream Parlor\" Option!"
 elif [ "`grep "V6 SuperCharger" /system/build.prop`" ]; then ADJs=1; scpercent=$(($scpercent+25))
	echo -n "in build.prop"
	if [ "$ran" -eq 1 ]; then echo "!"
	else echo "!  $scpercent%"
	fi
 elif [ -f "/data/local.prop" ] && [ "`grep "V6 SuperCharger" /data/local.prop`" ]; then ADJs=1; scpercent=$(($scpercent+25))
	echo -n "in local.prop"
	if [ "$ran" -eq 1 ]; then echo "!"
	else echo "!  $scpercent%"
	fi
 else echo "NOT Found!"
 fi
 echo $line
 if [ "$currentadj" = "$newscadj" ] || [ "$currentadj" = "$oldscadj1" ] || [ "$currentadj" = "$oldscadj2" ] || [ "$currentadj" = "$oldscadj3" ] || [ "$currentadj" = "$oldscadj4" ] || [ "$currentadj" = "$scamadj1" ]; then OOMs=1; scpercent=$(($scpercent+25))
	if [ "$currentadj" != "$newscadj" ]; then
		echo ""
		echo "   NON-SuperCharger OOM Grouping In Effect  $scpercent%"
		echo ""
		if [ "$currentadj" = "$scamadj1" ]; then
			echo "         ...and Home Is NOT \"Locked In Memory\"!"
			echo "   If you thought it was, you were mislead..."
			echo ""
			echo "   Apps simply got moved up a slot..."
			echo "     ...so the minfrees become less aggressive!"
			echo ""
			echo $line
			echo "                You Got SCAMMED!"
		fi
		echo $line
	elif [ ! "$scadj" ] && [ "$ran" -eq 0 ]; then echo "   OOM Grouping Fixes ARE In Effect!        $scpercent%"; echo $line
	fi
 elif [ "$currentadj" = "$scamadj2" ]; then
	echo "   Found \"Stockish\" OOM Grouping..."
	echo "             ...which basically does nothing :P"
	echo $line
 fi
 if [ "$ran" -eq 1 ]; then scpercent=$(($scpercent+25))
 else
	if  [ "$showparlor" ] || [ "$usedwebapp" ] && [ "$postics" ]; then
		echo ""
		echo "   SuperCharged Launcher is NOT in effect..."
		if [ "$showparlor" ]; then
			echo "   This ROM WON'T load values from a prop file!"
			echo "   You can do it with a SERVICES.JAR patch..."
			echo "   Just pick the \"Jelly ISCream Parlor\" Option!"
			echo "   Note: Automatic Transmission is OUTDATED!"
		else
			echo "   It was Patched with the OUTDATED WebApp!"
			echo "   Pick the \"Jelly ISCream Parlor\" Option!"
		fi
		echo "           ...See the XDA Thread for more info."
	elif [ "$scadj" ] && [ "$status" -eq 3 ]; then
		echo ""
		echo "   Home Launcher is \"Locked in Memory\"!"
		echo "   You need to DISABLE this shi... feature..."
		echo "          ...In both ROM and Launcher settings!"
	elif [ "$preics" ] && [ "$scadj" ] && [ "$oomstick" -eq 0 ] && [ "$buildprop" -eq 0 ]; then
		echo ""
		echo "   SuperCharged Launcher Is NOT In Effect!"
		echo "   You may need to use the build.prop option..."
		echo "   Select 2 - 13 from the menu NOW to access it!"
		showbuildpropopt=1
	fi
	if [ "$preics" ] && [ "$scadj" ] && [ "$oomstick" -eq 0 ] && [ "$buildprop" -eq 0 ] || [ "$showparlor" ] || [ "$usedwebapp" ]; then echo ""; echo $line; fi
	if [ "$scadj" ] && [ "$currentadj" != "$scadj" ]; then
		echo ""
		echo "   OOM Grouping Fixes ARE NOT In Effect!"
		echo "   That means the boot script did NOT run..."
		echo "   Select \"Owner's Guide\" on menu for Repairs!"
	elif [ "$scadj" ] && [ "$currentadj" = "$scadj" ]; then
		echo ""
		echo "   OOM Grouping Fixes ARE In Effect!        $scpercent%"
		echo "   That means the boot script ran!"
	else newsupercharger=woohoo
	fi
	if [ "$showparlor" ] || [ "$usedwebapp" ] || [ "$scadj" ]; then echo ""; echo $line; fi
	if [ "$scminfree" ]; then echo ""; fi
	if [ "$scminfree" ] && [ "$currentminfree" != "$scminfree" ]; then
		echo "   Current Values DON'T MATCH Prior SuperCharge!"
		if [ -f "/data/Ran_SuperCharger.log" ]; then echo "   Check /data/Ran_SuperCharger for boot info."
		else echo "   The boot script *99SuperCharger did NOT run!"
		fi
		echo "   Select \"Owner's Guide\" on menu for Repairs!"
	elif [ "$scminfree" ] && [ "$currentminfree" = "$scminfree" ]; then minfrees=1; scpercent=$(($scpercent+25))
		echo -n "   Current Values MATCH Prior SuperCharge!"
		if [ "$scpercent" -lt 100 ]; then echo "  $scpercent%"
		else echo " $scpercent%"
		fi
		echo "   That means that it's working! ;)"
	fi
 fi
 if [ ! "$scminfree" ]; then
	echo "   SuperCharger Minfrees NOT FOUND! Run 2 - 10!"
	echo $line
 else echo ""; echo $line
 fi
 echo $currentminfree | awk -F , '{OFMT="%.0f"; print "   Current Minfrees = "$1/256","$2/256","$3/256","$4/256","$5/256","$6/256" MB"}'
 if [ "$scminfreeold" ]; then echo $scminfreeold | awk -F , '{print "  Prior V6 Minfrees = "$1/256","$2/256","$3/256","$4/256","$5/256","$6/256" MB"}'; fi
 echo $line
 echo ""
 echo "   You have $ram MB of RAM on your device..."
 if [ "$ram" -lt 256 ]; then echo -n "         ...256 HP"
	calculatedmb="8, 12, $(($ram*11/100)), $(($ram*12/100)), $(($ram*13/100)), $(($ram*14/100))"
 elif [ "$ram" -lt 512 ]; then echo -n "         ...512 HP"
	calculatedmb="8, 12, $(($ram*11/100)), $(($ram*13/100)), $(($ram*15/100)), $(($ram*17/100))"
 elif [ "$ram" -lt 640 ]; then echo -n "         ...768 HP"
	calculatedmb="8, 14, $(($ram*13/100)), $(($ram*15/100)), $(($ram*17/100)), $(($ram*19/100))"
 elif [ "$ram" -lt 768 ]; then echo -n "         ...768 HP"
	calculatedmb="8, 14, $(($ram*15/100)), $(($ram*17/100)), $(($ram*19/100)), $(($ram*21/100))"
 elif [ "$ram" -lt 896 ]; then echo -n "         ...1000 HP"
	calculatedmb="8, 14, $(($ram*17/100)), $(($ram*19/100)), $(($ram*21/100)), $(($ram*23/100))"
 else echo -n "         ...1000 HP"
	calculatedmb="8, 16, $(($ram*20/100)), $(($ram*22/100)), $(($ram*24/100)), $(($ram*26/100))"
 fi
 calculatedminfree=`echo $calculatedmb | awk -F , '{print $1*256","$2*256","$3*256","$4*256","$5*256","$6*256}'`
 calculatedmbnosp=`echo $calculatedminfree | awk -F , '{print $1/256","$2/256","$3/256","$4/256","$5/256","$6/256}'`
 echo " settings are recommended!"
 echo ""
 if [ "$currentminfree" != "$calculatedminfree" ]; then
	echo "          -=SuperMinFree Calculator=- says:"
	echo ""
	echo "   Cust-OOMize with $calculatedmb MB!"
	echo ""
	echo "   Slot 3 Sets Free RAM & Is Your Task Killer!"
	echo ""
 else
	echo " BUT SuperMinFree Calculator Values are set..."
	echo ""
	echo $line
	echo "               SO THAT'S COOL TOO!"
 fi
 echo $line
 if [ "$currentminfree" != "`cat $storage/V6_SuperCharger/SuperChargerMinfree`" ] && [ "$ran" -eq 0 ]; then
	echo "   Re-SuperCharger Settings on $storage..."
	echo ""
	awk -F , '{print "                    "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}' $storage/V6_SuperCharger/SuperChargerMinfree
	echo $line
 fi 2>/dev/null
 if [ "$allrcpaths" ]; then
	echo ""
	echo " STOCK ROMS will benefit most from Services..."
	echo "   ...since those builds have no init.d support!"
	echo ""
	if [ "$scservice" ] || [ "$bpservice" ] || [ ! "$scminfree" ]; then
		echo $line
		echo -n "       SuperCharger Service is "
		if [ "$scservice" ]; then echo "Installed!"
		else echo "NOT Installed!"
		fi
		echo $line
		echo -n "   BulletProof Apps Service is "
		if [ "$bpservice" ]; then echo "Installed!"
		else echo "NOT Installed!"
		fi
	else
		if [ "$minfrees" -eq 0 ]; then echo $line; fi
		echo " Sorry, your ROM wipes service entries on boot."
		if [ "$minfrees" -eq 1 ]; then
			echo ""
			echo $line
			echo " But the Minfrees Match so it doesn't matter!"
		fi
	fi
	echo $line
 fi
 if [ ! -f "`ls /system/etc/init.d/*BulletProof_Apps*`" ] && [ ! -f "/data/97BulletProof_Apps.sh" ]; then echo "    BulletProof Apps Script is NOT Installed!"
 elif [ "`busybox ps$w | grep Bullet | grep Proof`" ]; then
	for i in `busybox ps$w | grep Bullet`; do
		if [ "`echo $i | grep Effect`" ]; then echo "           $i"; echo $line
		elif [ "`echo $i | grep "init\.d"`" ]; then echo " `echo $i | sed 's/.*etc//'` is Running!"; echo $line
		elif [ "`echo $i | grep data`" ]; then echo "$i is Running!"; echo $line
		fi
	done
	ldone=yes
 elif [ "`ls /system/etc/init.d/*BulletProof_Apps*`" ]; then echo " `ls /system/etc/init.d/*BulletProof_Apps* | sed 's/.*etc//'` is NOT Running!"
 else echo "/data/97BulletProof_Apps.sh is NOT Running!"
 fi 2>/dev/null
 if [ "$ldone" ]; then ldone=
 else echo $line
 fi
 if [ ! -f "/system/etc/init.d/96superflush" ] && [ ! -f "/system/xbin/flush" ] && [ ! -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then echo "          Fast Engine Flush is NOT Installed!"
 elif [ "$flushOmaticHours" -eq 0 ]; then echo "       Engine Flush-O-Matic is NOT Enabled!"
 elif [ "`busybox ps$w | grep -i flush | grep -E "_|/"`" ]; then
	for i in `busybox ps$w | grep -i flush | grep -E "_|/"`; do
		if [ "`echo $i | grep Effect`" ]; then echo "       $i"; echo $line
		elif [ "`echo $i | grep "init\.d"`" ]; then echo "   `echo $i | sed 's/.*system//'` is Running!"; echo $line
		elif [ "`echo $i | grep xbin`" ]; then echo "         $i is Running!"; echo $line
		elif [ "`echo $i | grep data`" ]; then echo "        `echo $i | sed 's:.*SuperCharger/::'` is Running!"; echo $line
		fi
	done
	ldone=yes
 else echo "       Engine Flush-O-Matic is ON & NOT in RAM!"
	echo $line
	if [ -f "/system/etc/init.d/96superflush" ]; then echo "   /etc/init.d/96superflush is NOT Running!"
	elif [ -f "/system/xbin/flush" ]; then echo "         /system/xbin/flush is NOT Running!"
	else echo "        !FastEngineFlush.sh is NOT Running!"
	fi
 fi 2>/dev/null
 if [ "$ldone" ]; then ldone=
 else echo $line
 fi
 echo -n "        Nitro Lag Nullifier is "
 if [ "`grep Nullifier /system/build.prop`" ]; then echo "Installed!"
 else echo "NOT Installed!"
 fi
 echo $line
 if [ `cat /proc/sys/kernel/random/entropy_avail` -gt 1000 ]; then echo " Whoah... Your Entropy-ness is THIS BIG => `cat /proc/sys/kernel/random/entropy_avail`"
 else echo "      Entropy-ness Envy? It is THIS small => `cat /proc/sys/kernel/random/entropy_avail`"
 fi
 echo $line
 echo ""
 if [ "$postics" ]; then echo " Lag? Disabling Compcache May Help!"
 else echo " Lag? Disable Lock Home in Memory & Compcache!"
 fi
 echo " Also Run Engine Flush Every Few Hours!"
 echo ""
 if [ "$smrun" ]; then
	echo " In Config, select Run as Root & Browse as Root!"
	echo " But DO NOT run this script at boot!"
	echo ""
	echo " For a quick status check..."
	echo " ...put a V6 SuperCharger WIDGET on the desktop!"
 else
	echo " Optimized for display with Script Manager."
	echo ""
	echo " SM can give you a quick status check..."
	echo " ...Put a V6 SuperCharger WIDGET on the desktop!"
	echo "                                  ...Try it! ;^]"
 fi
 echo ""
 echo $line
 ramkbytesfree=`free | awk 'NR==2{print $4}'`
 ramkbytescached=`cat /proc/meminfo | grep Cached | awk 'NR==1{print $2}'`
 ramfree=$(($ramkbytesfree/1024));ramcached=$(($ramkbytescached/1024));ramreportedfree=$(($ramfree + $ramcached))
 echo " True Free $ramfree MB = \"Free\" $ramreportedfree - Cached Apps $ramcached"
 echo $line
 echo "     SuperCharger Level: $scpercent% SuperCharged!"
 echo $line
 if [ "$scpercent" -eq 0 ] && [ "$rookie" ]; then
	echo " Hey Rookie! SCROLL UP to see the Menu Options!"
	echo $line
 elif [ "$ran" -eq 1 ] && [ "$scpercent" -lt 90 ]; then
	echo " Did it work? READ ABOVE MESSAGES AFTER REBOOT!"
	echo $line
 elif [ "$scpercent" -lt 100 ]; then
	if [ "$ADJs" -eq 0 ]; then echo " Lose 25% - ADJ Entries NOT Found / NOT Patched"; fi
	if [ "$oomstick" -eq 0 ]; then echo " Lose 25% - SuperCharged Launcher NOT In Effect"; fi
	if [ "$OOMs" -eq 0 ]; then echo " Lose 25% - OOM Grouping Fix(adj) NOT In Effect"; fi
	if [ "$minfrees" -eq 0 ]; then echo " Lose 25% - SuperCharger Minfrees NOT In Effect"; fi
	if [ "$usedwebapp" ]; then echo $line; echo "       OUTDATED Web App Patch Is In Effect"; fi
	echo $line
 fi
 $sleep
 if [ ! "$didsomething" ] && [ ! "$missingoptions" ] && [ ! "$newsupercharger" ] && [ "$scminfree" ] && [ "$currentminfree" != "$scminfree" ]; then
	if [ -d "/system/etc/init.d" ] && [ "`ls /system/etc/init.d/*SuperCharger*`" ] || [ ! -d "/system/etc/init.d" ]; then
		echo ""
		echo " Values DON'T MATCH... Read The Owner's Guide!"
		echo ""
		echo $line
		echo ""
		$sleep
		su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://$storage/!SuperCharger.html" 2>/dev/null
		echo ""
		echo $line
	fi 2>/dev/null
 fi
 echo -n "     Please Enter Option [1 - 33]: "
 if [ "$autoresupercharge" ]; then opt=24; echo $opt
 elif [ "$firstgear" ] || [ "$missingoptions" ]; then opt=29; echo $opt
 elif [ "$autoshowcalculated" ] && [ "$currentminfree" != "$calculatedminfree" ]; then opt=10; echo $opt
 elif [ "$postics" ] && [ "$scadj" ] && [ "$showparlor" ]; then opt=25; echo $opt
 elif [ "$ADJs" -eq 0 ] || [ "$oomstick" -eq 0 ] && [ ! "$showedboomstick" ]; then opt=1; echo $opt
 else read opt
 fi
 $sleep
 echo $line
 echo "            \\\\\\\\ V6 SUPERCHARGER ////"
 echo "             ======================="
 echo ""
 $sleep
 if [ "$opt" -ge 1 ] && [ "$opt" -le 29 ] || [ "$opt" -eq 32 ]; then didsomething=yes
	mount -o remount,rw / 2>/dev/null
	mount -o remount,rw rootfs 2>/dev/null
	busybox mount -o remount,rw / 2>/dev/null
	busybox mount -o remount,rw rootfs 2>/dev/null
	mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw /system 2>/dev/null
	busybox mount -o remount,rw $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
	if [ -d "/sqlite_stmt_journals" ]; then madesqlitefolder=0
	else mkdir /sqlite_stmt_journals; madesqlitefolder=1
	fi
	if [ "$opt" -ne 14 ]; then
		if [ ! "`grep "SuperCharger Installation" /system/build.prop`" ]; then echo "# SuperCharger Installation Marker." >> /system/build.prop; fi
		if [ ! -d "/data/V6_SuperCharger" ]; then mkdir /data/V6_SuperCharger; fi
		if [ ! -d "/data/V6_SuperCharger/PowerShift_Scripts" ]; then mkdir /data/V6_SuperCharger/PowerShift_Scripts; fi
		if [ ! -d "/data/V6_SuperCharger/BulletProof_One_Shots" ]; then mkdir /data/V6_SuperCharger/BulletProof_One_Shots; fi
	fi
 fi 2>/dev/null
 case $opt in
  1) echo "      V6 SUPERCHARGER AND LAUNCHER STATUS!";;
  2) if [ "$preics" ]; then echo "            256HP UNLEDDED MINFREES +"
	 else echo "        256HP UNLEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="256HP UnLedd"
	 MB1=8;MB2=12;MB3=22;MB4=24;MB5=26;MB6=28;;
  3) if [ "$preics" ]; then echo "             256HP LEDDED MINFREES +"
	 else echo "         256HP LEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="256HP Ledded"
	 MB1=8;MB2=12;MB3=26;MB4=28;MB5=30;MB6=32;;
  4) if [ "$preics" ]; then echo "         256HP SUPER UNLEDDED MINFREES +"
	 else echo "     256HP SUPER UNLEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="256HP Super"
	 MB1=8;MB2=12;MB3=28;MB4=30;MB5=35;MB6=50;;
  5) if [ "$preics" ]; then echo "            512HP UNLEDDED MINFREES +"
	 else echo "        512HP UNLEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="512HP UnLedd"
	 MB1=8;MB2=14;MB3=40;MB4=50;MB5=60;MB6=75;;
  6) if [ "$preics" ]; then echo "             512HP LEDDED MINFREES +"
	 else echo "         512HP LEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="512HP Ledded"
	 MB1=8;MB2=14;MB3=55;MB4=70;MB5=85;MB6=100;;
  7) if [ "$preics" ]; then echo "         512HP SUPER UNLEDDED MINFREES +"
	 else echo "     512HP SUPER UNLEDDED MINFREES SELECTED!"
	 fi
	 CONFIG="512HP Super"
	 MB1=8;MB2=14;MB3=75;MB4=90;MB5=95;MB6=125;;
  8) if [ "$preics" ]; then echo "         768HP SUPER UNLEDDED MINFREES +"
	 else echo "     768HP SUPER UNLEDDED MINFREES SELECTED!"
	 fi
	 if [ "$ram" -le 256 ]; then opt=26
		echo $line
		$sleep
		echo "      WHOA! There's NOT Enough RAM! lulz!"
	 else
		CONFIG="768HP Super"
		MB1=8;MB2=16;MB3=150;MB4=165;MB5=180;MB6=200
	 fi;;
  9) if [ "$preics" ]; then echo "         1000HP SUPER UNLEDDED MINFREES +"
	 else echo "     1000HP SUPER UNLEDDED MINFREES SELECTED!"
	 fi
	 if [ "$ram" -le 256 ]; then opt=26
		echo $line
		$sleep
		echo "      WHOA! There's NOT Enough RAM! lulz!"
	 else
		CONFIG="1000HP Super"
		MB1=8;MB2=16;MB3=200;MB4=220;MB5=240;MB6=275
	 fi;;
  10)if [ "$preics" ]; then echo "             CUST-OOMIZER MINFREES +"
	 else echo "         CUST-OOMIZER MINFREES SELECTED!"
	 fi
	 CONFIG="Cust-OOMized"
	 echo $line
	 echo ""
	 $sleep
	 echo " Your Current Minfree values are..."
	 echo ""
	 $sleep
	 echo $currentminfree | awk -F , '{OFMT="%.0f"; print "               "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}'
	 echo ""
	 $sleep
	 echo " Your SuperMinFree Calculator values are..."
	 echo ""
	 $sleep
	 echo "               $calculatedmb MB"
	 echo ""
	 if [ "$sccminfree" ]; then
		$sleep
		echo " Your Prior Cust-OOMizer values are..."
		echo ""
		$sleep
		echo $sccminfree | awk -F , '{print "               "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}'
		echo ""
	 fi
	 if [ "$scminfreeold" ] && [ "$currentminfree" != "$scminfreeold" ]; then
		$sleep
		echo " Your Prior V6 Minfrees are..."
		echo ""
		$sleep
		echo $scminfreeold | awk -F , '{print "               "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}'
		echo ""
	 fi
	 echo $line
	 if [ "$sccminfree" ] && [ "$currentminfree" != "$sccminfree" ] && [ "$calculatedminfree" != "$sccminfree" ] && [ ! "$autoshowcalculated" ]; then
		echo ""
		$sleep
		echo " Restore Previous Cust-OOMizer Settings?"
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read crestore
		echo ""
		echo $line
		case $crestore in
		  y|Y)restore=1
			  MB1=`echo $sccminfree | awk -F , '{print $1/256}'`;MB2=`echo $sccminfree | awk -F , '{print $2/256}'`;MB3=`echo $sccminfree | awk -F , '{print $3/256}'`;MB4=`echo $sccminfree | awk -F , '{print $4/256}'`;MB5=`echo $sccminfree | awk -F , '{print $5/256}'`;MB6=`echo $sccminfree | awk -F , '{print $6/256}'`
			  echo "    Cust-OOMizer Settings will be Restored!";;
			*);;
		esac
	 fi
	 if [ "$currentminfree" != "$calculatedminfree" ] && [ "$calculatedminfree" != "$scminfree" ] && [ "$restore" -eq 0 ]; then
		echo ""
		$sleep
		echo " Apply SuperMinFree Calculator Settings?"
		echo ""
		$sleep
		if [ "$autoshowcalculated" ]; then echo " If not, come back later for more options!"
		else echo " If not, there are still more options ahead!"
		fi
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read calculated
		echo ""
		echo $line
		case $calculated in
		  y|Y)calculatorcharge=1
			  CONFIG="Calculator"
			  MB1=`echo $calculatedmbnosp | awk -F , '{print $1}'`;MB2=`echo $calculatedmbnosp | awk -F , '{print $2}'`;MB3=`echo $calculatedmbnosp | awk -F , '{print $3}'`;MB4=`echo $calculatedmbnosp | awk -F , '{print $4}'`;MB5=`echo $calculatedmbnosp | awk -F , '{print $5}'`;MB6=`echo $calculatedmbnosp | awk -F , '{print $6}'`
			  echo "  Cust-OOMizing with SuperMinFree Calculator!";;
			*)if [ "$autoshowcalculated" ]; then echo " Well... I tried to do you a favour... sheesh!"; fi;;
		esac
	 fi 2>/dev/null
	 if [ "$scminfreeold" ] && [ "$currentminfree" != "$scminfreeold" ] && [ "$sccminfree" != "$scminfreeold" ] && [ "$calculatedminfree" != "$scminfreeold" ] && [ "$restore" -eq 0 ] && [ "$calculatorcharge" -eq 0 ] && [ ! "$autoshowcalculated" ]; then
		echo ""
		$sleep
		echo " Revert to Prior V6 Minfrees?"
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read prior
		echo ""
		echo $line
		case $prior in
		  y|Y)revert=1
			  MB1=`echo $scminfreeold | awk -F , '{print $1/256}'`;MB2=`echo $scminfreeold | awk -F , '{print $2/256}'`;MB3=`echo $scminfreeold | awk -F , '{print $3/256}'`;MB4=`echo $scminfreeold | awk -F , '{print $4/256}'`;MB5=`echo $scminfreeold | awk -F , '{print $5/256}'`;MB6=`echo $scminfreeold | awk -F , '{print $6/256}'`
			  echo "      Prior V6 Minfrees will be Restored!";;
			*);;
		esac
	 fi 2>/dev/null
	 if [ "$currentminfree" != "$sccminfree" ] && [ "$currentminfree" != "$scminfree" ] && [ "$restore" -eq 0 ] && [ "$calculatorcharge" -eq 0 ] && [ "$revert" -eq 0 ] && [ ! "$autoshowcalculated" ]; then
		echo ""
		$sleep
		echo " Apply Quick SuperCharge of Current Minfrees?"
		echo ""
		$sleep
		echo " If Yes, these become your Cust-OOMizer values."
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read quick
		echo ""
		echo $line
		case $quick in
		  y|Y)quickcharge=1
			  MB1=`echo $currentminfree | awk -F , '{printf "%.0f\n", $1/256}'`;MB2=`echo $currentminfree | awk -F , '{printf "%.0f\n", $2/256}'`;MB3=`echo $currentminfree | awk -F , '{printf "%.0f\n", $3/256}'`;MB4=`echo $currentminfree | awk -F , '{printf "%.0f\n", $4/256}'`;MB5=`echo $currentminfree | awk -F , '{printf "%.0f\n", $5/256}'`;MB6=`echo $currentminfree | awk -F , '{printf "%.0f\n", $6/256}'`
			  echo "   Quick Cust-OOMizer Settings will be Saved!";;
			*);;
		esac
	 fi 2>/dev/null
	 if [ "$restore" -eq 0 ] && [ "$calculatorcharge" -eq 0 ] && [ "$quickcharge" -eq 0 ] && [ "$revert" -eq 0 ] && [ ! "$autoshowcalculated" ]; then
		echo " Running Cust-OOMizer..."
		echo $line
		$sleep
		echo "            \\\\\\\\ V6 CUST-OOMIZER ////"
		echo "             ======================="
		echo ""
		$sleep
		echo " Enter your desired lowmemorykiller OOM levels!"
		echo ""
		$sleep
		echo " Slot 3 determines your free RAM the most!!"
		echo ""
		$sleep
		echo " Note: Enter \"X\" to Exit at any time ;^]"
		echo ""
		echo $line
		echo ""
		$sleep
		while [ "$break" -eq 0 ]; do
			echo -n "               Slot 1: ";read MB1
			if [ "$MB1" = "X" ] || [ "$MB1" = "x" ]; then break=1
			elif [ "$MB1" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		while [ "$break" -eq 0 ]; do
			echo -n "                 Slot 2: ";read MB2
			if [ "$MB2" = "X" ] || [ "$MB2" = "x" ]; then break=1
			elif [ "$MB2" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		while [ "$break" -eq 0 ]; do
			echo -n "                   Slot 3: ";read MB3
			if [ "$MB3" = "X" ] || [ "$MB3" = "x" ]; then break=1
			elif [ "$MB3" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		while [ "$break" -eq 0 ]; do
			echo -n "                     Slot 4: ";read MB4
			if [ "$MB4" = "X" ] || [ "$MB4" = "x" ]; then break=1
			elif [ "$MB4" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		while [ "$break" -eq 0 ]; do
			echo -n "                       Slot 5: ";read MB5
			if [ "$MB5" = "X" ] || [ "$MB5" = "x" ]; then break=1
			elif [ "$MB5" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		while [ "$break" -eq 0 ]; do
			echo -n "                         Slot 6: ";read MB6
			if [ "$MB6" = "X" ] || [ "$MB6" = "x" ]; then break=1
			elif [ "$MB6" -gt 0 ] 2>/dev/null; then break
			else echo " Input Error!                      Try again :p";sleep 2; fi
		done
		echo ""
		if [ "$break" -eq 0 ]; then
			$sleep
			echo $line
			echo " CONFIRM! $MB1, $MB2, $MB3, $MB4, $MB5, $MB6 MB?"
			echo $line
			echo ""
			$sleep
			echo -n " Enter N for No, any key for Yes: "
			read custOOM
			echo ""
			case $custOOM in
			  n|N)opt=26;;
				*)echo $line
				  echo "        Cust-OOMizer Settings Accepted!";;
			esac
		fi
	 fi
	 if [ "$break" -eq 1 ] || [ "$MB1" -eq 0 ]; then opt=26; fi
	 autoshowcalculated=;;
  11)echo " OOM GROUPING FIXES PLUS..."
	 echo ""
	 echo "                      ...HARD TO KILL LAUNCHER!"
	 $sleep
	 echo $line
	 echo "   This Launcher Is Strong BUT Still Killable"
	 echo $line
	 echo ""
	 $sleep
	 if [ "$gb" -eq 1 ]; then launcheradj=2
		update_options
		echo $line
		echo "             Driver Options Updated!"
	 else
		if [ "$postics" ]; then
			echo " This CAN'T SuperCharge ADJs on POST-ICS ROMS!"
			echo ""
			$sleep
			echo " It can only apply adj/Grouping Fixes..."
			echo ""
			$sleep
			echo "                           ...and other tweaks!"
			echo ""
			$sleep
			echo $line
			if [ "$servicesjarpatched" ]; then
				echo " Hey your services.jar is already patched..."
				echo ""
				$sleep
				echo "             ...with a Hard To Kill Launcher..."
				echo ""
				$sleep
					if [ "$HL" -eq 2 ]; then echo "                               ...so who cares!"
					else echo "  See The \"Jelly ISCream Parlor\" to change it!"
					fi
			else echo " Select The \"Jelly ISCream Parlor\" Option Next!"
			fi
		else opt=26
			echo " Sorry, Hard To Kill Launcher..."
			echo ""
			$sleep
			echo "             ...is not available on this ROM..."
			echo ""
		fi
	 fi;;
  12)echo " OOM GROUPING FIXES PLUS..."
	 echo ""
	 echo "                          ...DIE-HARD LAUNCHER!"
	 $sleep
	 echo $line
	 echo "   This Launcher Is Stronger and RECOMMENDED!"
	 echo $line
	 echo ""
	 $sleep
	 if [ "$postics" ]; then
		echo " This CAN'T SuperCharge ADJs on POST-ICS ROMS!"
		echo ""
		$sleep
		echo " It can only apply adj/Grouping Fixes..."
		echo ""
		$sleep
		echo "                           ...and other tweaks!"
		echo ""
		$sleep
		echo $line
		if [ "$servicesjarpatched" ]; then
			echo " Hey your services.jar is already patched..."
			echo ""
			$sleep
			echo "                 ...with a Die-Hard Launcher..."
			echo ""
			$sleep
				if [ "$HL" -eq 1 ]; then echo "                               ...so who cares!"
				else echo "  See The \"Jelly ISCream Parlor\" to change it!"
				fi
		else echo " Select The \"Jelly ISCream Parlor\" Option Next!"
		fi
	 else launcheradj=1
		update_options
		echo $line
		echo "             Driver Options Updated!"
	 fi;;
  13)echo " OOM GROUPING FIXES PLUS..."
	 echo ""
	 echo "                       ...BULLETPROOF LAUNCHER!"
	 $sleep
	 echo $line
	 echo "   This Launcher Is Strongest and UNKILLABLE!"
	 echo $line
	 echo ""
	 $sleep
	 if [ "$postics" ]; then
		echo " This CAN'T SuperCharge ADJs on POST-ICS ROMS!"
		echo ""
		$sleep
		echo " It can only apply adj/Grouping Fixes..."
		echo ""
		$sleep
		echo "                           ...and other tweaks!"
		echo ""
		$sleep
		echo $line
		if [ "$servicesjarpatched" ]; then
			echo " Hey your services.jar is already patched..."
			echo ""
			$sleep
			echo "              ...with a BulletProof Launcher..."
			echo ""
			$sleep
				if [ "$HL" -eq 0 ]; then echo "                               ...so who cares!"
				else echo "  See The \"Jelly ISCream Parlor\" to change it!"
				fi
		else echo " Select The \"Jelly ISCream Parlor\" Option Next!"
		fi
	 else
		echo "               =================="
		echo "                \\\\\\ WARNING! ///"
		echo "                 =============="
		echo ""
		$sleep
		echo $line
		echo "    This Breaks \"Long-Press Back To Kill\"!"
		echo $line
		echo ""
		$sleep
		echo " If you don't have or don't use this feature..."
		echo ""
		$sleep
		echo " ...or don't know what it is - just say \"Yes\" ;)"
		echo ""
		$sleep
		echo $line
		echo " Note 1: This is NOT for Gamers! (Less Free RAM)"
		echo $line
		$sleep
		echo " Note 2: It also does not play nice with Tasker!"
		echo $line
		echo ""
		$sleep
		echo -n " BulletProof? Enter Y for Yes, any key for No:"
		read breakback
		echo ""
		echo $line
		case $breakback in
		  y|Y)launcheradj=0
			  update_options
			  echo "             Driver Options Updated!"
			  echo $line
			  echo ""
			  $sleep
			  echo $line
			  echo "  Break Back Button... erm... BulletProofing!";;
			*)echo "    OK... Die-Hard Launcher Is Great Anyway!"
			  opt=26;;
		esac
	 fi;;
  14)echo "             ======================="
	 echo "            //// UN-SUPERCHARGER \\\\\\\\"
	 echo $line
	 echo ""
	 $sleep
	 echo -n "         :|"
	 sleep 3
	 echo -n "    !@#?&%(*)(*)&(!)?!"
	 sleep 3
	 echo "    :/"
	 sleep 3
	 echo ""
	 echo $line
	 echo ""
	 echo " WHAT? UnSuperCharge? Are you sure?"
	 echo ""
	 $sleep
	 echo -n " Enter Y for Yes, any key for No: "
	 read unsuper
	 echo ""
	 echo $line
	 case $unsuper in
		y|Y)echo " Well... okay then... be like that! :p";;
		  *)echo " False alarm... *whew*"
			opt=26;;
	 esac;;
  15)echo "            ======================="
	 echo "           //// THE bOOM STICK! \\\\\\\\";;
  16)echo "            ========================"
	 echo "           //// BULLETPROOF APPS \\\\\\\\";;
  17)if [ "$flushOmaticHours" -gt 0 ]; then
		flushmodebar="        ================================"
		flushmode="       //// -=Engine Flush-O-Matic=- \\\\\\\\"
	 else
		flushmodebar="          ============================="
		flushmode="         //// -=Fast Engine Flush=- \\\\\\\\"
	 fi
	 animspeed="busybox sleep 0.125"
	 clear;sleep 1;echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "             =======================";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   |";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   D";echo "               |   |";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                ___";echo "               |   D";echo "               |   |";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;$animspeed; $animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   D";echo "               |   |";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   |";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |   |";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "               |___|            __";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                 || ________  -( (-";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                 |_(--------)  '-'";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                    \      /";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "                     )_.._(";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "";echo "";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "                                          =======";echo "                                         zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "                               ==================";echo "                               zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "                     ============================";echo "                     zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo "           ======================================";echo "           zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo $line;echo " zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo $line;echo " zoom...                                zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo $line;echo " zoom...                     zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo $line;echo " zoom...           zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";$animspeed
	 clear;echo $line;echo " zoom... zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
	 clear;echo $line;echo " zOOM... zOOM...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
	 clear;echo $line;echo " zoom... zoom...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 0.5
	 clear;echo $line;echo " zOOM... zOOM...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";echo $line;echo "";echo "";echo "";echo "";echo "";echo "";echo "";echo "";busybox sleep 1
	 clear;echo $line;echo " zOOM... zOOM...";echo $line;echo "            \\\\\\\\ V6 SUPERCHARGER ////";echo "             =======================";echo "";echo "$flushmodebar";echo "$flushmode";;
  18)echo "                ================="
	 echo "               //// DETAILING \\\\\\\\";;
  19)echo "             ======================="
	 echo "            //// WHEEL ALIGNMENT \\\\\\\\";;
  20)echo "              ====================="
	 echo "             //// FIX EMISSIONS \\\\\\\\";;
  21)echo "              ====================="
	 echo "             //// FIX ALIGNMENT \\\\\\\\";;
  22)echo "           ==========================="
	 echo "          //// NITRO LAG NULLIFIER \\\\\\\\";;
  23)echo "             ======================"
	 echo "            //// SYSTEM INSTALL \\\\\\\\";;
  24)echo "             ======================="
	 echo "            //// RE-SUPERCHARGER \\\\\\\\";;
  25)echo "          ============================"
	 echo "         //// JELLY ISCREAM PARLOR \\\\\\\\"
	 if [ "$preics" ]; then opt=26
		echo $line
		echo ""
		$sleep
		echo "        FAIL: This is a PRE-ICS ROM! lol"
		echo ""
	 fi;;
  26)echo "              ====================="
	 echo "             //// POWERSHIFTING \\\\\\\\"
	 echo $line
	 echo ""
	 $sleep
	 echo " Now you can quickly switch minfree settings!"
	 echo ""
	 $sleep
	 echo " When you run a preset or the Cust-OOMizer..."
	 echo ""
	 $sleep
	 echo " ...a PowerShift Script is automatically saved!"
	 echo ""
	 echo $line
	 $sleep
	 echo " You can find them in the folder..."
	 echo ""
	 $sleep
	 echo "  .../data/V6_SuperCharger/PowerShift_Scripts :D"
	 echo $line
	 echo ""
	 $sleep
	 echo " Create \"Quick Widgets\" for them..."
	 echo ""
	 $sleep
	 echo "            ...and PowerShift between settings!"
	 echo ""
	 $sleep
	 echo $line
	 echo " They will also be your new SuperCharger values!"
	 echo $line
	 echo ""
	 $sleep
	 echo " They will have descriptive names..."
	 echo ""
	 $sleep
	 echo "                  ...indicating minfree values."
	 echo ""
	 $sleep
	 echo " Different Cust-OOMizer settings will be saved!"
	 echo "";;
  27)echo "              ====================="
	 echo "             //// Owner's Guide \\\\\\\\"
	 echo $line
	 echo ""
	 $sleep
	 echo " Loading Owner's Guide..."
	 echo ""
	 $sleep
	 su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start -a android.intent.action.VIEW -n com.android.browser/.BrowserActivity -d file://$storage/!SuperCharger.html"
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 echo " I hope that helped! :^)"
	 echo "";;
  28)echo "               ==================="
	 echo "              //// HELP CENTRE \\\\\\\\"
	 echo $line
	 echo ""
	 $sleep
	 echo " Loading web site for more help & updates..."
	 echo ""
	 $sleep
	 su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 echo " I hope that helped! :^)"
	 echo "";;
  29)echo "             ======================"
	 echo "            //// DRIVER OPTIONS \\\\\\\\"
	 echo $line
	 echo ""
	 for p in /data/local.prop /system/build.prop /system/bin/build.prop /system/etc/ram.conf; do
		if [ -f "$p" ]; then chown 0.0 $p; chmod 644 $p
			if [ ! -f "$p.unsuper" ]; then backedup=yes
				$sleep
				echo " Backing up ORIGINAL ${p##*/}..."
				echo ""
				$sleep
				cp -r $p $p.unsuper
				if [ "`diff $p $p.unsuper`" ]; then echo " ERROR BACKING UP $p!"
				else
					sed -i '/SuperCharger Installation/d' $p.unsuper
					echo "          ...as $p.unsuper!"
				fi
				echo ""
			fi
		fi
	 done 2>/dev/null
	 if [ -f "$initrcpath1" ] && [ ! -f "$initrcpath" ]; then cp -r $initrcpath1 $initrcpath; fi
	 for rc in $initrcpath1 $allrcpaths /system/etc/hw_config.sh; do
		if [ -f "$rc" ] && [ "$rc" = "$initrcpath1" ] && [ ! -f "$initrcbackup" ]; then backedup=yes
			$sleep
			echo " Backing up ORIGINAL $rc..."
			cp -r $rc $initrcbackup
			if [ "`diff $rc $initrcbackup`" ]; then
				echo ""
				$sleep
				echo " ERROR BACKING UP $rc!"
			fi
			echo ""
		elif [ -f "$rc" ] && [ "$rc" != "$initrcpath1" ] && [ ! -f "$rc.unsuper" ]; then backedup=yes
			$sleep
			echo " Backing up ORIGINAL $rc..."
			cp -r $rc $rc.unsuper
			if [ "`diff $rc $rc.unsuper`" ]; then
				echo ""
				$sleep
				echo " ERROR BACKING UP $rc!"
			fi
			echo ""
		fi
	 done 2>/dev/null
	 if [ "$backedup" ]; then backedup=; echo $line; echo ""; fi
	 $sleep
	 echo " Scrolling Speed Options..."
	 echo " =========================="
	 echo ""
	 $sleep
	 echo -n " "
	 if [ "$scpercent" -eq 100 ]; then echo -n "0 (no delay), "; fi
	 echo "1 (fast), 2 (normal), 3 (slow)"
	 while :; do
		echo ""
		$sleep
		if [ "$scpercent" -eq 100 ]; then echo -n " Please select scrolling speed (0 - 3): "
		else echo -n " Please select scrolling speed (1 - 3): "
		fi
		read speed
		echo ""
		case $speed in
		  0)sleep="sleep $speed";break;;
		  1)sleep="sleep $speed";break;;
		  2)sleep="sleep $speed";break;;
		  3)sleep="sleep $speed";break;;
		  *)echo "      Invalid entry... Please try again :p";;
		esac
	 done
	 echo $line
	 echo "       Scrolling Speed is now set to $speed..."
	 echo $line
	 echo ""
	 $sleep
	 if [ "$preics" ]; then
		echo " Build.prop vs Local.prop..."
		echo " ==========================="
		echo ""
		$sleep
		echo $line
		if [ ! "$buildprop" ] && [ ! -f "/data/local.prop" ]; then
			echo "  WARNING: You don't have a /data/local.prop!"
			echo $line
			echo ""
			$sleep
			echo " You can try creating /data/local.prop..."
			echo ""
			$sleep
			echo "  ...and see if the launcher gets SuperCharged!"
			echo ""
			$sleep
			echo $line
		fi
		echo "    Using local.prop is STRONGLY recommended!"
		echo $line
		echo ""
		$sleep
		echo " But if the launcher DOES'T get SuperCharged..."
		echo ""
		$sleep
		echo " You can apply MEM and ADJ values..."
		echo ""
		$sleep
		echo "        ...to build.prop instead of local.prop!"
		echo ""
		$sleep
		echo " This is more likely to stick but is RISKIER..."
		echo ""
		$sleep
		echo $line
		echo " WARNING: There is a small chance of bootloops!"
		echo ""
		$sleep
		echo "                 ...so have a backup available!"
		echo $line
		echo ""
		$sleep
		echo -n " Do you want to use Build.prop"
		if [ ! "$buildprop" ] && [ ! -f "/data/local.prop" ]; then
			echo "..."
			echo ""
			$sleep
			echo "                 ...or create /data/local.prop?"
		else echo "?"
		fi
		echo ""
		$sleep
		buildpropold=$buildprop
		echo -n " Enter (B)uild.prop or any key for local.prop: "
		read buildpropopt
		echo ""
		echo $line
		case $buildpropopt in
		  b|B)buildprop=1
			  prop="/system/build.prop"
			  echo "        Okay! build.prop Mode Activated!";;
			*)buildprop=0
			  prop="/data/local.prop"
			  echo "        Okay! local.prop Mode Activated!";;
		esac
		echo $line
		echo ""
		$sleep
		showbuildpropopt=0
		if [ ! -f "$prop" ]; then touch $prop; chown 0.0 $prop; chmod 644 $prop; fi
		if [ "$buildpropold" ] && [ "$buildprop" != "$buildpropold" ]; then
			if [ "$buildpropold" -eq 1 ]; then
				sed -n '/.*V6 SuperCharger/,/.*V6 SuperCharged/p' /system/build.prop >> /data/local.prop
				echo " Copied SuperCharger entries to local.prop..."
				echo ""
				$sleep
				sed -i '/.*V6 SuperCharger/,/.*V6 SuperCharged/d' /system/build.prop
				echo "   ...and cleaned SuperCharger from build.prop!"
			elif [ -f "/data/local.prop" ]; then
				sed -n '/.*V6 SuperCharger/,/.*V6 SuperCharged/p' /data/local.prop >> /system/build.prop
				echo " Copied SuperCharger entries to build.prop..."
				echo ""
				$sleep
				sed -i '/.*V6 SuperCharger/,/.*V6 SuperCharged/d' /data/local.prop
				echo "   ...and cleaned SuperCharger from local.prop!"
			fi
			echo ""
			echo $line
			echo ""
			$sleep
		fi
		echo -n " Press The Enter Key... "
		read enter
		echo ""
		echo $line
		echo ""
		$sleep
		echo " SuperCharged Launcher Strength..."
		echo " ================================="
		echo ""
		$sleep
		if [ "$gb" -eq 1 ]; then
			echo " Hard To Kill Launcher is..."
			echo ""
			$sleep
			echo "                  ...Strong BUT Still Killable!"
			echo ""
			$sleep
		fi
		echo " Die-Hard Launcher is..."
		echo ""
		$sleep
		echo "                ...VERY Strong and RECOMMENDED!"
		echo ""
		$sleep
		echo " BulletProof Launcher is..."
		echo ""
		$sleep
		echo "                   ...Strongest and UNKILLABLE!"
		echo ""
		$sleep
		echo "     ======================================="
		echo "      \\\\\\ BULLETPROOF LAUNCHER WARNING! ///"
		echo "       ==================================="
		echo ""
		$sleep
		echo $line
		echo "    This Breaks \"Long-Press Back To Kill\"!"
		echo $line
		echo ""
		$sleep
		echo " If you don't have or don't use this feature..."
		echo ""
		$sleep
		echo "                     ...don't worry about it ;)"
		echo ""
		$sleep
		echo $line
		echo " Note 1: This is NOT for Gamers! (Less Free RAM)"
		echo $line
		$sleep
		echo " Note 2: It also does not play nice with Tasker!"
		while :; do
			echo $line
			echo ""
			$sleep
			echo " Select a Launcher Strength..."
			echo ""
			echo -n " "
			if [ "$gb" -eq 1 ]; then echo -n "(H)TK, "; fi
			echo -n "(B)ulletProof, any key for Die-Hard: "
			read lstrength
			echo ""
			echo $line
			case $lstrength in
			  h|H)if [ "$gb" -eq 0 ]; then echo "      Invalid entry... Please try again :p"
				  else launcheradj=2
					echo " SuperCharged Launcher Strength is Hard To Kill!"
					break
				  fi;;
			  b|B)launcheradj=0
				  echo " SuperCharged Launcher Strength is BulletProof!"
				  break;;
				*)launcheradj=1
				  echo "  SuperCharged Launcher Strength is Die-Hard!"
				  break;;
			esac
		done
		for p in /system/etc/ram.conf $prop; do if [ -f "$p" ]; then sed -i 's/ro.HOME_APP_ADJ=.*/ro.HOME_APP_ADJ='$launcheradj/ $p; fi; done 2>/dev/null
		echo $line
		echo ""
		$sleep
	 else buildprop=1; prop="/system/build.prop"; launcheradj=1
	 fi
	 echo " Kernel & Virtual Memory Tweaks..."
	 echo " ================================="
	 echo ""
	 $sleep
	 echo " SuperCharger will apply additional tweaks..."
	 echo ""
	 $sleep
	 echo "     ...for RAM management and battery savings!"
	 echo ""
	 $sleep
	 echo $line
	 echo " Note: The Kick Ass Kernelizer has DOZENS MORE!"
	 echo $line
	 echo ""
	 $sleep
	 echo $line
	 echo " But The -=Entropy-ness Enlarger=- is included!"
	 echo $line
	 echo ""
	 $sleep
	 echo " \"Kernel Panics\" are inevitable..."
	 echo ""
	 $sleep
	 echo "         ...and can result in \"Random Reboots\"!"
	 echo ""
	 $sleep
	 echo " Choose a \"Random Reboot Tolerance\" Level... "
	 echo ""
	 $sleep
	 echo " 1. Rock Hard Kernel aka DON'T PANIC!"
	 echo "    ================================="
	 echo "                      ...this PREVENTS reboots!"
	 echo "          ...so choose this for STABLE kernels!"
	 echo " Note: This causes hangs on reboot on some ROMS"
	 echo ""
	 $sleep
	 echo " 2. Rock & Roll Kernel aka OOPS... DON'T PANIC!"
	 echo "    ==========================================="
	 echo "     ...reboots after a 30s recovery attempt..."
	 echo "       ...but NOT when an OOPS or BUG turns up!"
	 echo " Note: This causes hangs on reboot on some ROMS"
	 echo ""
	 $sleep
	 echo " 3. Soft Rock Kernel aka EVERYBODY PANIC!"
	 echo "    ====================================="
	 echo "       ...reboots after a 30s recovery attempt!"
	 echo "        ...battery drains on a frozen screen..."
	 echo "        ...so choose this for UNSTABLE kernels!"
	 echo ""
	 if [ "$scpercent" -eq 0 ]; then
		$sleep
		echo $line
		echo " An Option from 2 - 13 still needs to be run!"
	 fi
	 echo $line
	 echo ""
	 $sleep
	 echo $line
	 echo " VM Tweaks & Entropy-ness Enlarger Still Apply!"
	 echo $line
	 echo ""
	 $sleep
	 for rc in $initrcpath $allrcpaths; do
		sed -i ':vm/.*oom.*:d
				:vm/.*overcommit_memory.*:d
				:vm/.*swappiness.*:d
				:kernel/panic.*:d
				:random/.*_wakeup_threshold.*:d' $rc
	 done
	 echo " (N)one - use your ROM's / other tweak's values"
	 echo "  Rock (H)ard  - NEVER reboot on panic."
	 echo " (R)ock & Roll - Wait 30s but NOT on OOPS/Bug."
	 echo " (S)oft Rock   - Wait 30s on ANY panic."
	 while :; do
		echo ""
		$sleep
		echo -n " Pick a Kernel Strength / \"Reboot Tolerance\": "
		read kvm
		echo ""
		echo $line
		case $kvm in
		  n|N)panicmode=0; kpanic=30; kpoops=1
			  echo "         NONE!? Good Luck with that! LOL"
			  break;;
		  h|H)panicmode=3; kpanic=0; kpoops=0
			  echo "     DON'T PANIC! Rock Hard Kernel Chosen!"
			  break;;
		  r|R)panicmode=2; kpanic=30; kpoops=0
			  echo " OOPS... DON'T PANIC! Rock & Roll Kernel Chosen!"
			  break;;
		  s|S)panicmode=1; kpanic=30; kpoops=1
			  echo " EVERYBODY PANIC! Soft Rock Kernel Chosen!"
			  break;;
		    *)echo "      Invalid entry... Please try again :p"
			  echo $line;;
		esac
	 done
	 echo $line
	 echo ""
	 $sleep
	 for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
		if [ -f "$sc" ]; then
			if [ "$panicmode" -gt 0 ]; then sed -i '/kernel.panic/s/# //' $sc
			else sed -i '/kernel.panic/s/.*busybox/		# busybox/' $sc
			fi
		fi
	 done 2>/dev/null
	 for rc in $initrcpath $rcpaths; do	sed -i '/vm\/min_free_kbytes/ a\
    write /proc/sys/vm/oom_kill_allocating_task 0\
    write /proc/sys/vm/panic_on_oom 0\
    write /proc/sys/vm/overcommit_memory 1\
    write /proc/sys/vm/swappiness 20\
#   write /proc/sys/kernel/panic_on_oops '$kpoops'\
#   write /proc/sys/kernel/panic '$kpanic'\
	write /proc/sys/kernel/random/write_wakeup_threshold 3840\
	write /proc/sys/kernel/random/read_wakeup_threshold 1376' $rc
		if [ "$panicmode" -gt 0 ]; then sed -i ':^#.*kernel/panic:s:#: :' $rc; fi
	 done
	 echo " Applying Kernel & Virtual Memory Tweaks..."
	 echo ""
	 $sleep
	 Apply_KVM_Tweaks
	 echo -n " Press The Enter Key... "
	 read enter
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 echo " Accessories and SD Speed Tweaks..."
	 echo " =================================="
	 echo ""
	 $sleep
	 echo " SuperCharger can apply additional tweaks..."
	 echo ""
	 $sleep
	 echo "   ...which include additional battery savings!"
	 echo ""
	 $sleep
	 echo " They are as follows..."
	 echo ""
	 $sleep
	 echo "  ...based on the $ram MB of RAM on your device!"
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 echo "              SD Read Speed Tweak = $sdtweak KB"
	 if [ "`getprop | grep heapgrowthlimit`" ]; then echo "        dalvik.vm.heapgrowthlimit = $heapsize MB"; fi
	 echo "               dalvik.vm.heapsize = $heapsize MB"
	 if [ "`getprop | grep persist.sys.vm.heapsize`" ]; then echo "          persist.sys.vm.heapsize = $heapsize MB"; fi
	 echo "     persist.sys.purgeable_assets = 1"
	 echo "    wifi.supplicant_scan_interval = 180"
	 echo "    windowsmgr.max_events_per_sec = 90"
	 echo "                    pm.sleep_mode = 1"
	 echo ""
	 if [ "$scpercent" -eq 0 ]; then
		$sleep
		echo $line
		echo " An Option from 2 - 13 still needs to be run!"
	 fi
	 echo $line
	 echo ""
	 $sleep
	 sed -i '/Accessory Tweaks/,/sleep_mode/s/^# //' $prop
	 for rc in $initrcpath $allrcpaths; do sed -i ':bdi/read_ahead_kb:d' $rc; done
	 echo " Enable Accessories and SD Speed Tweaks?"
	 echo ""
	 $sleep
	 echo -n " Enter Y for Yes, any key for No: "
	 read acc
	 echo ""
	 echo $line
	 case $acc in
		y|Y)accsd=1
			echo "     Accessories and SD Speed Tweaks are ON!"
			echo $line
			echo ""
			$sleep
			for rc in $initrcpath $rcpaths; do sed -i '/KVM Tweaks/ i\
    write /sys/block/mmcblk0/bdi/read_ahead_kb '$sdtweak $rc
			done
			for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
				if [ -f "$sc" ]; then sed -i '/SD_Speed;/s/# //' $sc; fi
			done 2>/dev/null
			Apply_Accessories_SD_Speed;;
		  *)accsd=0
			echo "    Accessories and SD Speed Tweaks are OFF!"
			sed -i '/Accessory Tweaks/,/sleep_mode/s/^/# /
					/Accessory Tweaks/,/####/s/^# //' $prop
			for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
				if [ -f "$sc" ]; then sed -i 's/.*SD_Speed;/	# SD_Speed;/' $sc; fi
			done 2>/dev/null;;
	 esac
	 echo $line
	 echo ""
	 $sleep
	 echo -n " Press The Enter Key... "
	 read enter
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 echo " 3G TurboCharger Enhancement..."
	 echo " =============================="
	 echo ""
	 $sleep
	 echo " 3G TurboCharger Enhancement effects..."
	 echo ""
	 $sleep
	 echo " ...network buffersizes and TCP RAM allocation!"
	 echo ""
	 $sleep
	 echo $line
	 echo " This is an ADDON to my 3G TurboCharger Script!"
	 if [ "$scpercent" -eq 0 ]; then
		echo $line
		echo ""
		$sleep
		echo $line
		echo " An Option from 2 - 13 still needs to be run!"
	 fi
	 echo $line
	 echo ""
	 $sleep
	 sed -i '/TurboCharger Enhancement/,/edge=/s/^# //' $prop
	 echo " Enable 3G TurboCharger Enhancement?"
	 echo ""
	 $sleep
	 echo -n " Enter Y for Yes, any key for No: "
	 read acc
	 echo ""
	 echo $line
	 case $acc in
		y|Y)tc3g=1
			echo "     3G TurboCharger Enhancement is now ON!"
			echo $line
			echo ""
			$sleep
			for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
				if [ -f "$sc" ]; then sed -i '/3G_TCE;/s/# //' $sc; fi
			done 2>/dev/null
			Apply_3G_TCE;;
		  *)tc3g=0
			echo "     3G TurboCharger Enhancement is now OFF!"
			sed -i '/TurboCharger Enhancement/,/edge=/s/^/# /
					/TurboCharger Enhancement/,/####/s/^# //' $prop
			for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
				if [ -f "$sc" ]; then sed -i 's/.*3G_TCE;/	# 3G_TCE;/' $sc; fi
			done 2>/dev/null;;
	 esac
	 echo $line
	 echo ""
	 $sleep
	 echo -n " Press The Enter Key... "
	 read enter
	 echo ""
	 echo $line
	 echo ""
	 $sleep
	 if [ -d "/system/etc/init.d" ]; then
		echo " Detailing On Boot..."
		echo " ===================="
		echo ""
		$sleep
		echo " You have many SQLite databases that become..."
		echo ""
		$sleep
		echo " ...fragmented and unoptimized over a few days."
		echo ""
		$sleep
		echo " This tool will optimize them with..."
		echo ""
		$sleep
		echo "                  ...SQLite VACUUM and REINDEX!"
		echo ""
		boot_script_blurb "Detailing"
		Configure_Detailing
		echo $line
		echo ""
		$sleep
		echo -n " Press The Enter Key... "
		read enter
		echo ""
		echo $line
		echo ""
		$sleep
		echo " Fix Alignment On Boot..."
		echo " =========================="
		echo ""
		$sleep
		echo " This combines two scripts into one..."
		echo ""
		$sleep
		echo "          ...Wheel Alignment AND Fix Emissions!"
		echo ""
		$sleep
		echo " ZipAlign optimizes all your APKs..."
		echo ""
		$sleep
		echo "  ...which means less RAM comsumption..."
		echo ""
		$sleep
		echo "   ...better battery life and a faster device!!"
		echo ""
		$sleep
		echo " But sometimes... Force Closes can result..."
		echo ""
		$sleep
		echo "  ...so this Fixes Permissions of each app..."
		echo ""
		$sleep
		echo "           ...immediately after zipaligning it!"
		echo ""
		$sleep
		echo " It's REALLY FAST and..."
		echo ""
		$sleep
		echo $line
		echo "      It's the ONLY script of it's kind ;^]"
		boot_script_blurb "Fix Alignment"
		Configure_FixAlignment
		echo $line
		echo ""
		$sleep
		echo -n " Press The Enter Key... "
		read enter
		echo ""
		echo $line
		echo ""
		$sleep
		if [ "$fixalign" -ne 1 ]; then
			echo " Wheel Alignment On Boot..."
			echo " =========================="
			echo ""
			$sleep
			echo " ZipAlign optimizes all your APKs..."
			echo ""
			$sleep
			echo "  ...which means less RAM comsumption..."
			echo ""
			$sleep
			echo "                   ...better battery life..."
			echo ""
			$sleep
			echo "                       ...and a faster device!!"
			echo ""
			$sleep
			echo $line
			echo " If you get Force Closes, run Fix Emissions too!"
			boot_script_blurb "Wheel Alignment"
			Configure_WheelAlignment
			echo $line
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo $line
			echo ""
			$sleep
			echo " Fix Emissions On Boot..."
			echo " ========================"
			echo ""
			$sleep
			echo " This should fix app Force Closes!"
			echo ""
			$sleep
			echo " FCs usually happen due to permission errors..."
			echo ""
			$sleep
			echo " This tool will ensure that ALL apps..."
			echo ""
			$sleep
			echo "               ...have the correct permissions!"
			echo ""
			boot_script_blurb "Fix Emissions"
			Configure_FixEmissions
			echo $line
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo $line
			echo ""
			$sleep
		fi
		if [ "$preics" ]; then
			echo " System Integration - $initrcpath1 Options..."
			echo " =================="
			echo ""
			$sleep
			echo " SuperCharger can attempt greater integration..."
			echo ""
			$sleep
			echo "  ...with system files on boot using init.rc..."
			echo ""
			$sleep
			echo " If it sticks, it makes for a much cleaner mod!"
			echo ""
			$sleep
			echo " Root access issues are rare, but can occur..."
			echo ""
			echo $line
			$sleep
			echo " Regardless, a SuperCharged init.rc file..."
			echo ""
			$sleep
			echo "               ...can always be found in /data!"
			echo $line
			$sleep
			echo " Note: You can bake $initrcpath into your ROM!"
			echo $line
			echo ""
			$sleep
			echo " Custom ROMs: Settings should stick either way!"
			echo ""
			echo $line
			echo ""
			$sleep
			for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do if [ -f "$sc" ]; then sed -i '/diff/,/Integration/d' $sc; fi; done 2>/dev/null
			echo -n " Integrate? Enter Y for Yes, any key for No: "
			read bake
			echo ""
			echo $line
			case $bake in
			  y|Y)initrc=1
				  for sc in /system/etc/init.d/*SuperCharger* /data/99SuperCharger.sh /system/etc/hw_config.sh; do
					if [ -f "$sc" ]; then integrate_initrc $sc; fi
				  done 2>/dev/null
				  echo "    System Integration of $initrcpath1 is now ON!";;
				*)initrc=0
				  echo "    System Integration of $initrcpath1 is now OFF!";;
			esac
			echo $line
			echo ""
			$sleep
		else initrc=0
		fi
	 else initrc=0; detailinterval=0; zepalign=0; fixemissions=0; fixalign=0
	 fi
	 echo " Disable AWESOME V6 Animation? (Say \"NO\"!) :P"
	 echo "         ======="
	 echo ""
	 $sleep
	 echo -n " Enter Y for Yes, any key for No: "
	 read animate
	 echo ""
	 echo $line
	 case $animate in
		y|Y)animation=0
			echo "          Boo... Animation is OFF... :/";;
		  *)animation=1
			echo "          Yay... Animation is ON... :D";;
	 esac
	 echo $line
	 echo ""
	 $sleep
	 update_options
	 echo "        Driver Options Have Been Saved!"
	 echo ""
	 $sleep
	 echo $line
	 echo "             Now Off To The Races!"
	 firstgear=;missingoptions=;;
  30)echo "                ================="
	 echo "               //// OFF TOPIC \\\\\\\\"
	 echo $line
	 echo ""
	 $sleep
	 echo " Ok this is \"Off Topic\"..."
	 echo ""
	 $sleep
	 echo " ...but maybe there's a good reason..."
	 echo ""
	 $sleep
	 echo "            ...why this script is so popular :p"
	 echo ""
	 $sleep
	 echo " It's profound... so just read the link..."
	 echo ""
	 $sleep
	 echo "  ...and decide for yourself if it makes sense!"
	 echo ""
	 $sleep
	 echo " If you don't like it... remember..."
	 echo ""
	 $sleep
	 echo "                  ...don't shoot the messenger!"
	 echo ""
	 $sleep
	 echo " Either way... I'm not crazy..."
	 echo ""
	 $sleep
	 echo "      ...and you may learn something..."
	 echo ""
	 $sleep
	 echo "                    ...even if you're a doctor!"
	 echo ""
	 echo $line
	 echo ""
	 sleep 4
	 su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/0dMcp"
	 echo "";;
  31)echo $line
	 echo "                    !!POOF!!"
	 echo $line
	 echo ""
	 sleep 2
	 busybox sync
	 if [ -f "/proc/sys/kernel/sysrq" ]; then
		echo 1 > /proc/sys/kernel/sysrq 2>/dev/null
		echo b > /proc/sysrq-trigger 2>/dev/null
	 fi
	 echo "  If it don't go poofie, just reboot manually!"
	 echo ""
	 reboot; busybox reboot;;
  32)echo "              ==================="
	 echo "             //// SUPERCLEAN! \\\\\\\\"
	 if [ "$ram1" -ne "$ram2" ]; then opt=26; fi;;
  33)echo " Did you find this useful? Feedback is welcome!";;
  *) echo "   #!*@%$*?%@&)&*#!*?(*)(*)&(!)%#!&?@#$*%&?&$%$*#?!"
	 echo ""
	 sleep 2
	 echo "     oops.. typo?!  $opt is an Invalid Option!"
	 echo ""
	 sleep 2
	 echo "            1 <= Valid Option => 33 !!"
	 echo ""
	 sleep 2
	 echo -n " hehe... Press the Enter Key to continue... ;) "
	 read enter
	 echo ""
	 opt=69;;
 esac
 if [ "$opt" -ne 0 ] && [ "$opt" -ne 1 ] && [ "$opt" -ne 14 ] && [ "$opt" -ne 15 ] && [ ! "$opt" -gt 26 ] && [ "$ram1" -ne "$ram2" ]; then opt=69; autoresupercharge=; firstgear=; showparlor=; fi
 if [ "$preics" ] && [ "$opt" -ge 2 ] && [ "$opt" -le 10 ]; then
	echo ""
	$sleep
	echo $line
	if [ "$launcheradj" -eq 0 ]; then echo "               BULLETPROOF LAUNCHER!"
	elif [ "$launcheradj" -eq 2 ]; then echo "               HARD TO KILL LAUNCHER!"
	else echo "                 DIE-HARD LAUNCHER!"
	fi
 fi
 if [ "$opt" -le 25 ] || [ "$opt" -eq 32 ]; then
	echo $line
	echo ""
	$sleep
 fi
 if [ "$opt" -eq 1 ]; then
	echo " Out Of Memory (OOM) / lowmemorykiller values:"
	echo ""
	$sleep
	echo "        "$currentminfree pages
	echo ""
	$sleep
	echo $currentminfree | awk -F , '{OFMT="%.0f"; print "  Which means: "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}'
	echo ""
	echo $line
	if [ "$lname" ]; then
		echo " $lname is the home launcher!"
		echo $line
		echo ""
		$sleep
		echo -n " But verify groupings with the bOOM Stick"
		if [ "$lname" = "android.process.acore" ] && [ ! "$diehard" ]; then
			echo "..."
			echo ""
			$sleep
			echo "              ...since I'm not 100% sure... lol"
		else echo "!"
		fi
		echo ""
		echo $line
	fi
	echo ""
	$sleep
	echo "           Home Launcher Priority is: $HL"
	echo ""
	$sleep
	echo "          Foreground App Priority is: $FA"
	echo ""
	$sleep
	if [ "$gb" -eq 1 ] || [ "$servicesjarpatched" ]; then
		echo "         Perceptible App Priority is: $PA"
		echo ""
		$sleep
	fi
	echo "             Visible App Priority is: $VA"
	echo ""
	echo $line
	echo ""
	$sleep
	if [ "$status" -eq 4 ]; then
		echo " Launcher is greater than Visible App..."
		echo ""
		$sleep
		echo $line
		echo "     Wow, that's one weak ass launcher! :("
	elif [ "$HL" -eq "$VA" ]; then
		echo " Launcher is equal to Visible App..."
		echo ""
		$sleep
		echo "        ...Home Launcher is \"Locked In Memory\"!"
		echo ""
		$sleep
		echo $line
		echo "      meh... that's still pretty weak! :P"
	elif [ "$status" -eq 0 ]; then
		echo " Launcher is equal to Foreground App..."
		echo ""
		$sleep
		if [ "$gb" -eq 1 ] || [ "$servicesjarpatched" ]; then
			echo "           ...is less than Perceptible App..."
			echo ""
			$sleep
		fi
		echo "             ...and is less than Visible App..."
		echo ""
		$sleep
		echo $line
		echo "         Home Launcher is BULLETPROOF!"
	elif [ "$status" -eq 1 ]; then
		echo " Launcher is greater than Foreground App..."
		echo ""
		$sleep
		if [ "$gb" -eq 1 ] || [ "$servicesjarpatched" ]; then
			echo "           ...is less than Perceptible App..."
			echo ""
			$sleep
		fi
		echo "             ...and is less than Visible App..."
		echo ""
		$sleep
		echo $line
		echo "          Home Launcher is DIE-HARD!"
	else
		echo " Launcher is greater than Foreground App..."
		echo ""
		$sleep
		if [ "$gb" -eq 1 ] || [ "$servicesjarpatched" ]; then
			echo "            ...is equal to Perceptible App..."
			echo ""
			$sleep
		fi
		echo "             ...and is less than Visible App..."
		echo ""
		$sleep
		echo $line
		echo "      Home Launcher is very HARD TO KILL!"
	fi
	echo $line
	echo ""
	$sleep
	echo " Going to show The bOOM Stick..."
	echo ""
	$sleep
	echo " ...for deeper analysis...(that's what she sed!)"
	echo ""
	$sleep
	echo -n " Press The Enter Key... "
	read enter
	echo ""
	echo $line
	boomstick=bOOM
	bOOM_Stick bOOM
	showedboomstick=yes
 elif [ "$opt" -le 33 ]; then
	if [ "$opt" -le 13 ] || [ "$opt" -eq 24 ]; then
		if [ "`grep artprojects.RAM /d*/system/packages.xml`" ]; then
			echo $line
			echo "         WARNING: Incompatibilty Error!"
			echo $line
			echo ""
			$sleep
			echo " A memory app of questionable integrity found!"
			echo ""
			$sleep
			echo " To ensure REAL SUPERCHARGING..."
			echo "           =================="
			echo ""
			$sleep
			echo "    ...with A REAL SUPERCHARGED LAUNCHER..."
			echo "            ============================"
			echo ""
			$sleep
			echo "     You need to uninstall that \"cr-app\" :/"
			opt=33
		fi 2>/dev/null
	fi
	if [ "$opt" -eq 24 ]; then
		if [ "$autoresupercharge" ]; then resuper=Y
		else
			echo " Your previous V6 SuperCharger Settings are..."
			echo ""
			$sleep
			awk -F , '{print "               "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}' $storage/V6_SuperCharger/SuperChargerMinfree
			echo ""
			$sleep
			echo " Re-SuperCharge from $storage?"
			echo ""
			$sleep
			echo -n " Enter Y for Yes, any key for No: "
			read resuper
			echo ""
		fi
		echo $line
		case $resuper in
			y|Y)CONFIG=Re-Super
				if [ -f "$storage/V6_SuperCharger/97BulletProof_Apps.sh" ] && [ -f "$storage/V6_SuperCharger/BulletProof_Apps_HitList" ]; then
					echo ""
					$sleep
					echo " Re-BulletProof Apps too?"
					echo ""
					$sleep
					echo -n " Enter N for No, any key for Yes: "
					read rebullet
					echo ""
					case $rebullet in
						n|N);;
						  *)if [ "$allrcpaths" ]; then install_bp_service rebulletproof; echo ""; fi
							if [ "`ls $storage/V6_SuperCharger/*BulletProof_Apps`" ]; then cp -fr $storage/V6_SuperCharger/*BulletProof_Apps /system/etc/init.d; fi 2>/dev/null
							if [ "`ls $storage/V6_SuperCharger/BulletProof_Apps*`" ]; then cp -fr $storage/V6_SuperCharger/BulletProof_Apps* /data/V6_SuperCharger; fi 2>/dev/null
							if [ -f "$storage/V6_SuperCharger/97BulletProof_Apps.sh" ]; then cp -fr $storage/V6_SuperCharger/97BulletProof_Apps.sh /data; fi;;
					esac
				fi
				echo $line
				echo " Re-SuperCharging from $storage..."
				echo $line
				echo ""
				$sleep
				if [ "`ls $storage/V6_SuperCharger/SuperCharger*`" ]; then echo "      ...your Driver Options..."; $sleep; cp -fr $storage/V6_SuperCharger/SuperCharger* /data/V6_SuperCharger; fi 2>/dev/null
				if [ "`ls $storage/V6_SuperCharger/*SuperCharger`" ]; then cp -fr $storage/V6_SuperCharger/*SuperCharger /system/etc/init.d; fi 2>/dev/null
				if [ -f "$storage/V6_SuperCharger/99SuperCharger.sh" ]; then echo "      ...your SuperCharger Settings..."; $sleep; cp -fr $storage/V6_SuperCharger/99SuperCharger.sh /data; fi
				if [ -f "/data/97BulletProof_Apps.sh" ]; then echo "      ...your BulletProof Apps Settings..."; $sleep; fi
				if [ -d "$storage/V6_SuperCharger/BulletProof_One_Shots" ]; then cp -fr $storage/V6_SuperCharger/BulletProof_One_Shots /data/V6_SuperCharger; fi
				if [ -d "$storage/V6_SuperCharger/PowerShift_Scripts" ]; then echo "      ...your PowerShift Scripts..."; $sleep; cp -fr $storage/V6_SuperCharger/PowerShift_Scripts /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!Detailing.sh" ]; then echo "      ...your \"Quick Widget\" Scripts..."; $sleep; cp -fr $storage/V6_SuperCharger/!Detailing.sh /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!WheelAlignment.sh" ]; then cp -fr $storage/V6_SuperCharger/!WheelAlignment.sh /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!FixEmissions.sh" ]; then cp -fr $storage/V6_SuperCharger/!FixEmissions.sh /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!FixAlignment.sh" ]; then cp -fr $storage/V6_SuperCharger/!FixAlignment.sh /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!FastEngineFlush.sh" ]; then cp -fr $storage/V6_SuperCharger/!FastEngineFlush.sh /data/V6_SuperCharger; fi
				if [ -f "$storage/V6_SuperCharger/!SuperClean.sh" ]; then cp -fr $storage/V6_SuperCharger/!SuperClean.sh /data/V6_SuperCharger; fi
				echo "      ...all \"Terminal Emulator\" Scripts... "; dd if=$0 of=/system/xbin/v6 2>/dev/null
				if [ -f "/data/V6_SuperCharger/SuperChargerAdj" ]; then scadj=`cat /data/V6_SuperCharger/SuperChargerAdj`; fi
				if [ -f "/data/V6_SuperCharger/SuperChargerMinfree" ]; then scminfree=`cat /data/V6_SuperCharger/SuperChargerMinfree`; ReSuperCharge=1; autoshowcalculated=
					MB1=`echo $scminfree | awk -F , '{print $1/256}'`;MB2=`echo $scminfree | awk -F , '{print $2/256}'`;MB3=`echo $scminfree | awk -F , '{print $3/256}'`;MB4=`echo $scminfree | awk -F , '{print $4/256}'`;MB5=`echo $scminfree | awk -F , '{print $5/256}'`;MB6=`echo $scminfree | awk -F , '{print $6/256}'`
				fi
				chown 0.0 /system/etc/init.d/* 2>/dev/null; chmod 777 /system/etc/init.d/* 2>/dev/null
				chown 0.0 /data/V6_SuperCharger/*; chmod 777 /data/V6_SuperCharger/*
				chown 0.0 /data/V6_SuperCharger/BulletProof_One_Shots/* 2>/dev/null; chmod 777 /data/V6_SuperCharger/BulletProof_One_Shots/* 2>/dev/null
				chown 0.0 /data/V6_SuperCharger/PowerShift_Scripts/* 2>/dev/null; chmod 777 /data/V6_SuperCharger/PowerShift_Scripts/* 2>/dev/null
				chown 0.0 /system/xbin/v6 2>/dev/null; chmod 777 /system/xbin/v6 2>/dev/null
				if [ "`ls /data/*.sh`" ]; then chown 0.0 /data/*.sh; chmod 777 /data/*.sh; fi 2>/dev/null
				if [ -f "/data/99SuperCharger.sh" ]; then cp -fr /data/99SuperCharger.sh /system/xbin/99super; fi
				if [ -f "/data/V6_SuperCharger/!Detailing.sh" ]; then cp -fr /data/V6_SuperCharger/!Detailing.sh /system/xbin/vac; fi
				if [ -f "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then cp -fr /data/V6_SuperCharger/!WheelAlignment.sh /system/xbin/zepalign; fi
				if [ -f "/data/V6_SuperCharger/!FixEmissions.sh" ]; then cp -fr /data/V6_SuperCharger/!FixEmissions.sh /system/xbin/fixfc; fi
				if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then cp -fr /data/V6_SuperCharger/!FixAlignment.sh /system/xbin/fixalign; fi
				if [ -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh /system/xbin/flush; fi
				if [ -f "/data/V6_SuperCharger/!SuperClean.sh" ]; then cp -fr /data/V6_SuperCharger/!SuperClean.sh /system/xbin/sclean; fi
				if [ -d "/system/etc/init.d" ]; then
					if [ -f "/data/V6_SuperCharger/!Detailing.sh" ]; then cp -fr /data/V6_SuperCharger/!Detailing.sh /system/etc/init.d/92vac; fi
					if [ -f "/data/V6_SuperCharger/!WheelAlignment.sh" ]; then cp -fr /data/V6_SuperCharger/!WheelAlignment.sh /system/etc/init.d/93zepalign; fi
					if [ -f "/data/V6_SuperCharger/!FixEmissions.sh" ]; then cp -fr /data/V6_SuperCharger/!FixEmissions.sh /system/etc/init.d/94fixfc; fi
					if [ -f "/data/V6_SuperCharger/!FixAlignment.sh" ]; then cp -fr /data/V6_SuperCharger/!FixAlignment.sh /system/etc/init.d/95fixalign; fi
					if [ -f "/data/V6_SuperCharger/!FastEngineFlush.sh" ]; then cp -fr /data/V6_SuperCharger/!FastEngineFlush.sh /system/etc/init.d/96superflush; fi
				fi
				echo ""
				echo $line
				$sleep
				echo " ...finished copying files to /system and /data!"
				echo $line
				echo ""
				$sleep
				if [ -f "/data/V6_SuperCharger/SuperChargerOptions" ]; then firstgear=
					load_options
					if [ ! "$launcheradj" ]; then launcheradj=1; fi
					if [ ! "$panicmode" ]; then panicmode=1; kpanic=30; kpoops=1; fi
					if [ ! "$detailinterval" ]; then detailinterval=3; fi
					if [ ! "$zepalign" ]; then zepalign=0; fi
					if [ ! "$fixemissions" ]; then fixemissions=0; fi
					if [ ! "$fixalign" ]; then fixalign=0; fi
					if [ ! "$flushOmaticHours" ]; then flushOmaticHours=0; fi
					if [ ! "$accsd" ]; then accsd=0; fi
					if [ ! "$tc3g" ]; then tc3g=0; missingoptions=yes; fi
				fi
				echo $line
				show_current_options
				if [ "$missingoptions" ]; then
					echo $line
					echo "           Missing Some NEW Options!!"
					echo $line
					echo ""
					$sleep
					echo " You need to refresh them so..."
					echo ""
					$sleep
					echo "    ...Driver Options will be loaded..."
					echo ""
					$sleep
					echo "                        After Re-SuperCharging!"
					echo ""
					echo $line
					echo ""
					$sleep
				fi
				echo " If you previously used Terminal to execute..."
				echo ""
				$sleep
				echo " \"v6\", \"flush\", \"fixalign\", \"99super\", or..."
				echo ""
				$sleep
				echo "     ...\"vac\", \"fixfc\", \"zepalign\", \"sclean\"..."
				echo ""
				$sleep
				echo $line
				echo "    Those commands will work automagically!"
				echo $line
				echo ""
				$sleep
				echo " But to avoid conflicts (different rom, etc)..."
				echo ""
				$sleep
				echo "        ...some system files were not restored!"
				echo ""
				$sleep
				echo " Nitro Lag Nullifier and 3G TurboCharger..."
				echo ""
				$sleep
				echo "                ...may need to be re-installed!"
				echo ""
				echo $line
				echo ""
				$sleep
				echo " But this comes first... heh..."
				echo ""
				echo $line
				echo ""
				$sleep
				opt=12;;
			  *)echo " Re-SuperCharging Declined... meh...";;
		esac
	fi
	if [ "$opt" -le 14 ]; then
		if [ -f "$storage/UnSuperCharged.html" ]; then rm $storage/UnSuperCharged.html; fi
		if [ -f "$storage/UnSuperChargerError.html" ]; then rm $storage/UnSuperChargerError.html; fi
		if [ -f "$storage/SuperChargerScriptManagerHelp.html" ]; then rm $storage/SuperChargerScriptManagerHelp.html; fi
		if [ -f "$storage/SuperChargerHelp.html" ]; then rm $storage/SuperChargerHelp.html; fi
		if [ "$opt" -le 13 ]; then
			echo -n " zOOM... "; sleep 2; echo -n "zOOM..."; sleep 2; echo ""
			echo ""
			echo $newscadj > /data/V6_SuperCharger/SuperChargerAdj
			scadj=`cat /data/V6_SuperCharger/SuperChargerAdj`
			adj1=`echo $scadj | awk -F , '{print $1}'`;adj2=`echo $scadj | awk -F , '{print $2}'`;adj3=`echo $scadj | awk -F , '{print $3}'`;adj4=`echo $scadj | awk -F , '{print $4}'`;adj5=`echo $scadj | awk -F , '{print $5}'`;adj6=`echo $scadj | awk -F , '{print $6}'`
			if [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ]; then
				if [ "$scminfree" ] && [ ! "$scminfreeold" ]; then
					cp -fr /data/V6_SuperCharger/SuperChargerMinfree /data/V6_SuperCharger/SuperChargerMinfreeOld
					scminfreeold=`cat /data/V6_SuperCharger/SuperChargerMinfreeOld`
				fi
				SL0=$(($MB0*256));SL1=$(($MB1*256));SL2=$(($MB2*256));SL3=$(($MB3*256));SL4=$(($MB4*256));SL5=$(($MB5*256));SL6=$(($MB6*256))
				echo "$SL1,$SL2,$SL3,$SL4,$SL5,$SL6" > /data/V6_SuperCharger/SuperChargerMinfree
				scminfree=`cat /data/V6_SuperCharger/SuperChargerMinfree`
			elif [ "$scminfree" ]; then SL0=$(($MB0*256));SL1=`echo $scminfree | awk -F , '{print $1}'`;SL2=`echo $scminfree | awk -F , '{print $2}'`;SL3=`echo $scminfree | awk -F , '{print $3}'`;SL4=`echo $scminfree | awk -F , '{print $4}'`;SL5=`echo $scminfree | awk -F , '{print $5}'`;SL6=`echo $scminfree | awk -F , '{print $6}'`
			fi
			echo "==============  Information Panel  ============="
			echo "              ====================="
			echo ""
			$sleep
			if [ "$showbuildpropopt" -eq 1 ]; then
				echo " Even though you SuperCharged before..."
				echo ""
				$sleep
				echo "        ...Your launcher is NOT SuperCharged..."
				echo ""
				$sleep
				echo " To apply MEM and ADJ values..."
				echo ""
				$sleep
				echo "   ...You can try and use build.prop..."
				echo ""
				$sleep
				echo "                      ...instead of local.prop!"
				echo ""
				$sleep
				echo " This is more likely to work but riskier..."
				echo ""
				$sleep
				echo $line
				echo " WARNING: There is a small chance of bootloops!"
				echo ""
				$sleep
				echo "                 ...so have a backup available!"
				echo $line
				echo ""
				$sleep
				echo " Do you want to use Build.prop?"
				echo ""
				$sleep
				echo -n " Enter Y for Yes, any key for No: "
				read buildpropopt
				echo ""
				case $buildpropopt in
				  y|Y)buildprop=1
					  prop="/system/build.prop"
					  echo " Okay... will use the build.prop method!";;
					*)buildprop=0
					  prop="/data/local.prop"
					  echo " Okay... will try local.prop method again...";;
				esac
				echo ""
				$sleep
				update_options
				echo " Settings have been saved!"
				echo ""
				$sleep
				echo " Note: This can be changed later under Options!"
				echo ""
				echo $line
				echo ""
				$sleep
			fi
			for p in /data/local.prop /system/build.prop /system/bin/build.prop /system/etc/ram.conf; do
				if [ -f "$p" ]; then
					if [ -f "$p.unsuper" ]; then echo " Leaving ORIGINAL ${p##*/} backup intact..."
					else
						echo " Backing up ORIGINAL ${p##*/}..."
						echo ""
						$sleep
						cp -r $p $p.unsuper
						if [ "`diff $p $p.unsuper`" ]; then echo " ERROR BACKING UP $p!"
						else
							sed -i '/SuperCharger Installation/d' $p.unsuper
							echo "          ...as $p.unsuper!"
						fi
					fi
					echo ""
					$sleep
				fi
			done 2>/dev/null
			echo $line
			if [ "$preics" ]; then
				echo -n " MEM and ADJ values to be applied to "
				if [ "$buildprop" -eq 0 ]; then echo "LOCAL.PROP!"
				else echo "BUILD.PROP!"
				fi
				echo $line
			fi
			echo ""
			$sleep
			if [ -f "$initrcpath1" ] && [ ! -f "$initrcpath" ]; then cp -r $initrcpath1 $initrcpath; fi
			for rc in $initrcpath1 $allrcpaths /system/etc/hw_config.sh; do
				if [ -f "$rc" ]; then
					echo " Found $rc!"
					echo ""
					$sleep
					if [ "$rc" = "$initrcpath1" ]; then
						if [ -f "$initrcbackup" ]; then echo " Backup already exists... leaving backup intact"
						else
							echo " Backing up ORIGINAL settings..."
							cp -r $rc $initrcbackup
							if [ "`diff $rc $initrcbackup`" ]; then
								echo ""
								$sleep
								echo " ERROR BACKING UP $rc!"
							fi
						fi
					elif [ -f "$rc.unsuper" ]; then echo " Backup already exists... leaving backup intact"
					else
						echo " Backing up ORIGINAL settings..."
						cp -r $rc $rc.unsuper
						if [ "`diff $rc $rc.unsuper`" ]; then
							echo ""
							$sleep
							echo " ERROR BACKING UP $rc!"
						fi
					fi
					echo ""
					$sleep
					if [ "$preics" ] && [ "`grep -ls "on boot" $rc`" ] && [ "$rc" != "/system/etc/hw_config.sh" ]; then
						echo $line
						if [ "$rc" = "$initrcpath1" ] && [ "$initrc" -eq 0 ]; then
							echo ""
							echo " System Integration of $rc is OFF..."
							echo ""
							$sleep
							echo " But for cooking/baking into ROMs..."
							echo ""
							$sleep
							echo $line
						fi
						echo -n " "
						if [ "$rc" = "$initrcpath1" ] && [ "$initrc" -eq 0 ]; then echo -n "/data/"
						elif [ "$rc" = "$initrcpath1" ]; then echo -n "/"
						fi
						if [ "$preics" ] && [ "$opt" -ge 11 ] && [ "$opt" -le 13 ] && [ "$ReSuperCharge" -eq 0 ]; then echo "${rc##*/} will be OOM Fixed!"
						else
							echo -n "${rc##*/} will be SuperCharged"
							if [ "$rc" = "$initrcpath1" ]; then echo "!"
							else echo "..."
								echo $line
								$sleep
								echo "  ...it will also run The SuperCharger Service!"
							fi
						fi
					elif [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ] && [ "$rc" != "$initrcpath1" ] && [ "$rc" != "/system/etc/hw_config.sh" ]; then echo $line; echo "     It will run The SuperCharger Service!"
					fi
					echo $line
					echo ""
					$sleep
				fi
			done 2>/dev/null
			for rc in $initrcpath $allrcpaths; do
				sed -i '/#=#/,/KVM Tweaks/d
						/.*V6 SuperCharger/,/.*V6 SuperCharged/d
						/.*_ADJ/d' $rc
				if [ "$scminfree" ]; then
					sed -i '/.*_MEM/d
							/write \/sys\/module\/lowmemorykiller/d' $rc
				else sed -i '/write \/sys\/module\/lowmemorykiller\/parameters\/adj/d' $rc
				fi
				sed -i ':vm/.*min_free_kbytes*:d
						:vm/.*oom.*:d
						:vm/.*overcommit_memory.*:d
						:vm/.*swappiness.*:d
						:kernel/panic.*:d
						:random/.*_wakeup_threshold.*:d
						:bdi/read_ahead_kb:d' $rc
				if [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ]; then sed -i '/SuperCharger_Service/,/SuperCharged_Service/d' $rc; fi
			done
		else
			echo " UNSUPERCHARGE..."
			echo ""
			sleep 1
			echo "       ...UNFIX OOM GROUPINGS..."
			echo ""
			sleep 1
			echo "                   ...RESTORE WEAK ASS LAUNCHER"
			echo ""
			echo $line
			$sleep
			echo " Boo... UnSuperCharging Performance...."
			echo $line
			echo ""
			$sleep
			if [ ! -f "`ls /system/etc/init.d/*SuperCharger*`" ] && [ ! -f "`ls /data/*SuperCharger*`" ] && [ ! -f "`ls /system/etc/init.d/*BulletProof_Apps*`" ] && [ ! -f "$initrcpath" ] && [ ! -f "$initrcbackup" ] && [ ! "$allrcbackups" ]; then
				echo " I Got Nothing To Do! Try SuperCharging first!"
				echo ""
				$sleep
				UnSuperCharged=1
				cat > $storage/UnSuperCharged.html <<EOF
There was nothing to uninstall!<br>
<br>
For more SuperCharging help and info,<br>
See the <a href="http://goo.gl/qM6yR">V6 SuperCharger Thread</a><br>
Feedback is Welcome!<br>
<br>
-=zeppelinrox=- @ <a href="http://goo.gl/qM6yR">XDA</a> & <a href="http://www.droidforums.net/forum/droid-hacks/148268-script-v6-supercharger-htk-bulletproof-launchers-fix-memory-all-androids.html">Droid</a> Forums<br>
EOF
				echo $line
				echo " See $storage/UnSuperCharged.html for assistance!"
				echo $line
				echo ""
				$sleep
			else
				if [ -f "$initrcpath" ]; then rm $initrcpath; fi
				if [ -f "$initrcbackup" ]; then
					echo "                 BACKUP FOUND!"
					echo ""
					$sleep
					echo " Restoring $initrcpath1..."
					echo ""
					echo $line
					echo ""
					$sleep
					cp -fr $initrcbackup $initrcpath1
					rm $initrcbackup
				fi
				for rc in $allrcpaths; do
					if [ -f "$rc.unsuper" ] && [ ! -s "$rc.unsuper" ]; then rm $rc; rm $rc.unsuper; continue
					elif [ ! -f "$rc.unsuper" ]; then
						echo "      ERROR... ERROR... ERROR... ERROR..."
						echo ""
						$sleep
						echo "          AN RC BACKUP WAS NOT FOUND!"
						echo ""
						$sleep
						echo "       CAN'T restore some default values!"
						echo ""
						sleep 3
						UnSuperChargerError=1
						cat > $storage/UnSuperChargerError.html <<EOF
The backup file, $rc.unsuper, WAS NOT found!<br>
Please do a manual restore of $rc from your ROM's update file!<br>
<br>
For more SuperCharging help and info,<br>
See the <a href="http://goo.gl/qM6yR">V6 SuperCharger Thread</a><br>
Feedback is Welcome!<br>
<br>
-=zeppelinrox=- @ <a href="http://goo.gl/qM6yR">XDA</a> & <a href="http://www.droidforums.net/forum/droid-hacks/148268-script-v6-supercharger-htk-bulletproof-launchers-fix-memory-all-androids.html">Droid</a> Forums<br>
EOF
						echo $line
						echo " See $storage/UnSuperChargerError.html for help!"
						if  [ "${rc##*/}" != "init.rc" ]; then
							echo $line
							echo ""
							sleep 4
							sed -i '/#=#/,/KVM Tweaks/d
									/.*V6 SuperCharger/,/.*V6 SuperCharged/d
									/SuperCharger_Service/,/SuperCharged_Service/d
									/BulletProof_Apps_Service/,/BulletProofed_Apps_Service/d' $rc
							echo " Cleaned "$rc
							echo ""
						fi
					else
						echo "                 BACKUP FOUND!"
						echo ""
						$sleep
						echo " Restoring ${rc##*/}..."
						mv $rc.unsuper $rc
						echo ""
					fi
					echo $line
					echo ""
					$sleep
				done
			fi 2>/dev/null
		fi
		for p in /data/local.prop /system/build.prop /system/bin/build.prop /system/etc/ram.conf; do
			if [ -f "$p" ]; then
				if [ "$opt" -eq 14 ] && [ ! -f "$p.unsuper" ] || [ "$opt" -le 13 ]; then
					if [ "$UnSuperCharged" -ne 1 ]; then
						echo " Cleaning ADJ values from ${p##*/}..."
						echo ""
						$sleep
					fi
					sed -i '/.*V6 SuperCharger/,/.*V6 SuperCharged/d
							/.*_ADJ/d' $p
					if [ "$UnSuperCharged" -ne 1 ]; then
						echo " Cleaning MEM values from ${p##*/}..."
						echo ""
						$sleep
					fi
					if [ "$scminfree" ]; then sed -i '/.*_MEM/d' $p; fi
				fi
			fi
		done 2>/dev/null
		if [ "`ls /system/etc/init.d/*SuperCharger*`" ]; then
			if [ "$opt" -eq 14 ] || [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ] && [ ! "$newsupercharger" ]; then
				echo " Cleaning Up SuperCharge from /init.d folder"
				echo ""
				$sleep
				echo " Cleaning Up Grouping Fixes from /init.d folder"
				echo ""
				$sleep
			fi
			rm /system/etc/init.d/*SuperCharger*
		fi 2>/dev/null
		if [ -f "/data/99SuperCharger.sh" ]; then
			if [ "$opt" -eq 14 ] || [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ] && [ ! "$newsupercharger" ]; then
				echo " Cleaning Up SuperCharge from /data folder"
				echo ""
				$sleep
				echo " Cleaning Up Grouping Fixes from /data folder"
				echo ""
				$sleep
			fi
			rm /data/99SuperCharger.sh
		fi
		if [ "`ls /data/SuperCharger*`" ]; then rm /data/SuperCharger*; fi 2>/dev/null
		if [ "`ls /data/*-\(*\).sh`" ]; then rm /data/*-\(*\).sh; fi 2>/dev/null
		if [ -f "/data/local/userinit.sh" ]; then sed -i '/.*SuperCharger/d' /data/local/userinit.sh; fi
		if [ -f "/system/etc/hw_config.sh" ]; then sed -i '/.*V6 SuperCharger/,/.*V6 SuperCharged/d' /system/etc/hw_config.sh
			if [ "$UnSuperCharged" -ne 1 ] && [ ! "$newsupercharger" ]; then
				echo " Cleaning Up SuperCharge from hw_config.sh..."
				echo ""
				$sleep
			fi
		fi
		if [ "$opt" -eq 14 ]; then
			if [ -d "/data/V6_SuperCharger" ]; then rm -r /data/V6_SuperCharger; fi
			if [ "`ls /data/*BulletProof_Apps*`" ]; then rm /data/*BulletProof_Apps*; fi 2>/dev/null
			if [ "`ls /data/*SuperCharger*`" ]; then rm /data/*SuperCharger*; fi 2>/dev/null
			if [ "`ls /system/etc/init.d/*BulletProof_Apps*`" ]; then rm /system/etc/init.d/*BulletProof_Apps*; fi 2>/dev/null
			if [ -f "/system/xbin/v6" ]; then rm /system/xbin/v6; fi
			if [ -f "/system/xbin/99super" ]; then rm /system/xbin/99super; fi
			if [ -f "/system/xbin/vac" ]; then rm /system/xbin/vac; fi
			if [ -f "/system/xbin/zepalign" ]; then rm /system/xbin/zepalign; fi
			if [ -f "/system/xbin/fixfc" ]; then rm /system/xbin/fixfc; fi
			if [ -f "/system/xbin/fixalign" ]; then rm /system/xbin/fixalign; fi
			if [ -f "/system/xbin/flush" ]; then rm /system/xbin/flush; fi
			if [ -f "/system/etc/init.d/92vac" ]; then rm /system/etc/init.d/92vac; fi
			if [ -f "/system/etc/init.d/93zepalign" ]; then rm /system/etc/init.d/93zepalign; fi
			if [ -f "/system/etc/init.d/94fixfc" ]; then rm /system/etc/init.d/94fixfc; fi
			if [ -f "/system/etc/init.d/95fixalign" ]; then rm /system/etc/init.d/95fixalign; fi
			if [ -f "/system/etc/init.d/96superflush" ]; then rm /system/etc/init.d/96superflush; fi
			if [ -f "/system/xbin/sclean" ]; then rm /system/xbin/sclean; fi
			if [ "$UnSuperCharged" -ne 1 ]; then
				for p in /data/local.prop /system/build.prop /system/bin/build.prop /system/etc/hw_config.sh /system/etc/ram.conf; do
					if [ -f "$p.unsuper" ] && [ ! -s "$p.unsuper" ]; then rm $p; rm $p.unsuper
					elif [ -f "$p.unsuper" ]; then
						echo " Restoring ORIGINAL ${p##*/}..."
						echo ""
						$sleep
						mv $p.unsuper $p
					fi
				done 2>/dev/null
				echo " Removed Kernel & Virtual Memory Tweaks..."
				echo ""
				$sleep
				if [ "$accsd" -eq 1 ]; then
					echo "  ...Removed Accessories and SD Speed Tweaks..."
					echo ""
					$sleep
				fi
				if [ "$tc3g" -eq 1 ]; then
					echo "              ...3G TurboCharger Enhancement..."
					echo ""
					$sleep
				fi
				if [ "$UnSuperChargerError" -ne 1 ]; then
					echo " Your ROM's default minfree values are restored!"
					echo ""
					echo $line
				fi
				if [ ! "$servicesjarpatched" ]; then
					echo ""
					$sleep
					echo " Out Of Memory (OOM) Groupings UnFixed..."
					echo ""
					$sleep
					echo "                ...OOM Priorities UnFixed..."
					echo ""
					$sleep
					echo "                  Weak Ass Launcher Restored :("
					echo ""
					$sleep
					echo $line
					echo "           UnSuperCharging Complete!"
					echo $line
					echo ""
					$sleep
					echo " REBOOT NOW..."
					echo ""
					$sleep
					echo "           ...FOR UNSUPERCHARGE TO TAKE EFFECT!"
					echo ""
				fi
				scminfree=;sccminfree=;scminfreeold=;bpapplist=;allrcbackups=;ran=0;minfrees=0
			fi
			if [ "$servicesjarpatched" ] && [ -f "$storage/V6_SuperCharger/services.jar.unsuper" ]; then UnIScream=yes; fi
		else
			if [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ]; then
				if [ "$opt" -eq 10 ]; then
					echo $line
					echo ""
					if [ "$restore" -eq 1 ]; then echo "     Restoring Prior Cust-OOMizer Settings!"
					else
						if [ "$sccminfree" ] && [ "$calculatorcharge" -eq 0 ]; then
							echo " Removing Prior Cust-OOMizer Settings..."
							echo ""
							$sleep
						fi
						if [ "$quickcharge" -eq 1 ]; then echo "      Saving Quick Cust-OOMizer Settings!"
						elif [ "$calculatorcharge" -eq 1 ]; then echo "   Applying SuperMinFree Calculator Settings!"
						elif [ "$revert" -eq 1 ]; then echo "        Reverting to Prior V6 Minfrees!"
						else echo "     Saving Your New Cust-OOMizer Settings!"
						fi
					fi
					if [ "$calculatorcharge" -eq 0 ]; then cp -fr /data/V6_SuperCharger/SuperChargerMinfree /data/V6_SuperCharger/SuperChargerCustomMinfree; fi
					echo ""
					$sleep
				fi
				echo $line
				if [ "$ReSuperCharge" -eq 1 ]; then echo "         Re-SuperCharging Performance!"
				else echo " SuperCharging Performance: $CONFIG!"
				fi
				echo $line
				echo ""
				$sleep
				echo " Out Of Memory (OOM) / lowmemorykiller values:"
				echo ""
				$sleep
				echo $currentminfree | awk -F , '{OFMT="%.0f"; print "    Old MB = "$1/256", "$2/256", "$3/256", "$4/256", "$5/256", "$6/256" MB"}'
				echo "    New MB = $MB1, $MB2, $MB3, $MB4, $MB5, $MB6 MB"
				echo ""
				$sleep
				echo " Old Pages = "$currentminfree
				echo " New Pages = $scminfree"
				echo ""
				$sleep
			fi
			#
			# MFK Calculator (for min_free_kbytes) created by zeppelinrox.
			#
			slot=3
			MFK_Calculator $slot
			echo $line
			echo " Make Foreground AND Background Apps STAY FAST!"
			echo $line
			echo ""
			$sleep
			echo " With The MFK Calculator!"
			echo " ========================"
			echo ""
			$sleep
			echo " Key Settings That Impact Typical Free RAM..."
			echo ""
			$sleep
			echo "         $SSADJ = Secondary Server ADJ"
			echo "         $slot = Secondary Server Slot"
			echo "        $((SSMF/256)) = Secondary Server LMK MB"
			echo ""
			$sleep
			echo $line
			echo " Balanced MFK Calculation Complete..."
			echo $line
			echo ""
			$sleep
			echo "      $MFK = Customized MFK (min_free_kbytes)"
			echo ""
			for rc in $initrcpath $rcpaths; do
				if [ "`grep -s "on early-boot" $rc`" ] && [ "$preics" ]; then sed -i '/on early-boot/ a\
    # V6 SuperCharger, OOM Grouping & Priority Fixes created by -=zeppelinrox=-' $rc
				else sed -i '/on boot/ a\
    # V6 SuperCharger, OOM Grouping & Priority Fixes created by -=zeppelinrox=-' $rc
				fi
				sed -i '/V6 SuperCharger/ a\
    # SuperMinFree Calculator & MFK Calculator (for min_free_kbytes) created by zeppelinrox also ;^]\
    #\
    # See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article!\
    # See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why '"'Free RAM'"' Is NOT Wasted RAM!"\
    # See http://goo.gl/4w0ba - MFK Calculator Info - explanation for vm.min_free_kbytes.\
    #\
    # DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!\
    #\
    # BEGIN OOM_MEM_Settings\
    # END OOM_MEM_Settings\
    # BEGIN OOM_ADJ_Settings\
    # END OOM_ADJ_Settings\
    # End of V6 SuperCharged Entries.' $rc
				if [ "`grep -s "on early-boot" $rc`" ] && [ "$preics" ]; then sed -i '/on boot/ a\
      #################=##################' $rc
				else sed -i '/END OOM_ADJ_Settings/ a\
      #################=##################' $rc
				fi
				sed -i '/#=#/ a\
     #  Kernel & Virtual Memory Tweaks  #\
    ####################################\
    write /proc/sys/vm/min_free_kbytes '$MFK'\
    write /proc/sys/vm/oom_kill_allocating_task 0\
    write /proc/sys/vm/panic_on_oom 0\
    write /proc/sys/vm/overcommit_memory 1\
    write /proc/sys/vm/swappiness 20\
#   write /proc/sys/kernel/panic_on_oops '$kpoops'\
#   write /proc/sys/kernel/panic '$kpanic'\
	write /proc/sys/kernel/random/write_wakeup_threshold 3840\
	write /proc/sys/kernel/random/read_wakeup_threshold 1376\
    # End of KVM Tweaks' $rc
				if [ "$panicmode" -gt 0 ]; then sed -i ':^#.*kernel/panic:s:#: :' $rc; fi
				if [ "$accsd" -eq 1 ]; then sed -i '/KVM Tweaks/ i\
    write /sys/block/mmcblk0/bdi/read_ahead_kb '$sdtweak $rc
				fi
				if [ "$preics" ]; then
					if [ "$scminfree" ]; then sed -i '/on boot/ a\
    write '$minfreefile' '$scminfree $rc
						sed -i '/BEGIN OOM_MEM_Settings/ a\
    setprop ro.FOREGROUND_APP_MEM '$SL1'\
    setprop ro.VISIBLE_APP_MEM '$SL2'\
    setprop ro.SECONDARY_SERVER_MEM '$SL3'\
    setprop ro.BACKUP_APP_MEM '$SL4'\
    setprop ro.HOME_APP_MEM '$SL3'\
    setprop ro.HIDDEN_APP_MEM '$SL4'\
    setprop ro.EMPTY_APP_MEM '$SL6 $rc
						if [ "$gb" -eq 1 ]; then sed -i '/ro.VISIBLE_APP_MEM/ a\
    setprop ro.PERCEPTIBLE_APP_MEM '$SL0'\
    setprop ro.HEAVY_WEIGHT_APP_MEM '$SL3 $rc
						else sed -i '/ro.HIDDEN_APP_MEM/ a\
    setprop ro.CONTENT_PROVIDER_MEM '$SL5 $rc
						fi
					fi
					sed -i '/on boot/ a\
    write /sys/module/lowmemorykiller/parameters/adj '$scadj $rc
					sed -i '/BEGIN OOM_ADJ_Settings/ a\
    setprop ro.FOREGROUND_APP_ADJ '$adj1'\
    setprop ro.VISIBLE_APP_ADJ '$adj2'\
    setprop ro.SECONDARY_SERVER_ADJ '$adj3'\
    setprop ro.BACKUP_APP_ADJ '$(($adj3+1))'\
    setprop ro.HOME_APP_ADJ '$launcheradj'\
    setprop ro.HIDDEN_APP_MIN_ADJ '$(($adj4-1))'\
    setprop ro.EMPTY_APP_ADJ '$adj6 $rc
					if [ "$gb" -eq 1 ]; then sed -i '/ro.VISIBLE_APP_ADJ/ a\
    setprop ro.PERCEPTIBLE_APP_ADJ '$(($adj1+2))'\
    setprop ro.HEAVY_WEIGHT_APP_ADJ '$(($adj2+1)) $rc
					else sed -i '/ro.HIDDEN_APP_MIN_ADJ/ a\
    setprop ro.CONTENT_PROVIDER_ADJ '$adj4 $rc
					fi
					$sleep
					echo $line
					echo -n " "
					if [ "$rc" = "$initrcpath" ] && [ "$initrc" -eq 0 ]; then echo -n "/data/"
					elif [ "$rc" = "$initrcpath" ]; then echo -n "/"
					fi
					if [ "$opt" -ge 11 ] && [ "$opt" -le 13 ] && [ "$ReSuperCharge" -eq 0 ]; then echo "${rc##*/} has been OOM Fixed!"
					else echo "${rc##*/} has been SuperCharged!"
					fi
				else sed -i '/OOM_MEM_Settings/d
							 /BEGIN OOM_ADJ_Settings/ a\
    #\
    # This ROM (Android 4.0 and greater) requires a PATCHED services.jar\
    # If you don'"'"'t have it patched yet, go to http://goo.gl/IvGL1\
    # The ADJ priorities that were here DO NOT work anymore!\
    #' $rc
				fi
			done
			if [ "$preics" ]; then
				echo $line
				echo ""
				$sleep
				echo " Fixing Out Of Memory (OOM) Groupings..."
				echo ""
				$sleep
				echo "                    ...Fixing OOM Priorities..."
				echo ""
				$sleep
			fi
			for p in /system/etc/ram.conf $prop; do
				if [ -f "$p" ]; then
					echo "# V6 SuperCharger, OOM Grouping & Priority Fixes created by -=zeppelinrox=-" >> $p
					sed -i '/OOM Grouping/ a\
# SuperMinFree Calculator & MFK Calculator (for min_free_kbytes) created by zeppelinrox also ;^]\
#\
# See http://goo.gl/krtf9 - Linux Memory Consumption - Nice article!\
# See http://goo.gl/hFdNO - Memory and SuperCharging Overview, or... "Why '"'Free RAM'"' Is NOT Wasted RAM!"\
# See http://goo.gl/4w0ba - MFK Calculator Info - explanation for vm.min_free_kbytes.\
#\
# DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!\
#\
# BEGIN OOM_MEM_Settings\
# END OOM_MEM_Settings\
# BEGIN OOM_ADJ_Settings\
# END OOM_ADJ_Settings\
# End of V6 SuperCharged Entries.' $p
					if [ "$p" = "/system/etc/ram.conf" ]; then sed -i '/END OOM_ADJ_Settings/ a\
LMK_ADJ="'$scadj'"\
LMK_MINFREE="'$scminfree'"' $p
					else sed -i '/END OOM_ADJ_Settings/ a\
  #######################\
 #  Accessory Tweaks!  #\
#######################\
# dalvik.vm.heapgrowthlimit='$heapsize'm\
# dalvik.vm.heapsize='$heapsize'm\
# persist.sys.vm.heapsize='$heapsize'm\
# persist.sys.purgeable_assets=1\
# wifi.supplicant_scan_interval=180\
# windowsmgr.max_events_per_sec=90\
# pm.sleep_mode=1\
  ##################################\
 #  3G TurboCharger Enhancement!  #\
##################################\
# net.dns1=8.8.8.8\
# net.dns2=8.8.4.4\
# net.tcp.buffersize.default=6144,87380,110208,6144,16384,110208\
# net.tcp.buffersize.wifi=262144,524288,1048576,262144,524288,1048576\
# net.tcp.buffersize.lte=262144,524288,3145728,262144,524288,3145728\
# net.tcp.buffersize.hsdpa=6144,262144,1048576,6144,262144,1048576\
# net.tcp.buffersize.evdo_b=6144,262144,1048576,6144,262144,1048576\
# net.tcp.buffersize.umts=6144,87380,110208,6144,16384,110208\
# net.tcp.buffersize.hspa=6144,87380,262144,6144,16384,262144\
# net.tcp.buffersize.gprs=6144,8760,11680,6144,8760,11680\
# net.tcp.buffersize.edge=6144,26280,35040,6144,16384,35040' $p
						if [ ! "`getprop | grep heapgrowthlimit`" ]; then sed -i '/heapgrowthlimit/d' $p; fi
						if [ ! "`getprop | grep persist.sys.vm.heapsize`" ]; then sed -i '/persist.sys.vm.heapsize/d' $p; fi
						if [ "$accsd" -eq 1 ]; then sed -i '/Accessory Tweaks/,/sleep_mode/s/^# //' $p; fi
						if [ "$tc3g" -eq 1 ]; then sed -i '/TurboCharger Enhancement/,/edge=/s/^# //' $p; fi
					fi
					if [ "$preics" ]; then
						if [ "$scminfree" ]; then sed -i '/BEGIN OOM_MEM_Settings/ a\
ro.FOREGROUND_APP_MEM='$SL1'\
ro.VISIBLE_APP_MEM='$SL2'\
ro.SECONDARY_SERVER_MEM='$SL3'\
ro.BACKUP_APP_MEM='$SL4'\
ro.HOME_APP_MEM='$SL3'\
ro.HIDDEN_APP_MEM='$SL4'\
ro.EMPTY_APP_MEM='$SL6 $p
							if [ "$gb" -eq 1 ]; then sed -i '/ro.VISIBLE_APP_MEM/ a\
ro.PERCEPTIBLE_APP_MEM='$SL0'\
ro.HEAVY_WEIGHT_APP_MEM='$SL3 $p
							else sed -i '/ro.HIDDEN_APP_MEM/ a\
ro.CONTENT_PROVIDER_MEM='$SL5 $p
							fi
						fi
						sed -i '/BEGIN OOM_ADJ_Settings/ a\
ro.FOREGROUND_APP_ADJ='$adj1'\
ro.VISIBLE_APP_ADJ='$adj2'\
ro.SECONDARY_SERVER_ADJ='$adj3'\
ro.BACKUP_APP_ADJ='$(($adj3+1))'\
ro.HOME_APP_ADJ='$launcheradj'\
ro.HIDDEN_APP_MIN_ADJ='$(($adj4-1))'\
ro.EMPTY_APP_ADJ='$adj6 $p
						if [ "$gb" -eq 1 ]; then sed -i '/ro.VISIBLE_APP_ADJ/ a\
ro.PERCEPTIBLE_APP_ADJ='$(($adj1+2))'\
ro.HEAVY_WEIGHT_APP_ADJ='$(($adj2+1)) $p
						else sed -i '/ro.HIDDEN_APP_MIN_ADJ/ a\
ro.CONTENT_PROVIDER_ADJ='$adj4 $p
						fi
					else sed -i '/OOM_MEM_Settings/d
								 /BEGIN OOM_ADJ_Settings/ a\
#\
# This ROM (Android 4.0 and greater) requires a PATCHED services.jar\
# If you don'"'"'t have it patched yet, go to http://goo.gl/IvGL1\
# The ADJ priorities that were here DO NOT work anymore!\
#' $p
					fi
				fi
			done 2>/dev/null
			if [ "$preics" ]; then
				echo " ...OOM Groupings and Priorities are now fixed!"
				echo ""
				$sleep
				echo $line
				if [ "$launcheradj" -eq 0 ]; then
					echo ""
					echo " Applied BulletProof Launcher..."
					echo ""
					$sleep
					echo " Launcher is not only SuperCharged..."
					echo ""
					$sleep
					echo $line
					echo "                           ...It's BULLETPROOF!"
				elif [ "$launcheradj" -eq 2 ]; then echo "         Hard To Kill Launcher APPLIED!"
				else echo "           Die-Hard Launcher APPLIED!"
				fi
				if [ "$homeadj" -ne "$launcheradj" ]; then newlauncher=1; fi
			fi
			echo $line
			echo ""
			$sleep
			echo " Applying Kernel & Virtual Memory Tweaks..."
			echo ""
			$sleep
			echo -n "                    ";busybox sysctl -w vm.min_free_kbytes=$MFK
			Apply_KVM_Tweaks
			if [ "$accsd" -eq 1 ]; then
				Apply_Accessories_SD_Speed
				echo $line
				echo ""
				$sleep
			fi
			if [ "$tc3g" -eq 1 ]; then
				Apply_3G_TCE
				echo $line
				echo ""
				$sleep
			fi
			Re_Generate_99SuperCharger_sh
			echo $line
			echo "                  GEEK ALERT!!"
			echo $line
			echo ""
			$sleep
			echo " \"Start Up Script\" to be copied to /system/xbin!"
			echo "  ==============="
			echo ""
			$sleep
			echo " If need be, you can run it quick and easy..."
			echo ""
			$sleep
			echo " To use this script with Terminal Emulator..."
			echo ""
			$sleep
			echo " Run Terminal Emulator..."
			echo ""
			$sleep
			echo "           ...type \"su\" and Enter..."
			echo "                    =="
			echo ""
			$sleep
			echo "                 ...type \"99super\" and Enter..."
			echo "                          ======="
			echo ""
			$sleep
			echo "                  THAT'S IT!"
			echo ""
			echo $line
			echo ""
			$sleep
			if [ -f "/system/etc/hw_config.sh" ]; then
				echo " SuperCharging /system/etc/hw_config.sh..."
				echo ""
				echo $line
				echo ""
				$sleep
			fi
			if [ "$rcpaths" ] || [ "$preics" ] && [ "$initrc" -eq 1 ] && [ -d "/system/etc/init.d" ]; then
				echo " For Super Stickiness..."
				echo ""
				$sleep
			fi
			if [ -d "/system/etc/init.d" ]; then
				echo " SuperCharging /system/etc/init.d folder..."
				echo ""
				$sleep
				if [ "$scdiff" ]; then free_space_error /system/init.d
				else
					if [ "$desiredname" = "/system/etc/init.d/99SuperCharger" ]; then echo -n "  "
					elif [ "$desiredname" = "/system/etc/init.d/S99SuperCharger" ]; then echo -n " "
					fi
					echo "   ...with $desiredname!"
				fi
				if [ "`ls /system/etc/init.d/*oopy*`" ] && [ "`ls /system/etc/init.d/*oopy*`" != "/system/etc/init.d/zzloopy_runs_last_so_others_do_too" ]; then
					echo ""
					echo $line
					echo ""
					$sleep
					echo " Found `ls /system/etc/init.d/*oopy*`..."
					echo ""
					$sleep
					echo " ...it stops other init.d scripts from running!"
					echo ""
					$sleep
					echo " Renaming it to..."
					echo ""
					$sleep
					echo "   ...\"zzloopy_runs_last_so_others_do_too\" lol!"
					echo ""
					$sleep
					mv /system/etc/init.d/*oopy* /system/etc/init.d/zzloopy_runs_last_so_others_do_too
					echo " But it's better to just delete it..."
					echo ""
					$sleep
					echo "       ...and from the Driver's Console..."
					echo ""
					$sleep
					echo "                 ...\"BulletProof Apps\" instead!"
				fi 2>/dev/null
				echo ""
			else
				echo " Stock ROM? - Additional Configuration Required!"
				echo ""
				$sleep
				echo " You have no /system/etc/init.d folder..."
				echo ""
				$sleep
				echo $line
				echo "    ...so instead, use /data/99SuperCharger.sh!"
				echo $line
				echo ""
				$sleep
				if [ "$opt" -le 10 ]; then
					echo -n " Some Changes are TEMPORARY & "
					if [ "$allrcpaths" ]; then echo "MAY NOT PERSIST!"
					else echo "WON'T PERSIST!"
					fi
					echo ""
					$sleep
					echo " To enable PERSISTENT SuperCharger settings...."
					echo ""
					$sleep
					echo "                   ...and OOM Grouping Fixes..."
				else echo " To enable PERSISTENT OOM Grouping Fixes..."
				fi
				echo ""
				$sleep
				if [ "$allrcpaths" ]; then
					echo "       ...The SuperCharger Service should work!"
					echo ""
					$sleep
					echo " BUT if it doesn't..."
					echo ""
					$sleep
				fi
				if [ "$smrun" ]; then
					SuperChargerScriptManagerHelp=1
					cat > $storage/SuperChargerScriptManagerHelp.html <<EOF
Yay! You already have <a href="http://play.google.com/store/apps/details?id=os.tools.scriptmanager">Script Manager!</a><br>
After running the script, have Script Manager load the newly created <b>/data/99SuperCharger.sh</b> on boot<br>
In the "Config" settings, enable "Browse as Root."<br>
Press the menu key and then Browser.<br>
Navigate up to the root, then click on the "data" folder.<br>
Click on 99SuperCharger.sh and select "Script" from the "Open As" menu.<br>
In the properties dialogue box, check "Run as root" (ie. SuperUser) and "Run at boot" and "Save".<br>
And that's it!<br>
Script Manager will load your most recent settings on boot!<br>
<br>
Another option is to make a Script Manager widget for <b>/data/99SuperCharger.sh</b> on your homescreen and simply launch it after each reboot.<br>
<br>
If you run the script later and with different settings, you don't have to reconfigure anything.<br>
Script Manager will just load the new /data/99SuperCharger.sh on boot automagically ;^]<br>
<br>
For more SuperCharging help and info,<br>
See the <a href="http://goo.gl/qM6yR">V6 SuperCharger Thread</a><br>
Feedback is Welcome!<br>
<br>
-=zeppelinrox=- @ <a href="http://goo.gl/qM6yR">XDA</a> & <a href="http://www.droidforums.net/forum/droid-hacks/148268-script-v6-supercharger-htk-bulletproof-launchers-fix-memory-all-androids.html">Droid</a> Forums<br>
EOF
					echo " Use THIS app to make a \"Quick Widget\" for..."
					echo ""
					$sleep
					echo "                    .../data/99SuperCharger.sh!"
					echo ""
					$sleep
					echo " Or use it to load 99SuperCharger.sh on boot!"
					echo ""
					$sleep
					echo " OR, as per the \"Geek Alert\" mentioned above..."
					echo ""
					$sleep
					echo " ...use Terminal Emulator & do \"su -c 99super\"!"
					echo "                                ============="
					echo ""
					$sleep
					echo $line
					echo " See $storage/SuperChargerScriptManagerHelp.html"
				else
					echo " ..Please ENABLE boot scripts to be run from..."
					echo "                  .../system/etc/init.d folder!"
					echo " Easier: Script Manager can solve everything ;)"
					echo ""
					$sleep
					echo " But for now... "
					echo ""
					$sleep
					echo "  ...as per the \"Geek Alert\" mentioned above..."
					echo ""
					$sleep
					echo " ...use Terminal Emulator & do \"su -c 99super\"!"
					echo "                                ============="
					echo ""
					$sleep
					SuperChargerHelp=1
					cat > $storage/SuperChargerHelp.html <<EOF
To enable init.d boot scripts, go <a href="http://goo.gl/rZTyW">HERE</a><br>
This is for Motorolas! At least some of them anyway.<br>
If that page is incompatible with your phone, do some reasearch!<br>
<br>
A very nice and easy solution is to simply use<br>
Script Manager to load scripts on boot - on ANY ROM!<br>
Here is the <a href="http://play.google.com/store/apps/details?id=os.tools.scriptmanager">Google Play Link</a><br>
So first, you use Script Manager to run the V6 SuperCharger script.<br>
Then use it again to load the newly created <b>/data/99SuperCharger.sh</b> on boot<br>
In the 99SuperCharger.sh properties dialogue box, check "Run as root" (ie. SuperUser) and "Run at boot" and "Save".<br>
And that's it!<br>
Script Manager will load your most recent settings on boot!<br>
<br>
Another option is to make a Script Manager widget for <b>/data/99SuperCharger.sh</b> on your homescreen and simply launch it after each reboot.<br>
<br>
If you run the script later and with different settings, you don't have to reconfigure anything.<br>
Script Manager will just load the new /data/99SuperCharger.sh on boot automagically ;^]<br>
<br>
For more SuperCharging help and info,<br>
See the <a href="http://goo.gl/qM6yR">V6 SuperCharger Thread</a><br>
Feedback is Welcome!<br>
<br>
-=zeppelinrox=- @ <a href="http://goo.gl/qM6yR">XDA</a> & <a href="http://www.droidforums.net/forum/droid-hacks/148268-script-v6-supercharger-htk-bulletproof-launchers-fix-memory-all-androids.html">Droid</a> Forums<br>
EOF
					echo $line
					echo "See $storage/SuperChargerHelp.html for more help!"
				fi
			fi
			echo $line
			if [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ]; then
				if [ "$allrcpaths" ] && [ ! "$scsinfo" ]; then
					if [ -d "/system/etc/init.d" ]; then
						echo ""
						$sleep
						echo " And for added, Auto Insurance..."
						echo ""
						$sleep
						echo $line
					fi
					if [ ! "$scservice" ]; then echo " Installing SuperCharger Service to..."
					else echo " SuperCharger Service had been installed to..."
					fi
					echo $line
					echo ""
					$sleep
				fi
				install_sc_service
				if [ "$allrcpaths" ] && [ ! "$scsinfo" ]; then
					echo ""
					echo $line
					echo ""
					$sleep
					echo " You can leave the service on by either..."
					echo ""
					$sleep
					echo " ...reading comments in /data/99SuperCharger.sh"
					echo ""
					$sleep
					echo " Or... Run Terminal Emulator..."
					echo ""
					$sleep
					echo "              ...type \"su\" and Enter..."
					echo "                       =="
					echo ""
					$sleep
					echo "       ...type \"start super_service\" and Enter."
					echo "                ==================="
					echo ""
					$sleep
					echo " To stop the SuperCharger Service..."
					echo ""
					$sleep
					echo "        ...type \"stop super_service\" and Enter."
					echo "                 =================="
					echo ""
					echo $line
					echo ""
					$sleep
					echo " If the service is running and you type..."
					echo ""
					$sleep
					echo "          ...\"cat /proc/*/cmdline | grep Super\""
					echo ""
					$sleep
					echo " The output would look like this:"
					echo ""
					$sleep
					echo "      /data/99SuperCharger.sh"
					echo "      Super"
					echo ""
					echo $line
					echo ""
					$sleep
					echo " Easier: Similar results can be had with..."
					echo ""
					$sleep
					echo "                   ...\"busybox ps | grep Super\""
					echo ""
					echo $line
				elif [ ! "$allrcpaths" ] && [ ! "$scsinfo" ]; then
					echo $line
					echo "    SuperCharger Service Entries Installed!"
					echo $line
					echo ""
					$sleep
					echo " This won't work on this ROM but... "
					echo ""
					$sleep
					echo "       ...it makes for easy cooking into a ROM!"
					echo ""
					$sleep
					echo " Just read the comments in $initrcpath :)"
					echo ""
					echo $line
				fi
				echo ""
				$sleep
				echo " Setting LowMemoryKiller to..."
				echo ""
				$sleep
				echo "         ...$MB1, $MB2, $MB3, $MB4, $MB5, $MB6 MB"
				echo ""
				$sleep
				echo "$scminfree" > $minfreefile
				currentminfree=`cat $minfreefile`
				echo " OOM Minfree levels are now set to..."
				echo ""
				$sleep
				echo "         ..."$currentminfree
				echo ""
				if [ "$newlauncher" -eq 0 ]; then
					$sleep
					echo $line
					echo "      SUPERCHARGE IN EFFECT IMMEDIATELY!!"
				fi
				echo $line
				echo ""
				$sleep
				Re_Generate_PowerShift_Script
				echo " A PowerShift Script was saved as..."
				echo ""
				$sleep
				echo " $CONFIG-($MB1,$MB2,$MB3,$MB4,$MB5,$MB6)-PowerShift.sh!"
				echo ""
				$sleep
				echo " Goto data/V6_SuperCharger/PowerShift_Scripts.."
				echo ""
				$sleep
				echo "             ...make a \"Quick Widget\" for it..."
				echo ""
				$sleep
				echo "            ...and PowerShift between settings!"
				echo ""
				$sleep
				echo "  They'll also be your new SuperCharger values!"
				echo ""
				echo $line
				scsinfo=shown
			fi
			if [ "$adjfile" = "/sys/module/lowmemorykiller/parameters/adj" ]; then echo "$scadj" > $adjfile
			elif [ ! "$adjfile" ]; then adjfile="/data/V6_SuperCharger/SuperChargerAdj"
			fi
			if [ "$newlauncher" -eq 1 ]; then
				$sleep
				echo "           LAUNCHER CHANGE DETECTED!"
				echo $line
				echo ""
				$sleep
				echo " REBOOT NOW TO ENABLE..."
				echo ""
				$sleep
				if [ "$launcheradj" -eq 0 ]; then echo "          ...BULLETPROOF LAUNCHER..."
				elif [ "$launcheradj" -eq 2 ]; then echo "         ...HARD TO KILL LAUNCHER..."
				else echo "             ...DIE-HARD LAUNCHER..."
				fi
				echo ""
				$sleep
				echo "                     ...AND OOM GROUPING FIXES!"
				echo ""
				$sleep
				echo $line
			fi
			if [ "$SuperChargerHelp" -eq 1 ]; then
				$sleep
				echo " RUN /data/99SuperCharger.sh AFTER EACH REBOOT!"
			elif [ "$SuperChargerScriptManagerHelp" -eq 1 ]; then
				$sleep
				echo " DON'T FORGET to have Script Manager load..."
				echo "            .../data/99SuperCharger.sh on boot!"
				echo "     ...or make a Script Manager WIDGET for it!"
			elif [ "$opt" -le 10 ] || [ "$postics" ] || [ "$ReSuperCharge" -eq 1 ]; then
				$sleep
				if [ "$ReSuperCharge" -eq 1 ]; then echo -n " Restored"
				else echo -n "$CONFIG"
				fi
				echo " Settings WILL PERSIST after reboot!"
				echo $line
				echo ""
				$sleep
				echo " If they don't persist, read the Owner's Guide!"
				echo ""
			else
				echo ""
				$sleep
				echo " If OOM Fixes are't in effect after a reboot..."
				echo ""
				$sleep
				echo "                 ...and the Launcher is weak..."
				echo ""
				$sleep
				echo "                     ...read the Owner's Guide!"
				echo ""
			fi
			echo $line
			echo ""
			$sleep
			echo " SO... you know if it works or not by..."
			echo ""
			$sleep
			echo " ...READING THE INFO Under The Driver's Console!"
			echo ""
			$sleep
			echo $line
			echo " PLEASE: READ THE ABOVE MESSAGES BEFORE ASKING!"
			echo $line
			echo ""
			$sleep
			echo "   Because I may SNAP and call you names! ;o]"
			echo ""
			$sleep
			echo " And I'll likely add you to my IGNORE list..."
			echo ""
			$sleep
			echo " ...because you think it's OK to WASTE MY TIME!"
			echo ""
			echo $line
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			if [ "$opt" -le 10 ] || [ "$ReSuperCharge" -eq 1 ] || [ "$postics" ]; then ran=1; fi
			if [ -f "$initrcpath" ] && [ "$initrc" -eq 1 ]; then cp -fr $initrcpath $initrcpath1; fi
			if [ -f "/system/bin/build.prop" ]; then cp -fr /system/build.prop /system/bin; fi
			echo " Backing up refreshed files to $storage..."
			echo ""
			$sleep
			if [ -d "/data/V6_SuperCharger" ]; then cp -fr /data/V6_SuperCharger $storage; fi
			for rc in $initrcpath $allrcpaths; do cp -fr $rc* $storage/V6_SuperCharger; done
			if [ "`ls /system/build.prop*`" ]; then cp -fr /system/build.prop* $storage/V6_SuperCharger; fi 2>/dev/null
			if [ "`ls /data/local.prop*`" ]; then cp -fr /data/local.prop* $storage/V6_SuperCharger; fi 2>/dev/null
			if [ "`ls /system/etc/ram.conf*`" ]; then cp -fr /system/etc/ram.conf* $storage/V6_SuperCharger; fi 2>/dev/null
			echo "            ...Re-SuperCharger backup complete!"
			echo ""
			if [ "$newsupercharger" ] || [ "$postics" ]; then
				if [ "$preics" ]; then opt=32
					echo $line
					echo ""
					$sleep
					if [ "$autoresupercharge" ] || [ "$ReSuperCharge" -eq 1 ]; then
					echo " Re-SuperCharger is ALMOST done!"
					script_version_check
					else echo " I think this is your FIRST SuperCharge..."
					fi
					echo ""
					$sleep
				elif [ "$servicesjarpatched" ] || [ "$servicesjarinstalled" ]; then
					echo $line
					echo "             I Scream SUPERCHARGED!"
				elif [ ! "$showedparlor" ]; then opt=25
					echo $line
					echo ""
					$sleep
					echo " Now off to the \"Jelly ISCream Parlor\"..."
					echo ""
					$sleep
				fi
				autoresupercharge=
			fi
		fi
	fi
	if [ "$opt" -eq 15 ]; then
		echo "             Does Your OOM Stick?!"
		echo "             ====================="
		echo ""
		$sleep
		echo " Find Out Here... AND Find Your Home Launcher!!"
		echo ""
		$sleep
		echo " Choose from 2 bitchin' OOM Sticks..."
		echo ""
		$sleep
		echo " zOOM Stick (Quick) Mode is faster..."
		echo ""
		$sleep
		echo " ...it shows App Name, Priority (ADJ), and PID!"
		echo ""
		$sleep
		echo " vrOOM Stick (Verbose) mode is slower..."
		echo ""
		$sleep
		echo "         ...but adds Path and/or Apk file info!"
		echo ""
		echo $line
		echo ""
		$sleep
		echo " Do you want vrOOM or zOOM Stick mode?"
		echo ""
		$sleep
		echo -n " Enter V for vrOOM, any key for zOOM: "
		read chooseverifier
		echo ""
		echo $line
		case $chooseverifier in
		  v|V)echo " vrOOM Stick Verifier (Verbose) selected..."
			  boomstick=vrOOM;;
			*)echo " zOOM Stick Verifier (Quick) selected..."
			  boomstick=zOOM;;
		esac
		echo $line
		bOOM_Stick $boomstick
	fi
	if [ "$opt" -eq 16 ]; then
		if [ "$bpapplist" ] && [ "`busybox ps | grep Bullet | grep Proof`" ]; then
			echo " You are currently BulletProofing..."
			echo ""
			$sleep
			for bpapp in $bpapplist; do echo "          $bpapp"; done
			echo ""
			echo $line
			echo ""
			$sleep
			echo " Un-BulletProof Previously BulletProofed Apps?"
			echo ""
			$sleep
			echo " You can Un-BulletProof All or Individually ;^]"
			echo ""
			$sleep
			echo " \"One-Shot\" scripts will remain untouched..."
			echo ""
			$sleep
			echo -n " Enter Y for Yes, any key for No: "
			read unbp
			echo ""
			echo $line
			case $unbp in
			  y|Y)while :;do
					echo ""
					$sleep
					echo -n " Un-BulletProof (A)ll (I)ndividually E(X)it? "
					read unbpopt
					echo ""
					echo $line
					case $unbpopt in
					  a|A)if [ "`ls /data/V6_SuperCharger/BulletProof_Apps*.sh`" ]; then rm /data/V6_SuperCharger/BulletProof_Apps*.sh; fi 2>/dev/null
						  if [ "`ls /data/V6_SuperCharger/BulletProof_Apps*`" ]; then rm /data/V6_SuperCharger/BulletProof_Apps*; fi 2>/dev/null
						  if [ "`ls /data/*BulletProof_Apps*`" ]; then rm /data/*BulletProof_Apps*; fi 2>/dev/null
						  if [ "`ls /system/etc/init.d/*BulletProof_Apps*`" ]; then rm /system/etc/init.d/*BulletProof_Apps*; fi 2>/dev/null
						  echo "           Un-BulletProofed ALL Apps!"
						  bpapplist=; opt=15
						  break;;
					  i|I)for unbpapp in $bpapplist; do
							echo ""
							$sleep
							echo " Un-Bulletproof $unbpapp?"
							echo ""
							echo -n " Enter Y for Yes, any key for No: "
							read unbpone
							echo ""
							echo $line
							case $unbpone in
							  y|Y)sed -i '/Begin '$unbpapp'/,/End '$unbpapp'/d' /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh
								  sed -i '/'$unbpapp'/d' /data/V6_SuperCharger/BulletProof_Apps_HitList
								  echo " Un-BulletProofed $unbpapp!"
								  echo $line;;
							    *);;
							esac
						  done
						  bpapplist=`cat /data/V6_SuperCharger/BulletProof_Apps_HitList`
						  echo ""
						  $sleep
						  echo " Here's Your Updated HitList!"
						  echo ""
						  $sleep
						  for bpapp in $bpapplist; do echo "          $bpapp"; done
						  echo ""
						  showedbpapplist=yes; opt=15
						  break;;
					  x|X)echo "       Ok... let's BulletProof something!"
						  break;;
						*)echo "      Invalid entry... Please try again :p"
						  echo $line;;
					esac
				  done;;
				*)echo "                   Cool Beans!";;
			esac
			if [ "$opt" -eq 16 ]; then
				echo $line
				echo ""
				$sleep
			fi
		fi 2>/dev/null
		if [ "$opt" -eq 16 ]; then
			echo " This will attempt to lock an app in memory!"
			echo ""
			$sleep
			echo " To undo, come back here to \"Un-Bulletproof\"!"
			echo ""
			$sleep
			echo " Do you want to view the current process list?"
			echo ""
			$sleep
			echo " You can BulletProof Apps without viewing it!"
			echo ""
			$sleep
			install_bp_service
			Re_Generate_97BulletProof_Apps_sh
			Re_Generate_BulletProof_Apps_Fine_Tuner_sh
			echo -n " Enter N for No, any key for Yes: "
			read bp
			echo ""
			echo $line
			case $bp in
			  n|N)echo " Okay... I hope you know what process to enter!";;
				*)echo " Loading zOOM Stick Verifier (Quick)..."
				  echo $line
				  boomstick=zOOM
				  bOOM_Stick;;
			esac
			while :; do
			  bpps=;bppid=;bpappname=;apprunning=;addedtohitlist=;addedtofinetuner=
			  if [ ! "$bptips" ]; then
				echo " Ideas: BulletProof the Phone, Media or SMS App!"
				echo ""
				$sleep
				if [ "$postics" ] && [ ! "$servicesjarpatched" ]; then
					echo $line
					echo " POST-ICS TIP! Try BulletProofing The Launcher!"
					echo $line
					echo ""
					$sleep
				fi
				bptips=shown
			  fi
			  echo " Enter a unique segment of the process name..."
			  echo ""
			  $sleep
			  echo " Example: \"Opera\" for Opera Browser..."
			  echo ""
			  $sleep
			  echo -n " Or press the Enter key to exit: "
			  read bpps
			  echo ""
			  echo $line
			  if [ ! "$bpps" ]; then
				echo " Okay... See Ya Later! ;^]"
				break
			  else
				if [ ! "`pgrep $bpps`" ]; then
					echo " Can't find $bpps running..."
					echo ""
					$sleep
					echo "             ...so it can't be BulletProofed :("
					echo $line
					echo ""
					$sleep
					echo " Tip: You can manually edit/add apps to..."
					echo ""
					$sleep
					echo " /data/V6_SuperCharger/BulletProof_Apps_HitList!"
					echo ""
					echo $line; bpappname=$bpps
				else bppid=`pgrep $bpps`; apprunning=true
					if [ -f "/proc/$bppid/cmdline" ]; then bpappname=`cat /proc/$bppid/cmdline | sed 's:.*/::'`
					else
						echo ""
						echo " Grrrr... there's more than one match!"
						echo ""
						$sleep
						for bphit in `pgrep $bpps`; do
						  if [ "`cat /proc/$bphit/cmdline`" ]; then
							bpappnametemp=`cat /proc/$bphit/cmdline | sed 's:.*/::'`
							echo -n " Want $bpappnametemp? (Y)es or E(N)ter: "
							read pick
							case $pick in
							  y|Y)bpappname=$bpappnametemp;;
								*);;
							esac
							echo ""
							$sleep
						  fi
						  if [ "$bpappname" ]; then echo $line; break; fi
						done
					fi 2>/dev/null
				fi
				if [ "$bpappname" ]; then bpappname=${bpappname%:*}
					if [ "$apprunning" ]; then
						$sleep
						echo " BulletProofing $bpappname..."
						echo ""
						$sleep
						echo "-17" > /proc/`pgrep $bpps`/oom_adj
						echo "-1000" > /proc/`pgrep $bpps`/oom_score_adj
						renice -10 `pgrep $bpps`
						echo " $bpappname has been BulletProofed!"
						echo ""
						$sleep
						echo -n " $bpappname's oom score is "
						cat /proc/`pgrep $bpps`/oom_score
						echo ""
						$sleep
						echo -n " $bpappname's oom priority is "
						cat /proc/`pgrep $bpps`/oom_adj
						cat /proc/`pgrep $bpps`/oom_score_adj
						echo $line
					fi 2>/dev/null
					if [ "`ls /data/V6_SuperCharger/BulletProof_One_Shots | grep $bpappname`" ]; then
						$sleep
						echo " Existing \"One-Shot\" Script To Be Updated! :o)"
						echo $line
					fi 2>/dev/null
					echo ""
					$sleep
					echo " Gonna save BulletProof \"One-Shot\" Script to..."
					echo ""
					$sleep
					echo " ...data/V6_SuperCharger/BulletProof_One_Shots!"
					echo ""
					$sleep
					if [ ! "$bpwinfo" ]; then
						echo " With Script Manager..."
						echo ""
						$sleep
						echo "               ...make a \"Quick Widget\" for it."
						echo ""
						$sleep
						echo " OR, with Terminal Emulator..."
						echo ""
						$sleep
						echo " ...you can quickly run ALL \"One-Shot\" scripts!"
						echo ""
						$sleep
						echo " Type: \"su\" and enter..."
						echo "        =="
						echo ""
						$sleep
						echo " \"/data/V6*/Bullet*/1Shot*\" and enter!"
						echo "  ========================"
						echo ""
						$sleep
						echo "                  THAT'S IT!"
						echo ""
						$sleep
						echo $line
						echo "    NOTE: DO NOT put it on a timed schedule!"
						echo $line
						echo ""
						$sleep
						echo " Just launch it... wait 30 seconds and..."
						echo ""
						$sleep
						echo "  ...the script will relaunch then kill itself!"
						echo ""
						$sleep
						echo " You can then close Script Manager and..."
						echo ""
						$sleep
						echo "   ...the BulletProof \"One-Shot\" keeps running!"
						echo ""
						$sleep
						bpwinfo=shown
					fi
					Re_Generate_BulletProof_1Shots $bpappname
					echo " Saved 1Shot-$bpappname.sh to..."
					echo ""
					$sleep
					echo " ...data/V6_SuperCharger/BulletProof_One_Shots!"
					echo ""
					if [ ! "$bpainfo" ]; then
						echo $line
						echo ""
						$sleep
						echo " To see if it's working..."
						echo ""
						$sleep
						echo "        ...in Terminal Emulator, you can type..."
						echo ""
						$sleep
						echo " \"pstree | grep 1Shot\" OR \"pstree | grep sleep\""
						echo ""
						$sleep
						echo " OR... get COMPLETE information with..."
						echo ""
						$sleep
						echo "         ...\"cat /proc/*/cmdline | grep 1Shot\"!"
						echo ""
						$sleep
						echo " The output should look like this:"
						echo ""
						$sleep
						echo "    /path/to/1Shot-$bpappname.sh"
						echo "    1Shot-$bpappname_is_In_Effect!"
						echo "    1Shot"
						echo ""
						echo $line
						echo ""
						$sleep
						echo " Easier: Similar results can be had with..."
						echo ""
						$sleep
						echo "                   ...\"busybox ps | grep 1Shot\""
						echo ""
						echo $line
						echo ""
						$sleep
						echo " The *97BulletProof_Apps Boot Script loads..."
						echo ""
						$sleep
						echo " /data/V6_SuperCharger/BulletProof_Apps_HitList."
						echo ""
						$sleep
						echo $line
						echo " Tip: Manually trim or add apps to this list!"
						echo $line
						echo ""
						$sleep
						echo " If it DOESN'T run automatically..."
						echo "       ======="
						echo ""
						$sleep
						echo " Script Manager can be used a couple of ways ;)"
						echo ""
						$sleep
						echo " Use it to make a \"Quick Widget\" for..."
						echo ""
						$sleep
						echo "                 .../data/97BulletProof_Apps.sh!"
						echo ""
						$sleep
						echo " Or make it load 97BulletProof_Apps.sh on boot!"
						echo ""
						$sleep
						echo " OR, for LESS overhead... use Terminal Emulator!"
						echo ""
						$sleep
						echo " Type: \"su\" and enter, \"/data/97*\" and enter!"
						echo "        ==              ========="
						echo ""
						$sleep
						echo "                  THAT'S IT!"
						echo ""
						$sleep
						echo $line
						echo "    NOTE: DO NOT put it on a timed schedule!"
						echo $line
						echo ""
						$sleep
						echo " Just launch it... wait 30 seconds and..."
						echo ""
						$sleep
						echo "  ...the script will relaunch then kill itself!"
						echo ""
						$sleep
						echo " You can then close the app and..."
						echo ""
						$sleep
						echo "  ...the BulletProof Apps script keeps running!"
						echo ""
						echo $line
						echo ""
						$sleep
						echo " Also, in the /data/V6_SuperCharger folder..."
						echo ""
						$sleep
						echo "         ...find BulletProof_Apps_Fine_Tuner.sh"
						echo ""
						$sleep
						echo $line
						echo " Read its notes and \"Fine Tune\" App Priorities!"
						echo $line
						echo ""
						bpainfo=shown
					fi
					if [ "$bpapplist" ] && [ ! "$showedbpapplist" ]; then
						echo $line
						echo ""
						$sleep
						echo " You are already BulletProofing..."
						echo ""
						$sleep
						for bpapp in $bpapplist; do echo "          $bpapp"; done
						echo ""
						showedbpapplist=
					fi
					echo $line
					if [ "`echo $bpapplist | grep $bpappname`" ]; then
						$sleep
						echo " $bpappname's on the Hit List! ;^]"
					else
						echo ""
						$sleep
						echo " Add $bpappname to the HitList?"
						echo ""
						$sleep
						echo -n " Enter Y for Yes, any key for No: "
						read bpabs
						echo ""
						case $bpabs in
						  y|Y)echo $bpappname >> /data/V6_SuperCharger/BulletProof_Apps_HitList
							  bpapplist=`cat /data/V6_SuperCharger/BulletProof_Apps_HitList`
							  addedtohitlist=yes;;
							*)echo $line
							  echo " Okay... maybe next time!";;
						esac
					fi
					if [ "`grep $bpappname /data/V6_SuperCharger/BulletProof_Apps_Fine_Tuner.sh`" ]; then
						echo $line
						echo ""
						$sleep
						echo " Overwrite your prior Fine Tune Setting for it?"
						echo ""
						$sleep
						echo -n " Enter Y for Yes, any key for No: "
						read bpaft
						echo ""
						case $bpaft in
						  y|Y)addedtofinetuner=yes;;
							*);;
						esac
					else addedtofinetuner=yes
					fi
					if [ "$addedtofinetuner" ]; then
						echo $line
						echo ""
						$sleep
						echo " Updating BulletProof_Apps_Fine_Tuner.sh..."
						echo ""
						Re_Generate_BulletProof_Fine_Tunes $bpappname
					fi
					if [ "$addedtohitlist" ]; then
						echo $line
						echo ""
						$sleep
						echo " Here's Your Updated HitList!"
						echo ""
						$sleep
						for bpapp in $bpapplist; do echo "          $bpapp"; done
						echo ""
						echo $line
						echo ""
						$sleep
						echo " BulletProof_Apps_HitList will be loaded via..."
						echo ""
						$sleep
						if [ -d "/system/etc/init.d" ]; then
							if [ "$bpdiff" ]; then free_space_error /system/init.d
							else echo "     ...`ls /system/etc/init.d/*BulletProof*`"
							fi
						else echo "                .../data/97BulletProof_Apps.sh!"
						fi
						echo ""
						if [ ! "$bpsinfo" ]; then
							$sleep
							echo $line
							echo " Is it working? See /data/Ran_BulletProof_Apps!"
							echo $line
							echo ""
							$sleep
							echo " Or... in Terminal Emulator, you can type..."
							echo ""
							$sleep
							echo " \"pstree | grep Bullet\" OR \"pstree | grep sleep\""
							echo ""
							$sleep
							echo " OR... get COMPLETE information with..."
							echo ""
							$sleep
							echo "         ...\"cat /proc/*/cmdline | grep Bullet\"!"
							echo ""
							$sleep
							echo " The output should look like this:"
							echo ""
							$sleep
							echo "      /path/to/*97BulletProof_Apps*"
							echo "      BulletProof_Apps_is_In_Effect!"
							echo "      Bullet"
							echo ""
							echo $line
							echo ""
							$sleep
							echo " Easier: Similar results can be had with..."
							echo ""
							$sleep
							echo "                  ...\"busybox ps | grep Bullet\""
							echo ""
						fi
						if [ "$allrcpaths" ] && [ ! "$bpsinfo" ]; then
							echo $line
							echo ""
							$sleep
							echo " The BulletProof Apps Service should..."
							echo ""
							$sleep
							echo "       ...automatically run this on a schedule!"
							echo ""
							$sleep
							echo " BUT if it doesn't, just be sure that..."
							echo ""
							$sleep
							echo " ...the *97BulletProof_Apps script runs at boot!"
							echo ""
							$sleep
							echo $line
							echo " BulletProof Apps Service was installed to..."
							echo $line
							echo ""
							$sleep
							for bps in $allrcpaths; do
								echo "   ...$bps!"
								if [ ! "$bpservice" ]; then $sleep; fi
							done
							echo ""
							echo $line
							echo ""
							$sleep
							echo " You can stop the service by either..."
							echo ""
							$sleep
							echo "   ...reading comments in 97BulletProof_Apps.sh"
							echo ""
							$sleep
							echo " Or... Run Terminal Emulator..."
							echo ""
							$sleep
							echo "              ...type \"su\" and Enter..."
							echo "                       =="
							echo ""
							$sleep
							echo "       ...type \"stop bullet_service\" and Enter."
							echo "                ==================="
							echo ""
							$sleep
							echo " To restart the BulletProof Apps Service..."
							echo ""
							$sleep
							echo "       ..type \"start bullet_service\" and Enter."
							echo "               ===================="
							echo ""
							echo $line
							echo ""
							$sleep
							echo " \"cat /proc/*/cmdline | grep Bullet\"..."
							echo ""
							$sleep
							echo "     ...OR... \"busybox ps | grep Bullet\"..."
							echo ""
							$sleep
							echo "   ...will also show if the service is running!"
							echo ""
						elif [ ! "$allrcpaths" ] && [ ! "$bpsinfo" ]; then
							echo $line
							$sleep
							echo " BulletProof Apps Service Entries Installed!"
							echo $line
							echo ""
							$sleep
							echo " This won't work on this ROM but... "
							echo ""
							$sleep
							echo "       ...it makes for easy cooking into a ROM!"
							echo ""
							$sleep
							echo " Just read the comments in $initrcpath :)"
							echo ""
						fi
						bpsinfo=shown
					fi
				fi
			  fi
			  echo $line
			  echo ""
			  $sleep
			done
			if [ "$bpapplist" ]; then
				echo $line
				echo ""
				$sleep
				if [ ! "`busybox ps | grep Bullet | grep Proof`" ]; then
					echo $line
					echo " Now launching /data/97BulletProof_Apps.sh..."
					echo ""
					$sleep
					echo "    ... and it will stay in the background! ;^]"
					echo $line
					echo ""
					$sleep
					if [ "`busybox --list | grep nohup`" ]; then (busybox nohup /data/97BulletProof_Apps.sh > /dev/null &)
					elif [ "`busybox --list | grep start-stop-daemon`" ]; then busybox start-stop-daemon -S -b -x /data/97BulletProof_Apps.sh
					else
						echo " Oh wait... you don't have either busybox..."
						echo ""
						$sleep
						echo "     ...\"nohup\" or \"start-stop-daemon\" applets!"
						echo ""
						$sleep
						echo " If I run it for you right now..."
						echo ""
						$sleep
						echo "       ...you can't be returned to this script!"
						echo ""
						$sleep
						echo " So just do it yourself... haha... oh and..."
						echo ""
						$sleep
						echo $line
						echo "   Install a BusyBox build with MORE features!"
						echo $line
						echo ""
						$sleep
					fi
				fi
				echo $line
				echo " ALL BulletProof* files backed up to $storage..."
			fi
		fi
	fi
	if [ "$opt" -eq 17 ]; then
		echo " Your device may get laggy after a day or two.."
		echo ""
		$sleep
		echo "                  ...or merely several hours..."
		echo ""
		$sleep
		echo "                    ...if you haven't rebooted."
		echo ""
		$sleep
		echo " It happens when system caches keep growing..."
		echo ""
		$sleep
		echo "            ...and free RAM keeps shrinking..."
		echo ""
		$sleep
		echo "           ...and apps are starved for memory!"
		echo ""
		echo $line
		echo ""
		$sleep
		echo " This Engine Flush will give you a Quick Boost!"
		echo ""
		$sleep
		echo " The system will drop all file system caches..."
		echo ""
		$sleep
		echo "       ...which means more free RAM and no lag!"
		echo ""
		$sleep
		echo "                        ..so no need to reboot!"
		echo ""
		$sleep
		echo $line
		echo "    NOTE: DO NOT put it on a timed schedule!"
		echo $line
		echo ""
		$sleep
		echo " It's better to just enable..."
		echo ""
		$sleep
		echo $line
		echo "           -=Engine Flush-O-Matic=- !"
		echo $line
		echo ""
		$sleep
		echo "            ...and choose how often it runs ;^]"
		echo ""
		$sleep
		echo " The script will relaunch and kill itself..."
		echo ""
		$sleep
		echo "  ...and the new instance waits to flush again!"
		echo ""
		echo $line
		echo ""
		$sleep
		Re_Generate_FastEngineFlush_sh
		echo " Continue and Flush it all away?"
		echo ""
		$sleep
		echo -n " Enter N for No, any key for Yes: "
		read flush
		echo ""
		echo $line
		case $flush in
		  n|N)echo "      Okay... just stay full of cache then!"
			  echo $line
			  echo ""
			  $sleep
			  flushnotrun=yes;;
			*)echo "    Nice! Gonna dump some cache... flush too!"
			  echo $line
			  sleep 2
			  if [ "`busybox --list | grep nohup`" ] || [ "`busybox --list | grep start-stop-daemon`" ]; then
				sh /data/V6_SuperCharger/!FastEngineFlush.sh
				flushOmaticHours=`awk -F , '{print $11}' /data/V6_SuperCharger/SuperChargerOptions`
			  else
				echo " Oh wait... you don't have either busybox..."
				echo ""
				$sleep
				echo "     ...\"nohup\" or \"start-stop-daemon\" applets!"
				echo ""
				$sleep
				echo " So I ain't gonna run it right now... DIY... :p"
				echo ""
				$sleep
				echo $line
				echo "   Install a BusyBox build with MORE features!"
				echo $line
				echo ""
				$sleep
				flushnotrun=yes
			  fi;;
		esac
		echo " For Fast Flushing..."
		echo ""
		$sleep
		echo " ../data/V6_SuperCharger/!FastEngineFlush.sh..."
		echo ""
		$sleep
		echo "                                ...was created!"
		echo ""
		$sleep
		echo " With Script Manager..."
		echo ""
		$sleep
		echo "       ...you can make a \"Quick Widget\" for it."
		echo ""
		echo $line
		echo ""
		$sleep
		if [ ! "`diff /data/V6_SuperCharger/!FastEngineFlush.sh /system/xbin/flush`" ]; then
			echo " There is another copy in /system/xbin..."
			echo ""
			$sleep
			echo " To use this script with Terminal Emulator..."
			echo ""
			$sleep
			echo " Run Terminal Emulator..."
			echo ""
			$sleep
			echo "           ...type \"su\" and Enter..."
			echo "                    =="
			echo ""
			$sleep
			echo "                   ...type \"flush\" and Enter..."
			echo "                            ====="
			echo ""
			$sleep
			echo "                  THAT'S IT!"
		else free_space_error /system/xbin
		fi
		echo ""
		if [ "$flushnotrun" ]; then
			flushnotrun=
			Configure_Engine_Flush
		fi
	fi
	if [ "$opt" -eq 18 ]; then
		echo " You have many SQLite databases that become..."
		echo ""
		$sleep
		echo " ...fragmented and unoptimized over a few days."
		echo ""
		$sleep
		echo " This tool will optimize them with..."
		echo ""
		$sleep
		echo "                  ...SQLite VACUUM and REINDEX!"
		echo ""
		echo $line
		echo ""
		$sleep
		if [ "`which sqlite3`" ]; then
			Re_Generate_Detailing_sh
			echo " Optimize SQLite databases now?"
			echo ""
			$sleep
			echo -n " Enter N for No, any key for Yes: "
			read detail
			echo ""
			echo $line
			case $detail in
			  n|N)echo "     SQLite Optimization Declined... meh..."
				  echo $line
				  echo ""
				  $sleep
				  detailingnotrun=yes;;
				*)echo "         Time to clean up after you! ;^]"
				  echo $line
				  sleep 2
				  sh /data/V6_SuperCharger/!Detailing.sh
				  detailinterval=`awk -F , '{print $7}' /data/V6_SuperCharger/SuperChargerOptions`;;
			esac
			echo " For Diligent Detailing..."
			echo ""
			$sleep
			echo "      .../data/V6_SuperCharger/!Detailing.sh..."
			echo ""
			$sleep
			echo "                                ...was created!"
			echo ""
			$sleep
			echo " With Script Manager..."
			echo ""
			$sleep
			echo "       ...you can make a \"Quick Widget\" for it."
			echo ""
			echo $line
			echo ""
			$sleep
			if [ ! "`diff /data/V6_SuperCharger/!Detailing.sh /system/xbin/vac`" ]; then
				echo " There is another copy in /system/xbin..."
				echo ""
				$sleep
				echo " To use this script with Terminal Emulator..."
				echo ""
				$sleep
				echo " Run Terminal Emulator..."
				echo ""
				$sleep
				echo "           ...type \"su\" and Enter..."
				echo "                    =="
				echo ""
				$sleep
				echo "                     ...type \"vac\" and Enter..."
				echo "                              ==="
				echo ""
				$sleep
				echo "                  THAT'S IT!"
			else free_space_error /system/xbin
			fi
			echo ""
			if [ -d "/system/etc/init.d" ] && [ "$detailingnotrun" ]; then
				detailingnotrun=
				boot_script_blurb "Detailing"
				Configure_Detailing
			fi
		else
			echo " Doh... sqlite3 binary was NOT found..."
			echo ""
			$sleep
			echo $line
			echo "                      ...No Vacuuming For You!!"
			echo $line
			echo ""
			$sleep
			echo " Load the XDA SuperCharger thread..."
			echo ""
			$sleep
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo $line
			echo ""
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
			echo ""
		fi
	fi
	if [ "$opt" -eq 19 ]; then
		echo " ZipAlign optimizes all your APKs..."
		echo ""
		$sleep
		echo "  ...which means less RAM comsumption..."
		echo ""
		$sleep
		echo "                   ...better battery life..."
		echo ""
		$sleep
		echo "                       ...and a faster device!!"
		echo ""
		$sleep
		echo $line
		echo " If you get Force Closes, run Fix Emissions too!"
		echo $line
		echo ""
		$sleep
		if [ "`which zipalign`" ]; then
			Re_Generate_WheelAlignment_sh
			echo " ZipAlign data and system APKs now?"
			echo ""
			$sleep
			echo -n " Enter N for No, any key for Yes: "
			read align
			echo ""
			echo $line
			case $align in
			  n|N)echo "  No Wheel Alignment? Watch out for teh curbs!"
				  echo $line
				  echo ""
				  $sleep
				  zepalignnotrun=yes;;
				*)echo "        Gonna \"ZepAlign\" in no time! ;^]"
				  echo $line
				  sleep 2
				  sh /data/V6_SuperCharger/!WheelAlignment.sh
				  autofixemissions=yes
				  zepalign=`awk -F , '{print $8}' /data/V6_SuperCharger/SuperChargerOptions`
				  fixalign=`awk -F , '{print $10}' /data/V6_SuperCharger/SuperChargerOptions`;;
			esac
			echo " For Zippy... uhh... \"ZepAligning\"..."
			echo ""
			$sleep
			echo " .../data/V6_SuperCharger/!WheelAlignment.sh..."
			echo ""
			$sleep
			echo "                                ...was created!"
			echo ""
			$sleep
			echo " With Script Manager..."
			echo ""
			$sleep
			echo "       ...you can make a \"Quick Widget\" for it."
			echo ""
			echo $line
			echo ""
			$sleep
			if [ ! "`diff /data/V6_SuperCharger/!WheelAlignment.sh /system/xbin/zepalign`" ]; then
				echo " There is another copy in /system/xbin..."
				echo ""
				$sleep
				echo " To use this script with Terminal Emulator..."
				echo ""
				$sleep
				echo " Run Terminal Emulator..."
				echo ""
				$sleep
				echo "           ...type \"su\" and Enter..."
				echo "                    =="
				echo ""
				$sleep
				echo "                ...type \"zepalign\" and Enter..."
				echo "                         ========"
				echo ""
				$sleep
				echo "                  THAT'S IT!"
			else free_space_error /system/xbin
			fi
			echo ""
			if [ -d "/system/etc/init.d" ] && [ "$zepalignnotrun" ]; then
				zepalignnotrun=
				boot_script_blurb "Wheel Alignment"
				Configure_WheelAlignment
			fi
			if [ "$autofixemissions" ]; then
				echo $line
				echo ""
				$sleep
				echo " Run the Fix Permissions option?"
				echo ""
				$sleep
				echo -n " Enter N for No, any key for Yes: "
				read emissions
				echo ""
				echo $line
				case $emissions in
				  n|N)autofixemissions=
					  mount -o remount,rw / 2>/dev/null
					  mount -o remount,rw rootfs 2>/dev/null
					  busybox mount -o remount,rw / 2>/dev/null
					  busybox mount -o remount,rw rootfs 2>/dev/null
					  mount -o remount,rw /system 2>/dev/null
					  busybox mount -o remount,rw /system 2>/dev/null
					  busybox mount -o remount,rw $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
					  echo "       Okay... but run it if you get FCs!!";;
					*)opt=20
					  echo ""
					  echo "              ====================="
					  echo "             //// FIX EMISSIONS \\\\\\\\"
					  echo $line
					  echo ""
					  $sleep;;
				esac
			fi
		else
			echo " Doh... zipalign binary was NOT found..."
			echo ""
			$sleep
			echo $line
			echo "                    ...No ZepAligning For You!!"
			echo $line
			echo ""
			$sleep
			echo " Load the XDA SuperCharger thread..."
			echo ""
			$sleep
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo $line
			echo ""
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
			echo ""
		fi
	fi
	if [ "$opt" -eq 20 ]; then
		echo " This should fix app Force Closes!"
		echo ""
		$sleep
		echo " FCs usually happen due to permission errors..."
		echo ""
		$sleep
		echo " This tool will ensure that ALL apps..."
		echo ""
		$sleep
		echo "               ...have the correct permissions!"
		echo ""
		echo $line
		echo ""
		$sleep
		Re_Generate_FixEmissions_sh
		echo " Fix Permissions now?"
		echo ""
		$sleep
		echo -n " Enter N for No, any key for Yes: "
		if [ "$autofixemissions" ]; then emissions=Y; autofixemissions=; echo $emissions
		else read emissions
		fi
		echo ""
		echo $line
		case $emissions in
		  n|N)echo "     Fix Emissions Declined... What The FC!?"
			  echo $line
			  echo ""
			  $sleep
			  fixemissionsnotrun=yes;;
			*)echo "      Cool... This won't take too long ;^]"
			  echo $line
			  sleep 2
			  sh /data/V6_SuperCharger/!FixEmissions.sh
			  fixemissions=`awk -F , '{print $9}' /data/V6_SuperCharger/SuperChargerOptions`
			  fixalign=`awk -F , '{print $10}' /data/V6_SuperCharger/SuperChargerOptions`;;
		esac
		echo " For a Fast FCing Fix..."
		echo ""
		$sleep
		echo "   .../data/V6_SuperCharger/!FixEmissions.sh..."
		echo ""
		$sleep
		echo "                                ...was created!"
		echo ""
		$sleep
		echo " With Script Manager..."
		echo ""
		$sleep
		echo "       ...you can make a \"Quick Widget\" for it."
		echo ""
		echo $line
		echo ""
		$sleep
		if [ ! "`diff /data/V6_SuperCharger/!FixEmissions.sh /system/xbin/fixfc`" ]; then
			echo " There is another copy in /system/xbin..."
			echo ""
			$sleep
			echo " To use this script with Terminal Emulator..."
			echo ""
			$sleep
			echo " Run Terminal Emulator..."
			echo ""
			$sleep
			echo "           ...type \"su\" and Enter..."
			echo "                    =="
			echo ""
			$sleep
			echo "                   ...type \"fixfc\" and Enter..."
			echo "                            ====="
			echo ""
			$sleep
			echo "                  THAT'S IT!"
		else free_space_error /system/xbin
		fi
		echo ""
		if [ -d "/system/etc/init.d" ] && [ "$fixemissionsnotrun" ]; then
			fixemissionsnotrun=
			boot_script_blurb "Fix Emissions"
			Configure_FixEmissions
		fi
	fi
	if [ "$opt" -eq 21 ]; then
		echo " This combines two scripts into one..."
		echo ""
		$sleep
		echo "          ...Wheel Alignment AND Fix Emissions!"
		echo ""
		$sleep
		echo " ZipAlign optimizes all your APKs..."
		echo ""
		$sleep
		echo "  ...which means less RAM comsumption..."
		echo ""
		$sleep
		echo "   ...better battery life and a faster device!!"
		echo ""
		$sleep
		echo " But sometimes... Force Closes can result..."
		echo ""
		$sleep
		echo "  ...so this Fixes Permissions of each app..."
		echo ""
		$sleep
		echo "           ...immediately after zipaligning it!"
		echo ""
		$sleep
		echo " It's REALLY FAST and..."
		echo ""
		$sleep
		echo $line
		echo "      It's the ONLY script of it's kind ;^]"
		echo $line
		echo ""
		$sleep
		if [ "`which zipalign`" ]; then
			Re_Generate_FixAlignment_sh
			echo " FixAlign data and system APKs now?"
			echo ""
			$sleep
			echo -n " Enter N for No, any key for Yes: "
			read align
			echo ""
			echo $line
			case $align in
			  n|N)echo "  No Fix Alignment? Try and drive straight!"
				  echo $line
				  echo ""
				  $sleep
				  fixalignnotrun=;;
				*)echo "        Gonna \"FixAlign\" in no time! ;^]"
				  echo $line
				  sleep 2
				  sh /data/V6_SuperCharger/!FixAlignment.sh
				  zepalign=`awk -F , '{print $8}' /data/V6_SuperCharger/SuperChargerOptions`
				  fixemissions=`awk -F , '{print $9}' /data/V6_SuperCharger/SuperChargerOptions`
				  fixalign=`awk -F , '{print $10}' /data/V6_SuperCharger/SuperChargerOptions`;;
			esac
			echo " For Fast 'n Furious FixAligning..."
			echo ""
			$sleep
			echo "   .../data/V6_SuperCharger/!FixAlignment.sh..."
			echo ""
			$sleep
			echo "                                ...was created!"
			echo ""
			$sleep
			echo " With Script Manager..."
			echo ""
			$sleep
			echo "       ...you can make a \"Quick Widget\" for it."
			echo ""
			echo $line
			echo ""
			$sleep
			if [ ! "`diff /data/V6_SuperCharger/!FixAlignment.sh /system/xbin/fixalign`" ]; then
				echo " There is another copy in /system/xbin..."
				echo ""
				$sleep
				echo " To use this script with Terminal Emulator..."
				echo ""
				$sleep
				echo " Run Terminal Emulator..."
				echo ""
				$sleep
				echo "           ...type \"su\" and Enter..."
				echo "                    =="
				echo ""
				$sleep
				echo "                ...type \"fixalign\" and Enter..."
				echo "                         ========"
				echo ""
				$sleep
				echo "                  THAT'S IT!"
			else free_space_error /system/xbin
			fi
			echo ""
			if [ -d "/system/etc/init.d" ] && [ "$fixalignnotrun" ]; then
				fixalignnotrun=
				boot_script_blurb "Fix Alignment"
				Configure_FixAlignment
			fi
		else
			echo " Doh... zipalign binary was NOT found..."
			echo ""
			$sleep
			echo $line
			echo "                    ...No FixAligning For You!!"
			echo $line
			echo ""
			$sleep
			echo " Load the XDA SuperCharger thread..."
			echo ""
			$sleep
			echo "   ...and install The SuperCharger Starter Kit!"
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo $line
			echo ""
			su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/qM6yR"
			echo ""
		fi
	fi
	if [ "$opt" -eq 22 ]; then
		echo " This is EXPERIMENTAL..."
		echo ""
		$sleep
		echo "              ...it may improve multitasking..."
		echo ""
		$sleep
		echo "    ...it may make your device even snappier..."
		echo ""
		$sleep
		echo "                 ...it may really do nothing..."
		echo ""
		$sleep
		echo "     But some people swear that it's great!"
		echo ""
		$sleep
		echo " Values are added at the bottom of build.prop!"
		echo ""
		$sleep
		echo $line
		echo " Warning: 3G, WiFi or BlueTooth issues reported!"
		while :; do
			echo $line
			echo ""
			$sleep
			echo -n " Enter (N)ullify, (U)n-Nullify, E(X)it: "
			read nln
			echo ""
			echo $line
			case $nln in
			  n|N)nitro=1;break;;
			  u|U)nitro=2;break;;
			  x|X)nitro=3;break;;
				*)echo "      Invalid entry... Please try again :p";;
			esac
		done
		if [ "$nitro" -ne 3 ]; then
			if [ "$nitro" -eq 1 ]; then
				if [ -f "/system/build.prop.unsuper" ]; then echo " Leaving ORIGINAL build.prop backup intact..."
				else
					echo " Backing up ORIGINAL build.prop..."
					echo ""
					$sleep
					cp -r /system/build.prop /system/build.prop.unsuper
					if [ "`diff /system/build.prop /system/build.prop.unsuper`" ]; then echo " ERROR BACKING UP /system/build.prop!"
					else
						sed -i '/SuperCharger Installation/d' /system/build.prop.unsuper
						echo "              ...as /system/build.prop.unsuper!"
					fi
				fi
				echo $line
				cp -fr /system/build.prop $storage/V6_SuperCharger/build.prop.unsuper
			fi
			echo ""
			$sleep
			if [ -f "/system/bin/build.prop" ] && [ ! -f "/system/bin/build.prop.unsuper" ]; then cp -r /system/bin/build.prop /system/bin/build.prop.unsuper; fi
			sed -i '/Nullifier/,/Nullified/d' /system/build.prop
			if [ "$nitro" -eq 1 ]; then
				cat >> /system/build.prop <<EOF
# Nitro Lag Nullifier created by -=zeppelinrox=-
#
# DO NOT DELETE COMMENTS. DELETING COMMENTS WILL BREAK UNINSTALL ROUTINE!
#
ENFORCE_PROCESS_LIMIT=false
MAX_SERVICE_INACTIVITY=
MIN_HIDDEN_APPS=
MAX_HIDDEN_APPS=
CONTENT_APP_IDLE_OFFSET=
EMPTY_APP_IDLE_OFFSET=
MAX_ACTIVITIES=
ACTIVITY_INACTIVE_RESET_TIME=
# End of Nullified Entries.
EOF
				echo " Nitro Lag Nullifier installed..."
			else echo " Uninstalled Nitro Lag Nullifier..."
			fi
			echo ""
			$sleep
			if [ -f "/system/bin/build.prop" ]; then cp -fr /system/build.prop /system/bin; fi
			echo "                            ...Reboot required!"
		fi
		echo ""
	fi
	if [ "$opt" -eq 23 ]; then
		echo " This will copy V6 SuperCharger to /system/xbin"
		echo ""
		$sleep
		echo " To use this script with Terminal Emulator..."
		echo ""
		$sleep
		echo " Run Terminal Emulator..."
		echo ""
		$sleep
		echo "           ...type \"su\" and Enter..."
		echo "                    =="
		echo ""
		$sleep
		echo "                      ...type \"v6\" and Enter..."
		echo "                               =="
		echo ""
		$sleep
		echo "                  THAT'S IT!"
		echo ""
		$sleep
		echo " Note that su is short for SuperUser..."
		echo ""
		echo $line
		echo ""
		$sleep
		echo " So... continue installation?"
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read v6xbin
		echo ""
		case $v6xbin in
		  y|Y)if [ "$0" = "v6" ] || [ "$0" = "/system/xbin/v6" ]; then echo $line; echo " You are already running it from system/xbin!"
			  else
				dd if=$0 of=/system/xbin/v6 2>/dev/null
				cp -fr $0 $storage/V6_SuperCharger/v6
				if [ ! "`diff $0 /system/xbin/v6`" ]; then
					chown 0.0 /system/xbin/v6; chmod 777 /system/xbin/v6
					echo $line
					echo "  FABULOUS! Installation Was A Great Success!"
				else
					free_space_error /system/xbin
					echo ""
				fi
			  fi;;
			*)echo $line; echo " Well... forget it then...";;
		esac
	fi
	if [ "$opt" -eq 25 ] || [ "$UnIScream" ]; then
		if [ "$servicesjarpatched" ]; then
			if [ ! "$UnIScream" ]; then
				echo "  Hey... services.jar is ALREADY SuperCharged!"
				echo ""
				echo $line
			fi
			if [ -f "$storage/V6_SuperCharger/services.jar.unsuper" ]; then
				echo ""
				$sleep
				echo " A backup services.jar was found..."
				echo ""
				$sleep
				echo " ie.$storage/V6_SuperCharger/services.jar.unsuper"
				echo ""
				$sleep
				echo " Do you want to restore it (with permissions)?"
				echo "             (services.odex too, if it exists)"
				echo ""
				$sleep
				if [ "`busybox stat -t /system/bin/adb | awk '{print $14}'`" -gt "`busybox stat -t $storage/V6_SuperCharger/services.jar.unsuper | awk '{print $14}'`" ]; then
					adbnewer="yes"
					echo $line
					echo " WARNING: This backup was created BEFORE..."
					echo "               ...this ROM's installation date!"
					echo $line
					echo ""
					$sleep
					echo " It MIGHT be from a different ROM! Go ahead?"
					echo ""
					$sleep
				else adbnewer=
				fi
				echo -n " Enter Y for Yes, any key for No: "
				if [ "$UnIScream" ] && [ "$adbnewer" ]; then restorejar=Y; echo $restorejar
				else read restorejar
				fi
				echo ""
				case $restorejar in
				  y|Y)cp -fr $storage/V6_SuperCharger/services.jar.unsuper /system/framework/services.jar
					  cp -fr $storage/V6_SuperCharger/services.odex.unsuper /system/framework/services.odex 2>/dev/null
					  if [ ! "`diff $storage/V6_SuperCharger/services.jar.unsuper /system/framework/services.jar`" ]; then
						echo $line
						echo "       Successfully restored services.jar!"
						echo $line
						echo ""
						$sleep
						if [ "$UnIScream" ]; then
							echo " Out Of Memory (OOM) Groupings UnFixed..."
							echo ""
							$sleep
							echo "                ...OOM Priorities UnFixed..."
							echo ""
							$sleep
							echo "                  Weak Ass Launcher Restored :("
							echo ""
							$sleep
							echo $line
							echo "           UnSuperCharging Complete!"
							echo $line
							echo ""
							$sleep
						fi
					  else
						free_space_error /system/framework
						echo ""
						$sleep
					  fi
					  echo $line;;
					*);;
				esac
			fi
			if [ "$usedwebapp" ] || [ "$adbnewer" ]; then echo ""; fi
		fi
		if [ ! "$servicesjarpatched" ] || [ "$usedwebapp" ] || [ "$adbnewer" ]; then
			if [ "$newsupercharger" ] && [ "$ran" -eq 1 ]; then
				echo -n " Press The Enter Key... "
				read enter
				echo ""
				echo "          ============================"
				echo "         //// JELLY ISCREAM PARLOR \\\\\\\\"
				echo $line
				echo ""
				$sleep
			fi
			if [ "$odex" ] || [ "$jb" -eq 1 ]; then
				if [ "$odex" ]; then
					echo "             You have an ODEXED ROM!"
					echo "             ======================="
					echo ""
					$sleep
				fi
				echo " The ICS Priority Charger WebApp WON'T work..."
				echo ""
				$sleep
				if [ "$jb" -eq 1 ]; then
					echo "                     ...on Jelly Bean as of yet!"
					echo ""
					$sleep
				fi
				if [ "$odex" ]; then
					echo " This tool CAN install a pre-patched..."
					echo ""
					$sleep
					echo "   ...services.jar and services.odex..."
				else
					echo " This tool CAN install..."
					echo ""
					$sleep
					echo "   ...a pre-patched services.jar..."
				fi
				echo ""
				$sleep
				echo "     ...from $storage to /system/framework..."
			else
				echo " This will download a patched services.jar..."
				echo ""
				$sleep
				echo "              ...OR install one from $storage..."
				echo ""
				$sleep
				echo "        ...to /system/framework/services.jar..."
			fi
			echo ""
			$sleep
			echo "        ...AND apply permissions and ownership!"
			echo ""
			$sleep
			echo " If you had ALREADY copied to framework..."
			echo ""
			$sleep
			echo "     ...permissions will be applied ANYWAY! ;^]"
			echo ""
			echo $line
			echo ""
			$sleep
			echo " BUT the BEST and EASIEST method is to use..."
			echo ""
			$sleep
			echo "     ...the -=Ultimatic Jar Patcher Tools=- ;^]"
			echo ""
			$sleep
			echo " Choosing \"Ultimatic\" will open the XDA thread!"
			echo ""
			$sleep
			echo $line
			if [ "$odex" ]; then echo ""; echo "  ODEX ROMS can only do Manual Method for now!"
			elif [ "$jb" -eq 1 ]; then echo ""; echo "  Jelly Bean can only do Manual Method for now!"
			else
				if [ ! "$usedwebapp" ]; then
					echo "   Note: Downloaded services.jar will be WEAK!"
					echo $line
					echo ""
					$sleep
				fi
				echo " To get 100% SuperCharged,choose Manual Method!"
				echo ""
				$sleep
				echo " So hey, you have 2 choices!"
			fi
			echo ""
			$sleep
			echo "   Automatic Transmission: Automagical Install"
			$sleep
			echo "                       OR"
			$sleep
			echo "  Manual Method: See tools in thread to assist!"
			echo ""
			if [ ! "$odex" ] && [ "$jb" -eq 0 ]; then
				$sleep
				echo $line
				echo " WARNING: Priority Charger WebApp is OUT OF DATE"
				echo $line
				echo ""
				$sleep
				echo " It's missing the latest enhancements..."
				echo ""
				$sleep
				echo "           ...and the NEWEST MultiTasking Mods!"
				echo ""
				$sleep
				echo " The Launcher will still be WEAK-ish and..."
				echo ""
				$sleep
				echo " ...your SuperCharger Level will be reduced 25%!"
				echo ""
				$sleep
				echo $line
				echo " MANUAL METHOD RECOMMENDED FOR 100% SUPERCHARGE!"
			fi
			while :; do
				echo $line
				echo ""
				$sleep
				echo -n " Enter (A)utomatic or (M)anual or E(X)it: "
				if [ "$odex" ] || [ "$jb" -eq 1 ] || [ "$usedwebapp" ]; then transmit=M; echo $transmit
				else read transmit
				fi
				echo ""
				echo $line
				case $transmit in
				  a|A)autotransmit=yes
					  echo "        Automatic Transmission Selected!";;
				  m|M)manualtransmit=yes
					  echo "             Manual Method Selected!";;
				  x|X)break;;
					*)echo "      Invalid entry... Please try again :p";;
				esac
				while [ "$autotransmit" ] || [ "$manualtransmit" ] && [ ! "$newservicesjar" ]; do
					echo $line
					echo ""
					$sleep
					echo -n " Enter (U)ltimatic, (I)nstall, E(X)it: "
					if [ "$autotransmit" ]; then servicechoice=D; echo $servicechoice
					elif [ "$autoinstalljar" ]; then servicechoice=I; echo $servicechoice
					else read servicechoice
					fi
					echo ""
					echo $line
					case $servicechoice in
				  d|D|u|U)echo ""
						  $sleep
						  if [ "$autotransmit" ]; then
							if [ "`busybox ping -c 1 108.163.181.154 | grep statistics`" ]; then
								echo "           Sweet... Device is Online!"
								echo ""
								$sleep
								echo $line
								if [ ! -f "/system/xbin/curl" ]; then
									echo " Installing download tool..."
									echo $line
									echo ""
									$sleep
									wget -O /system/xbin/curl http://108.163.181.154/curl
									chown 0.0 /system/xbin/curl; chmod 777 /system/xbin/curl
								fi
								echo ""
								MD5=`md5sum /system/framework/services.jar | awk '{print $1}'`
								Patch_Exists=`curl http://android.mimic.ca/check_md5/$MD5`
								echo ""
								$sleep
								if [ "$Patch_Exists" = "True" ]; then curl -D $TMP_DIR/tmp_header http://android.mimic.ca/super_download/$MD5 -o $TMP_DIR/tmp_output
								else curl -D $TMP_DIR/tmp_header -F services_file=@/system/framework/services.jar -F is_super=True http://android.mimic.ca/ -o $TMP_DIR/tmp_output
								fi
								echo ""
								$sleep
								HEADER_MD5=`grep md5sum $TMP_DIR/tmp_header | awk '/md5sum/{sub(/.*md5sum=/, ""); print $1}'`
								HEADER_MD5=`echo $HEADER_MD5 | tr -d '\n\r'`
								if [ ! "$HEADER_MD5" ]; then
									# Header does not contain md5hash, checking file output!
									# We replace the HEADER_MD5 output with the webpage output (tmp_output) since
									# The header's output no longer matters...
									HEADER_MD5=`cat $TMP_DIR/tmp_output`
								fi
								rm $TMP_DIR/tmp_header
								echo $line
								case $HEADER_MD5 in
								  $a|$b)# This is a legit reason, not a bad download.
										echo "     ERROR: services.jar cannot be patched!"
										echo $line
										echo ""
										$sleep
										echo -n " Reason: It's "
										if [ "$HEADER_MD5" = "$b" ]; then echo -n "a "; fi
										echo "$HEADER_MD5 :p";;
									  *)echo " Patched services.jar MD5hash should be:"
										echo "         [$HEADER_MD5]"
										echo $line
										$sleep
										FILE_MD5=`md5sum $TMP_DIR/tmp_output | awk '{print $1}'`
										echo " Downloaded services.jar MD5hash is:"
										echo "         [$FILE_MD5]"
										echo $line
										echo ""
										$sleep
										echo $line
										if [ "X$HEADER_MD5" = "X$FILE_MD5" ]; then autoinstalljar=yes
											echo "   Clean Download Success! MD5sums Match! ;^]"
											echo $line
											echo ""
											$sleep
											mv $TMP_DIR/tmp_output $storage/V6_SuperCharger/services_supercharged.jar
											echo "      Now off to Auto Install services.jar!"
										else
											echo "          ERROR: MD5sums DO NOT Match!"
											echo $line
											echo ""
											$sleep
											echo " There is a possible download issue... :("
										fi;;
								esac
							else
								echo ""
								echo $line
								echo ""
								$sleep
								echo "       FAIL... Cannot Connect to Server :("
							fi
							echo ""
						  else
							echo " Going to load the..."
							echo ""
							$sleep
							echo "  ...Ultimatic Jar Patcher Tools thread at XDA!"
							echo ""
							$sleep
							echo " These tools (including MultiTasking Mods)..."
							echo ""
							$sleep
							echo "            ...can patch and install it all..."
							echo ""
							$sleep
							echo "                    ...from start to finish :o)"
							echo ""
							if [ ! "$odex" ]; then
								$sleep
								echo " But if you run it and do \"Offline\" Mode..."
								echo ""
								$sleep
								echo "             ...you can patch any services.jar!"
								echo ""
								$sleep
								echo " If you do that... you can come back..."
								echo ""
								$sleep
								echo $line
								echo "       ...and select \"(I)nstall\" to install it!"
							fi
						  fi
						  echo $line
						  echo ""
						  $sleep
						  echo -n " Press The Enter Key... "
						  read enter
						  echo ""
						  if [ ! "$autotransmit" ]; then
							echo $line
							su -c "LD_LIBRARY_PATH=/vendor/lib:/system/lib am start http://goo.gl/IvGL1"
						  fi
						  manualtransmit=yes;autotransmit=;;
					  i|I)echo ""
						  if [ "$autoinstalljar" ]; then foundjars="$storage/V6_SuperCharger/services_supercharged.jar"
						  else
							  echo " Wait... looking for *services*.jar on $storage!"
							  echo ""
							  for searchjar in `busybox find $storage/ -iname "*services*.jar"`; do
								jarname="$jarname "$searchjar
								if [ "`echo $jarname | grep .jar`" ]; then
									jarnospace=`echo $jarname | sed 's/ /_/g'`
									if [ "`echo $jarname | grep " "`" ]; then
										echo $line
										echo ""
										echo " Renaming:" /${jarname#*/}
										$sleep
										echo " New Name:" /${jarnospace#*/}
										echo ""
										$sleep
										mv "`echo $jarname | sed 's/^ //'`" $jarnospace
									fi
									jarname=
									foundjars="$foundjars $jarnospace"
								fi
							  done
							  echo $line
						  fi
						  if [ "$foundjars" ]; then
							if [ "$autoinstalljar" ]; then
								$sleep
								echo " Automatic Transmission Almost Complete..."
								echo ""
							else
								echo " Cool... look what I found... ;^]"
								echo $line
								echo ""
								$sleep
								busybox ls -lc $foundjars | awk '{print $6,$7,$8,$9}' | sed 's:'$storage'::' | while read listjars; do echo " $listjars"; done
								echo ""
								$sleep
								echo $line
								echo " Newest files are listed first!"
							fi
							for jar in `busybox ls -lc $foundjars | awk '{print $9}'`; do
								echo $line
								echo ""
								$sleep
								echo " Install ${jar##*mnt}?"
								echo ""
								$sleep
								if [ "`busybox stat -t /system/bin/adb | awk '{print $14}'`" -gt "`busybox stat -t $jar | awk '{print $14}'`" ]; then
									echo $line
									echo " WARNING: This file was created BEFORE..."
									echo "               ...this ROM's installation date!"
									echo $line
									echo ""
									$sleep
									echo " It MIGHT be from a different ROM! Go ahead?"
									echo ""
									$sleep
								fi
								echo -n " Enter Y for Yes, any key for No: "
								if [ "$autoinstalljar" ]; then installjar=Y; echo $installjar
								else read installjar
								fi
								echo ""
								case $installjar in
								  y|Y)if [ "`busybox stat -t /system/bin/adb | awk '{print $14}'`" -gt "`busybox stat -t $storage/V6_SuperCharger/services.jar.unsuper | awk '{print $14}'`" ]; then
										  echo " Backing up services.jar to $storage..."
										  echo ""
										  $sleep
										  cp -fr /system/framework/services.jar $storage/V6_SuperCharger/services.jar.unsuper
										  cp -fr /system/framework/services.odex $storage/V6_SuperCharger/services.odex.unsuper 2>/dev/null
									  fi 2>/dev/null
									  echo "   ...now installing SuperCharged services.jar!"
									  echo ""
									  $sleep
									  cp -fr $jar /system/framework/services.jar
									  cp -fr ${jar%.jar}.odex /system/framework/services.odex 2>/dev/null
									  if [ ! "`diff $jar /system/framework/services.jar`" ]; then opt=32; newservicesjar=woohoo; servicesjarinstalled=yes
										echo $line
										echo "             I Scream SUPERCHARGED!"
										echo $line
										echo ""
										$sleep
										echo $line
									  else
										free_space_error /system/framework
										echo ""
										echo $line
										echo ""
										$sleep
										echo " Restoring original services.jar!"
										echo ""
										cp -fr $storage/V6_SuperCharger/services.jar.unsuper /system/framework/services.jar
										cp -fr $storage/V6_SuperCharger/services.odex.unsuper /system/framework/services.odex 2>/dev/null
									  fi
									  break;;
									*);;
								esac
							done
						  else echo "    No *services*.jar were found on $storage!"
						  fi
						  foundjars=;autoinstalljar=;;
					  x|X)break;;
						*)echo "      Invalid entry... Please try again :p";;
					esac
				done
				if [ "$autotransmit" ] || [ "$manualtransmit" ]; then break; fi
			done
		fi
		chown 0.0 /system/framework/services.*; chmod 644 /system/framework/services.*
		echo " Applied permissions to /framework/services.jar!"
		if [ "$newservicesjar" ] || [ "$UnIScream" ]; then
			echo $line
			echo ""
			$sleep
			echo " Reboot Required: Boot will take a LONG Time!"
			echo ""
			$sleep
		fi
		showparlor=;showedparlor=yes;manualtransmit=;UnIScream=
	fi
	if [ "$opt" -eq 32 ]; then
		if [ "$newsupercharger" ] && [ "$ran" -eq 1 ] || [ "$newservicesjar" ]; then
			echo " Select YES in the next step to..."
			echo ""
			$sleep
			echo $line
			echo "                       ...SuperClean & ReStart!"
			echo $line
			echo ""
			$sleep
			echo -n " Press The Enter Key... "
			read enter
			echo ""
			echo "              ==================="
			echo "             //// SUPERCLEAN! \\\\\\\\"
			echo $line
			echo ""
			$sleep
			newsupercharger=; newservicesjar=
		fi
		echo " This tool will wipe your dalvik-cache..."
		echo ""
		$sleep
		echo $line
		echo "     Bootloops are LESS likely to happen :^)"
		echo $line
		echo ""
		$sleep
		echo " Initial boot will take a long time but..."
		echo ""
		$sleep
		echo "    ...your system will be clean and efficient!"
		echo ""
		$sleep
		echo $line
		echo " If the screen freezes during boot..."
		echo ""
		$sleep
		echo "         ...pull the battery and retry..."
		echo ""
		$sleep
		echo "    ...sometimes it takes 3 or more tries..."
		echo ""
		$sleep
		echo "           ...as everything gets re-configured!"
		echo $line
		echo ""
		$sleep
		Re_Generate_SuperClean_sh
		echo " For Speedy SuperCleaning..."
		echo ""
		$sleep
		echo "     .../data/V6_SuperCharger/!SuperClean.sh..."
		echo ""
		$sleep
		echo "                                ...was created!"
		echo ""
		$sleep
		echo " With Script Manager..."
		echo ""
		$sleep
		echo "       ...you can make a \"Quick Widget\" for it."
		echo ""
		echo $line
		echo ""
		$sleep
		if [ ! "`diff /data/V6_SuperCharger/!SuperClean.sh /system/xbin/sclean`" ]; then
			echo " There is another copy in /system/xbin..."
			echo ""
			$sleep
			echo " To use this script with Terminal Emulator..."
			echo ""
			$sleep
			echo " Run Terminal Emulator..."
			echo ""
			$sleep
			echo "           ...type \"su\" and Enter..."
			echo "                    =="
			echo ""
			$sleep
			echo "                  ...type \"sclean\" and Enter..."
			echo "                           ======"
			echo ""
			$sleep
			echo "                  THAT'S IT!"
		else free_space_error /system/xbin
		fi
		echo ""
		echo $line
		echo ""
		$sleep
		echo " Do you want to SuperClean & ReStart now?"
		echo ""
		$sleep
		echo -n " Enter Y for Yes, any key for No: "
		read superclean
		echo ""
		case $superclean in
			y|Y)if [ "$madesqlitefolder" -eq 1 ]; then rm -r /sqlite_stmt_journals; fi 2>/dev/null
				for cachedir in /*/dalvik-*; do rm -r $cachedir/* 2>/dev/null; done
				echo " All cleaned up and ready to..."
				echo ""
				$sleep
				echo $line
				echo "                    !!POOF!!"
				echo $line
				echo ""
				sleep 2
				busybox sync
				if [ -f "/proc/sys/kernel/sysrq" ]; then
					echo 1 > /proc/sys/kernel/sysrq 2>/dev/null
					echo b > /proc/sysrq-trigger 2>/dev/null
				fi
				echo "  If it don't go poofie, just reboot manually!"
				echo ""
				echo $line
				reboot; busybox reboot;;
			  *)echo $line
				echo " Okay... maybe next time!";;
		esac
	fi
 fi
 if [ "$opt" -lt 33 ]; then
	echo $line
	echo ""
	$sleep
	echo " To Return to Driver's Console..."
	echo ""
	$sleep
	echo -n "              ...Press the Return or Any Key: "
	read enter
 fi
 if [ "$opt" -le 14 ] || [ "$opt" -ge 23 ] && [ "$opt" -le 25 ] || [ "$opt" -eq 33 ]; then
	echo ""
	echo $line
	echo ""
	$sleep
	if [ "$opt" -eq 1 ]; then echo " SuperCharger and Launcher Status..."
	elif [ "$opt" -eq 14 ]; then echo " UnSuperCharging..."
	else
		echo " SuperCharging, OOM Grouping & Priority Fixes.."
		echo ""
		$sleep
		echo "    ...BulletProof, Die-Hard & HTK Launchers..."
	fi
	echo ""
	$sleep
	echo "     ...by -=zeppelinrox=- @ XDA & Droid Forums"
	sleep 2
 fi
 if [ "$opt" -eq 33 ]; then
	echo ""
	echo "                                    Buh Bye ;^]"
	echo ""
	echo $line
	echo ""
	$sleep
	exit 0
 fi
 if [ "$madesqlitefolder" -eq 1 ]; then rm -r /sqlite_stmt_journals; fi 2>/dev/null
 mount -o remount,ro / 2>/dev/null
 mount -o remount,ro rootfs 2>/dev/null
 busybox mount -o remount,ro / 2>/dev/null
 busybox mount -o remount,ro rootfs 2>/dev/null
 mount -o remount,ro /system 2>/dev/null
 busybox mount -o remount,ro /system 2>/dev/null
 busybox mount -o remount,ro $(busybox mount | awk '$3=="/system"{print $1,$3}') 2>/dev/null
done
